*=============================================================================
* TSBrw.ch  Version 7.0 15/Jul/2004
* Trimmed version of TSBrowse.ch to avoid preprocessor table overflow with Clipper 5.3
* Predefined Constants
*=============================================================================

// Horizontal alignment

#ifndef DT_LEFT
   #define DT_LEFT              0
   #define DT_CENTER            1
   #define DT_RIGHT             2
#endif
#define DT_VERT              3  // vertical text (only for headers)
#define DT_CENTERED          DT_CENTER

// Vertical alignment
#define DT_TOP               0
#define DT_BOTTOM            2

// Cursor movement after editing
#define DT_DONT_MOVE         0
#define DT_MOVE_RIGHT        1
#define DT_MOVE_DOWN         2
#define DT_MOVE_LEFT         3
#define DT_MOVE_UP           4
#define DT_MOVE_NEXT         5

// Report method() language text selection
#define DT_DATE              1
#define DT_PAGE              2
#define DT_TIME              3
#define DT_PREVIEW           4

#define DT_SPANISH           1
#define DT_ENGLISH           2

#define __FLAT__

// Flags for phantom column: with or without a grid
#define PHCOL_GRID          -1
#define PHCOL_NOGRID        -2

// Default text sizes
#define BRSE_CHARPIX_H      14
#define BRSE_CHARPIX_W       8

// Line Styles
#define LINES_NONE           0
#define LINES_ALL            1
#define LINES_VERT           2
#define LINES_HORZ           3
#define LINES_3D             4
#define LINES_DOTTED         5

// aColors items number
#define CLR_TEXT             1   // text
#define CLR_PANE             2   // back
#define CLR_HEADF            3   // header text
#define CLR_HEADB            4   // header back
#define CLR_FOCUSF           5   // focused text
#define CLR_FOCUSB           6   // focused back
#define CLR_EDITF            7   // editing text
#define CLR_EDITB            8   // editing back
#define CLR_FOOTF            9   // footer text
#define CLR_FOOTB           10   // footer back
#define CLR_SELEF           11   // focused inactive (or selected) text
#define CLR_SELEB           12   // focused inactive (or selected) back
#define CLR_ORDF            13   // order column text
#define CLR_ORDB            14   // order column back
#define CLR_LINE            15   // grid lines

// System Colors
#define COLOR_ACTIVECAPTION          2
#define COLOR_INACTIVECAPTION        3
#define COLOR_WINDOW                 5
#define COLOR_WINDOWTEXT             8
#define COLOR_CAPTIONTEXT            9
#define COLOR_HIGHLIGHT             13
#define COLOR_HIGHLIGHTTEXT         14
#define COLOR_BTNFACE               15
#define COLOR_BTNSHADOW             16
#define COLOR_BTNTEXT               18
#define COLOR_INACTCAPTEXT          19
#define COLOR_BTNHIGHLIGHT          20

// Styles
#define DS_3DLOOK                    4
#define GWL_STYLE                  -16

#define CS_DBLCLKS                   8
#define TRUE                        .T.
#define FALSE                       .F.
