.autodepend
.swap
.suffixes: .prg .hrb

# Flags for modules to include: YES | NO (must be UPPERCASE)##################

LNK_DBFNTX    = YES
LNK_DBFCDX    = YES
LNK_DBFDBT    = YES
LNK_ADS       = NO
LNK_DEBUG     = NO
LNK_ADVANTAGE = NO
LNK_ODBC      = NO
LNK_HBOLE     = YES
LNK_BTNGET    = YES
LNK_LISTBOX   = NO   ## FW25 bug fix with EraseBkGnd METHOD
MAP_FILE      = NO
DELETE_OBJ    = YES  ## delete compiled .obj files at end
DELETE_RES    = YES  ## delete compiled .res files at end
DELETE_HRB    = YES  ## delete compiled .hrb files at end

# Application directories & filenames ########################################

APP_PRG_DIR      = ..\Source\Classes
APP_OBJ_DIR      = .
APP_EXE_DIR      = .
APP_RES_DIR      = .

APP_EXE  = $(APP_EXE_DIR)\$(APP_NAME).exe
APP_RC   = $(APP_RES_DIR)\$(APP_NAME).rc
APP_RES  = $(APP_RES_DIR)\$(APP_NAME).res
APP_MAP  = $(APP_RES_DIR)\$(APP_NAME).map

# Paths for dependent files ##################################################

.path.prg = ..\SOURCE\CLASSES
.path.hrb = .
.path.obj = .

# Other Paths ################################################################

FW_PATH = c:\FWH
HB_PATH = c:\Harbour
BC_PATH = c:\bcc55

# Application PRG files (your PRG files go here) #############################

APP_PRG_LIST = TSBROWSE.PRG TSCOLUMN.PRG TSBTNGET.PRG

!if $(LNK_LISTBOX) == YES
   APP_PRG_LIST = $(APP_PRG_LIST) ListBox.prg
!endif

# Contruction of the rest dependency lists ###################################

APP_PRGS = $(APP_PRG_LIST)
APP_HRBS = $(APP_PRG_LIST:.prg=.c)
APP_OBJS = $(APP_PRG_LIST:.c=.obj)

# Harbour & Borland flags ####################################################

HB_DEF = -D__HARBOUR__
!if $(LNK_HBOLE) == YES
   HB_DEF = $(HB_DEF);__OLE__
!endif
!if $(LNK_ADVANTAGE) == YES
   HB_DEF = $(HB_DEF);__ADS__
!endif

HB_FLAGS      = $(HB_DEF) -i$(FW_PATH)\Include;$(HB_PATH)\Include -n -m -gc0
BC_COMP_FLAGS = -c -O2 -I$(HB_PATH)\Include;$(BC_PATH)\Include
BC_LINK_FLAGS = -Gn -E99 -aa -Tpe -s -I$(APP_OBJ_DIR)

!if $(MAP_FILE) != YES
   BC_LINK_FLAGS = $(BC_LINK_FLAGS) -x
!endif

# Dependencies ###############################################################

all: $(APP_PRGS) $(APP_HRBS) $(APP_OBJS)


# Implicit Rules #############################################################

.prg.hrb:
   $(HB_PATH)\Bin\Harbour.exe $(HB_FLAGS) $** -o$@  >> Comp.log

.hrb.obj:
   $(BC_PATH)\Bin\bcc32.exe $(BC_COMP_FLAGS) -o$@ $**  >> Comp.log

# Explicit Rules #############################################################


$(APP_EXE) :: $(APP_OBJS)
