.autodepend
.swap
.suffixes: .prg .hrb

# Flags for modules to include: YES | NO (must be UPPERCASE)##################

LNK_DBFNTX    = YES
LNK_DBFCDX    = YES
LNK_DBFDBT    = YES
LNK_DEBUG     = NO
LNK_ADVANTAGE = NO
LNK_ODBC      = NO
LNK_HBOLE     = YES
LNK_BTNGET    = YES
LNK_FWCALEN   = YES
LNK_SDEBUG    = YES  ## TSBrowse debug.prg
MAP_FILE      = NO
DELETE_OBJ    = YES  ## delete compiled .obj files at end
DELETE_RES    = YES  ## delete compiled .res files at end
DELETE_HRB    = YES  ## delete compiled .hrb files at end

# Application directories & filenames ########################################

APP_PRG_DIR      = .
APP_OBJ_DIR      = .
APP_EXE_DIR      = .
APP_RES_DIR      = .

APP_EXE  = $(APP_EXE_DIR)\$(APP_NAME).exe
APP_RC   = $(APP_RES_DIR)\$(APP_NAME).rc
APP_RES  = $(APP_RES_DIR)\$(APP_NAME).res
APP_MAP  = $(APP_RES_DIR)\$(APP_NAME).map

# Paths for dependent files ##################################################

.path.prg = $(APP_PRG_DIR);..\Source\Function
.path.hrb = $(APP_OBJ_DIR)
.path.obj = $(APP_OBJ_DIR)

# Other Paths ################################################################

FW_PATH = c:\FWH
HB_PATH = c:\xHarbour
BC_PATH = c:\bcc55

# Application PRG files (your PRG files go here) #############################

APP_PRG_LIST = $(APP_NAME).prg
!if $(LNK_FWCALEN) == YES
   APP_PRG_LIST = $(APP_PRG_LIST) FwCalen.prg
!endif
!if $(LNK_SDEBUG) == YES
   APP_PRG_LIST = $(APP_PRG_LIST) Debug.prg
!endif

# Contruction of the rest dependency lists ###################################

APP_PRGS = $(APP_PRG_LIST)
APP_HRBS = $(APP_PRG_LIST:.prg=.hrb)
APP_OBJS = $(APP_PRG_LIST:.prg=.obj)

# Harbour & Borland flags ####################################################

HB_FLAGS       = -i$(FW_PATH)\Include;$(HB_PATH)\Include -n -m -gc0
BC_COMP_FLAGS  = -c -O2 -I$(HB_PATH)\Include;$(BC_PATH)\Include
BC_LINK_FLAGS  = -Gn -E99 -aa -Tpe -s -I$(APP_OBJ_DIR)

!if $(LNK_HBOLE) == YES
   HB_FLAGS      = -D__HBOLE__ -i$(FW_PATH)\Include;$(HB_PATH)\Include -n -m -gc0
   BC_COMP_FLAGS = -c -O2 -D__HBOLE__ -I$(HB_PATH)\Include;$(BC_PATH)\Include
!endif

!if $(MAP_FILE) != YES
   BC_LINK_FLAGS = $(BC_LINK_FLAGS) -x
!endif

# Dependencies ###############################################################

all: $(APP_OBJS) $(APP_HRBS) $(APP_EXE)

!if $(RES_FILE) == YES
all: $(APP_RES)
!endif

# Implicit Rules #############################################################

.prg.hrb:
   $(HB_PATH)\Bin\Harbour.exe $(HB_FLAGS) $** -o$@  >> Comp.log

.hrb.obj:
   $(BC_PATH)\Bin\bcc32.exe $(BC_COMP_FLAGS) -o$@ $**  >> Comp.log

# Explicit Rules #############################################################

!if $(RES_FILE) == YES
$(APP_RES) : $(APP_RC)
   $(BC_PATH)\Bin\brc32.exe -D__32_BITS__ -r $**

$(APP_EXE) :: $(APP_RES)
   @if exist $(APP_EXE) del $(APP_EXE) > nul
!endif

$(APP_EXE) :: $(APP_OBJS)
   @echo $(BC_PATH)\Lib\c0w32.obj + > make.tmp
   @echo $(**), + >> make.tmp
   @echo $(APP_EXE), + >> make.tmp
   @echo $(APP_MAP), + >> make.tmp
   @echo ..\Lib\SBrowseX.lib + >> make.tmp
   @echo $(FW_PATH)\Lib\FiveHx.lib + >> make.tmp
   @echo $(FW_PATH)\Lib\FiveHc.lib + >> make.tmp
   @echo $(HB_PATH)\Lib\rtl.lib + >> make.tmp
   @echo $(HB_PATH)\Lib\vm.lib + >> make.tmp
   @echo $(HB_PATH)\Lib\gtwin.lib + >> make.tmp
   @echo $(HB_PATH)\Lib\lang.lib + >> make.tmp
   @echo $(HB_PATH)\Lib\macro.lib + >> make.tmp
   @echo $(HB_PATH)\Lib\rdd.lib + >> make.tmp
!if $(LNK_DBFNTX) == YES
   @echo $(HB_PATH)\Lib\dbfntx.lib + >> make.tmp
!endif
!if $(LNK_DBFCDX) == YES
   @echo $(HB_PATH)\Lib\dbfcdx.lib + >> make.tmp
   @echo $(HB_PATH)\Lib\dbffpt.lib + >> make.tmp
!endif
!if $(LNK_DBFDBT) == YES
   @echo $(HB_PATH)\Lib\dbfdbt.lib + >> make.tmp
!endif
!if $(LNK_DEBUG) == YES
   @echo $(HB_PATH)\Lib\debug.lib + >> make.tmp
!endif
   @echo $(HB_PATH)\Lib\common.lib + >> make.tmp
   @echo $(HB_PATH)\Lib\pp.lib + >> make.tmp
!if $(LNK_ADVANTAGE) == YES
   @echo $(HB_PATH)\Lib\rddads.lib + >> make.tmp
   @echo $(FW_PATH)\Lib\ace32.lib + >> make.tmp
!endif
!if $(LNK_ODBC) == YES
   @echo $(BC_PATH)\Lib\Psdk\odbc32.lib + >> make.tmp
!endif
!if $(LNK_BTNGET) == YES
   @echo ..\Lib\BtnGet.lib + >> make.tmp
!endif
   @echo $(BC_PATH)\Lib\cw32.lib + >> make.tmp
   @echo $(BC_PATH)\Lib\import32.lib, + >> make.tmp
!if $(RES_FILE) == YES
   @echo $(APP_RES) >> make.tmp
!endif
   $(BC_PATH)\Bin\ilink32.exe $(BC_LINK_FLAGS) @make.tmp > Link.log
   @del $(APP_EXE_DIR)\$(APP_NAME).tds
   @del make.tmp
!if $(DELETE_OBJ) == YES
   del $(APP_OBJ_DIR)\*.obj
!endif
!if $(DELETE_HRB) == YES
   del $(APP_OBJ_DIR)\*.hrb
!endif
!if $(RES_FILE) == YES
!if $(DELETE_RES) == YES
   del $(APP_RES_DIR)\*.res
!endif
!endif
