#define _VIDEO_CH
#define _OBJECTS_CH
#define _DDE_CH

#include "FiveWin.ch"
#include "\TSBrowse\Include\TSBrowse.ch"

#define CLR_PINK   nRGB( 255, 128, 128)
#define CLR_NBLUE  nRGB( 128, 128, 192)

//--------------------------------------------------------------------------//

Function Main()

   Local oBrw, oDlg, oBmp[ 3 ], aColor[ 2 ], ;
         ahBmp:= { LoadBitmap( GetResources(), "Level1" ), ;
                   LoadBitmap( GetResources(), "Level3" ), ;
                   LoadBitmap( GetResources(), "Level2" ) }

   // to see how SetDeleteMode() works:
   Set( _SET_DELETED, .T. )

   USE SBALIGN ALIAS TEST SHARED NEW

   DEFINE DIALOG oDlg RESOURCE "DIALOGO" ;
          TITLE OemToansi( "TSBrowse: Alignment in Code Blocks and " + ;
                           "Alignable BitMaps" )

   REDEFINE BROWSE oBrw CELLED ;
            ID 101 OF oDlg ;
            COLORS CLR_BLACK, CLR_PINK

   // see new behaviour of VALID clause
   ADD COLUMN TO oBrw ;
         HEADER "Name" ;
         DATA FieldWBlock( "Field1", Select() ) ;
			PICTURE "@!" ;
         VALID {|uVar| ! Empty( uVar ) };
         3DLOOK FALSE SIZE 200 ;
         EDITABLE MOVE DT_MOVE_RIGHT

   ADD COLUMN TO oBrw ;
         HEADER "Result" ;
         DATA { | uVar | If( uVar == Nil, Test->Field2, ;
                If( ! Empty( uVar ), Test->Field2 := uVar, ;
                If( oBrw:lAppendMode, ( oBrw:skip( - 1 ),oBrw:Refresh(.T.) ), Nil ) ) ) };
         COLORS CLR_BLACK,CLR_PINK ;
         ALIGN DT_CENTER ;
         SIZE 70 PIXELS ;
         3DLOOK TRUE ;
         EDITABLE MOVE DT_MOVE_NEXT

   // alignment in code blocks
   ADD COLUMN TO oBrw ;
         HEADER "A  B  C " ;              
         DATA { || If( Test->Field2 < 6, ahBmp[ 3 ], ;
                   If( Test->Field2 < 9, ahBmp[ 2 ], ;
                       ahBmp[ 1 ] ) ) } ;
         3DLOOK TRUE ;
         ALIGN { || nMakeLong( DT_CENTER, If( Test->Field2 < 6, DT_RIGHT, ;
                    If( Test->Field2 < 9, DT_CENTER, DT_LEFT ) ) ) }, ;
               DT_LEFT, DT_LEFT ;
         COLOR CLR_BLACK, CLR_NBLUE ;
         SIZE 45 BITMAP


   // delete rows by pressing Del key
   oBrw:SetDeleteMode( .T., .T. )  // ( lOnOff, lConfirm, bDelete)

   // activating Auto Append feature
   oBrw:SetAppendMode( .T. )

   // setting cursor colors (5,6) to hole browse
   oBrw:SetColor( { 5, 6 }, { CLR_WHITE, CLR_BLACK } )

   // setting cursor colors to specific columns (3)
   oBrw:SetColor( { 5, 6 }, { CLR_BLACK, CLR_WHITE }, 3 )

   // increasing cells height
   oBrw:nHeightCell += 4

   // we don't want horizontal scroll bar
   oBrw:lNoHScroll := .T.

   ACTIVATE DIALOG oDlg CENTERED


   DbCloseArea()
   AEval( ahBmp,{ | x | DeleteObject( x ) } )

Return Nil

//--------------------------------------------------------------------------//

Function StrCharCount( cStr, cChr )

   Local nAt, ;
         nCount := 0

   While ! Empty( cStr ) .and. ( nAt := At( cChr, cStr ) ) > 0
      nCount ++
      cStr := SubStr( cStr, nAt + 1 )
   EndDo

Return nCount
