#include "FiveWin.ch"

#ifdef __XPP__
   #define COMBO_BASE      320
#else
   #define COMBO_BASE  WM_USER
#endif

#define CB_SETEDITSEL    ( COMBO_BASE +  2 )
#define CB_GETCURSEL     ( COMBO_BASE +  7 )
#define CB_SETCURSEL     ( COMBO_BASE + 14 )
#define CB_SHOWDROPDOWN  ( COMBO_BASE + 15 )
#define CB_ERR              -1

* ============================================================================
* CLASS TSCombo  Version 8.0 Feb/01/2008
* ============================================================================

CLASS TSCombo FROM TComboBox

   DATA   lAppend

   METHOD GetDlgCode( nLastKey )
   METHOD HandleEvent( nMsg, nWParam, nLParam )
   METHOD KeyDown( nKey, nFlags )
   METHOD KeyChar( nKey, nFlags )
   METHOD LButtonDown( nRow, nCol )
   METHOD LostFocus()

ENDCLASS

* ============================================================================
* METHOD TSCombo:GetDlgCode() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GetDlgCode( nLastKey, nFlags ) CLASS TSCombo

   ::nLastKey := nLastKey

Return DLGC_WANTALLKEYS

* ============================================================================
* METHOD TSCombo:HandleEvent() Version 8.0 Feb/01/2008
* ============================================================================

METHOD HandleEvent( nMsg, nWParam, nLParam ) CLASS TSCombo
// just used for some testings

   /*fDebug( "nMsg="+AllTrim(cValTochar(nMsg))+" nWParam="+;
           AllTrim(cValTochar(nWParam))+;
           " nLoWord="+AllTrim(cValTochar(nLoWord(nLParam)))+;
           " nHiWord="+AllTrim(cValTochar(nHiWord(nLParam)))+CRLF+;
           " ProcName="+ProcName(2)+Space(1)+LTrim(Str(ProcLine(2)))+space(1)+;
           ProcName(3)+Space(1)+LTrim(Str(Procline(3))) ) */

Return Super:HandleEvent( nMsg, nWParam, nLParam )

* ============================================================================
* METHOD TSCombo:KeyDown() Version 8.0 Feb/01/2008
* ============================================================================

METHOD KeyDown( nKey, nFlags ) CLASS TSCombo

   ::nLastKey := nKey

   If nKey == VK_TAB .or. nKey == VK_RETURN .or. nKey == VK_ESCAPE
      ::bLostFocus := Nil
      Eval( ::bKeyDown, nKey, nFlags, .T. )
      Return 0
   Endif

Return Nil

* ============================================================================
* METHOD TSCombo:LostFocus() Version 8.0 Feb/01/2008
* ============================================================================

METHOD LostFocus() CLASS TSCombo

   Local nAt

   Default ::lAppend := .F.

   If ::nLastKey == Nil .and. ::lAppend
      ::SetFocus()
      ::nLastKey := 0
      Return 0
   EndIf

   nAt := ::SendMsg( CB_GETCURSEL )

   If nAt != CB_ERR
      ::nAt = nAt + 1
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, nAt + 1 )
      Else
         Eval( ::bSetGet, ::aItems[ nAt + 1 ] )
      Endif
   Else
      Eval( ::bSetGet, GetWindowText( ::hWnd ) )
   Endif

   ::lFocused := .F.

   If ::bLostFocus != Nil
      Eval( ::bLostFocus, ::nLastKey )
   EndIf

Return 0

* ============================================================================
* METHOD TSCombo:KeyChar() Version 8.0 Feb/01/2008
* ============================================================================

METHOD KeyChar( nKey, nFlags ) CLASS TSCombo

   Do Case
      Case nKey == VK_TAB
         Return 0
            // We don't want API default behavior

      Case nKey == VK_ESCAPE
         Return 0

      Case nKey == VK_RETURN
         Return 0

      Otherwise
         Return Super:Keychar( nKey, nFlags )
   Endcase

Return 0

* ============================================================================
* METHOD TSCombo:LButtonDown() Version 8.0 Feb/01/2008
* ============================================================================

METHOD LButtonDown( nRow, nCol ) CLASS TSCombo

   Local nShow := 1

   If ::nLastKey != Nil .and. ::nLastKey == 9999
      nShow := 0
      ::nLastKey := 0
   Else
      ::nLastKey := 9999
   EndIf

   ::PostMsg( CB_SHOWDROPDOWN, nShow, 0 )

Return 0
