#include "FiveWin.ch"

#ifdef __CLIPPER__
   #define EM_GETSEL       (WM_USER+0)
#else
   #define EM_GETSEL               176
#endif

* ============================================================================
* CLASS TSFGet  Version 8.0 Feb/1/2008
* ============================================================================

CLASS TSFGet FROM TFGet

   METHOD New( nRow, nCol, bSetGet, oWnd, nWidth, nHeight, oFont,;
               lHScroll, nClrFore, nClrBack, oCursor, lPixel, cMsg, lUpdate,;
               bWhen, lCenter, lRight, lReadOnly, bValid, bChanged,;
               lDesign, lNoBorder, lNoVScroll ) CONSTRUCTOR

   Method KeyChar( nKey, nFlags )
   Method KeyDown( nKey, nFlags )
   Method LostFocus( hCtlFocus )

ENDCLASS

* ============================================================================
* METHOD TSFGet:New() Version 8.0 Feb/1/2008
* ============================================================================

METHOD New( nRow, nCol, bSetGet, oWnd, nWidth, nHeight, oFont, lHScroll,;
            nClrFore, nClrBack, oCursor, lPixel, cMsg, lUpdate,;
            bWhen, lCenter, lRight, lReadOnly, bValid, bChanged,;
            lDesign, lNoBorder, lNoVScroll ) CLASS TSFGet

   Default lCenter := .F., ;  // just to fix a bug TFGet class
           lRight  := .F.

Return Super:New( nRow, nCol, bSetGet, oWnd, nWidth, nHeight, oFont, ;
                  lHScroll, nClrFore, nClrBack, oCursor, lPixel, cMsg, ;
                  lUpdate, bWhen, lCenter, lRight, lReadOnly, bValid, ;
                  bChanged, lDesign, lNoBorder, lNoVScroll )

* ============================================================================
* METHOD TSFGet:KeyChar() Version 8.0 Feb/1/2008
* ============================================================================

METHOD KeyChar( nKey, nFlags ) CLASS TSFGet

   If GetKeyState( VK_CONTROL )
      nKey := If( Upper( Chr( nKey ) ) == "W" .or. nKey == VK_RETURN, VK_TAB, nKey )
   EndIf

   If nKey == VK_TAB .or. nKey == VK_ESCAPE
      Return 0
   Endif

RETURN Super:KeyChar( nKey, nFlags )

* ============================================================================
* METHOD TSFGet:KeyDown() Version 8.0 Feb/1/2008
* ============================================================================

METHOD KeyDown( nKey, nFlags ) CLASS TSFGet

   If GetKeyState( VK_CONTROL )
      nKey := If( Upper( Chr( nKey ) ) == "W" .or. nKey == VK_RETURN, VK_TAB, nKey )
   EndIf

   ::nLastKey := ::oWnd:nLastKey := nKey

   If nKey == VK_TAB .or. nKey == VK_ESCAPE

      Eval( ::bSetGet, ::GetTextFormat() )
      ::bLostFocus := Nil
      Eval( ::bKeyDown, nKey, nFlags, .T. )

      Return 0

   Endif

RETURN Super:KeyDown( nKey, nFlags )

* ============================================================================
* METHOD TSFGet:LostFocus() Version 8.0 Feb/1/2008
* ============================================================================

METHOD LostFocus( hCtlFocus ) CLASS TSFGet

   ::lFocused := .F.

   if ::bSetGet != nil
      Eval( ::bSetGet, ::GetTextFormat() )
   endif

   ::HideCaret()
   ::VisibleBlock( ! ::lFocusBlock )

   If ::bLostFocus != Nil
      Eval( ::bLostFocus, ::nLastKey, hCtlFocus )
   EndIf

Return 0
