#define _FOLDER_CH
#define _TREE_CH
#define _VIDEO_CH
#define _DDE_CH

#include "FiveWin.ch"
#include "TSBrowse.ch"

#define VK_CTRL_W          23
#define WM_NCLBUTTONDOWN  161  // 0x00A1
#define WM_NCHITTEST      132  // 0x0084
#define HTERROR           (-2)
#define WM_SETCURSOR       32  // 0x0020

Static nsLastKey

* ============================================================================
* CLASS TSGet  Version 8.0 Feb/01/2008
* ============================================================================

CLASS TSGet FROM TGet

   DATA aFill
   DATA lRightLeftExit AS LOGICAL INIT .F.
   DATA lFixCaret, lChanged, lFilled

   METHOD FillText( nKey )
   METHOD GetDlgCode( nLastKey )
   METHOD GotFocus( hCtlLost )
   METHOD _GotFocus( hCtlLost )
   METHOD KeyDown(nKey,nFlags)
   METHOD KeyChar(nKey,nFlags)
   METHOD HandleEvent( nMsg, nWParam, nLParam )
   METHOD LostFocus( hCtlFocus )
   METHOD lValid()
   METHOD RButtonDown( nRow, nCol, nFlags )
   METHOD Spinner( bUp, bDown, bMin, bMax )

ENDCLASS

* ============================================================================
* METHOD TSGet:GetDlgCode() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GetDlgCode( nLastKey, nFlags ) CLASS TSGet

   ::oWnd:nLastkey := nLastKey

Return DLGC_WANTALLKEYS

* ============================================================================
* METHOD TSGet:GotFocus() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GotFocus( hCtlLost ) CLASS TSGet

   If ! ::lDrag
      ::oGet:SetFocus()
      ::DispText()
      ::oGet:Pos = ::nPos
      ::SetPos( ::nPos )
      CallWindowProc( ::nOldProc, ::hWnd, WM_SETFOCUS )

      If ::lFixCaret != Nil .and. ::lFixCaret
         DestroyCaret()
         CreateCaret( ::hWnd, 0, 6, ::nGetChrHeight() )
         ShowCaret( ::hWnd )
      Else
         DestroyCaret()
         If Set( _SET_INSERT )
            CreateCaret( ::hWnd, 0, 6, ::nGetChrHeight() )
         Else
            CreateCaret( ::hWnd, 0, 2, ::nGetChrHeight() )
         EndIf
         ShowCaret( ::hWnd )
      Endif

   Else
      HideCaret( ::hWnd )
   Endif

   ::nLastKey := nsLastKey := 0
   ::_GotFocus()

Return 0

* ============================================================================
* METHOD TSGet:_GotFocus() Version 8.0 Feb/01/2008
* ============================================================================

METHOD _GotFocus( hCtlLost ) CLASS TSGet

   ::lFocused       = .T.
   ::oWnd:nResult   = Self
   ::oWnd:oCtlFocus = Self
   ::oWnd:hCtlFocus = ::hWnd
   ::SetMsg( ::cMsg )

   If ::lDrag
      ::ShowDots()
   Endif

   If ::bGotFocus != Nil
      Return Eval( ::bGotFocus, Self, hCtlLost )
   Endif

Return 0

* ============================================================================
* METHOD TSGet:KeyDown() Version 8.0 Feb/01/2008
* ============================================================================

METHOD KeyDown( nKey, nFlags ) CLASS TSGet

   ::nLastKey := nsLastKey := ::oWnd:nLastKey := nKey

   IF nKey == VK_DOWN .or. nKey == VK_UP .or. nKey == VK_RETURN .or. ;
      nKey == VK_ESCAPE .or. nKey == VK_TAB .or. ;
      ( ::lRightLeftExit .and. ( nKey = VK_LEFT .or. nKey = VK_RIGHT ) )

      If ::lValid()
         ::bLostFocus := Nil
         Eval( ::bKeyDown, nKey, nFlags, .T. )
      Else
         nsLastKey := 0
         ::DispText()
         ::oGet:Pos := ::nPos
      Endif

      Return 0

   Elseif nKey == VK_INSERT .and. ! GetKeyState( VK_SHIFT ) .and. ;
          ! GetKeyState( VK_CONTROL )

      Set( _SET_INSERT, ! Set( _SET_INSERT ) )

      If ::lFixCaret == Nil .or. ! ::lFixCaret
         DestroyCaret()
         If Set( _SET_INSERT )
            CreateCaret( ::hWnd, 0, 6, ::nGetChrHeight() )
         Else
            CreateCaret( ::hWnd, 0, 2, ::nGetChrHeight() )
         EndIf
         ShowCaret( ::hWnd )
      EndIf

      Return 0

   Endif

RETURN Super:KeyDown( nKey, nFlags )

* ============================================================================
* METHOD TSGet:KeyChar() Version 8.0 Feb/01/2008
* ============================================================================

METHOD KeyChar( nKey, nFlags ) CLASS TSGet

   Local nHi, nLo, lAccept, nDefButton, ;
         bKeyAction := SetKey( nKey )

   ::nLastKey := nsLastKey := nKey

   If bKeyAction != Nil .and. lAnd( nFlags, 16777216 ) // function Key
      Eval( bKeyAction, ProcName( 4 ), ProcLine( 4 ), Self )
      Return 0         // Already processed, API do nothing
   EndIf

   If ::lReadOnly
      If nKey == VK_ESCAPE
         ::oWnd:End()
      EndIf
      Return 0
   EndIf

   Do Case
      Case nKey == VK_BACK       // Already processed at KeyDown
         Return 0

      Case nKey == VK_TAB .and. GetKeyState( VK_SHIFT )
         Return 0

      Case nKey == VK_TAB .or. nKey == VK_RETURN
         Return 0

      Case nKey >= 32 .and. nKey < 256
         ::GetSelPos( @nLo, @nHi )
         // Delete selection

         If nHi != nLo
            ::GetDelSel( nLo, nHi )
            ::EditUpdate()
         EndIf

         If ::oGet:Type == "N" .and. ;
            ( Chr( nKey ) == "." .or. Chr( nKey ) == "," )
            ::oGet:ToDecPos()
         Else

            If ::bChange != Nil
               lAccept = Eval( ::bChange, nKey, nFlags, Self )

               If ValType( lAccept ) == "L" .and. ! lAccept
                  Return 0
               EndIf

            EndIf

            If ::aFill != Nil
               ::FillText( nKey )
            EndIf

            If Set( _SET_INSERT )             // many thanks to HMP
               ::oGet:Insert( Chr( nKey ) )
            Else
               ::oGet:Overstrike( Chr(nKey) )
            End

         EndIf

         If ::oGet:Rejected()
            MessageBeep( -1 )
         Else
            ::EditUpdate()
         EndIf

   EndCase

Return 0

* ============================================================================
* METHOD TSGet:LostFocus() Version 8.0 Feb/01/2008
* ============================================================================

METHOD LostFocus( hCtlFocus ) CLASS TSGet

   Default ::lChanged := .F., ;
           ::lFilled  := .F.

   ::lFocused := .F.
   ::SetMsg( ::cMsg )

   if ! Empty( ::cPicture ) .and. ::oGet:type == "N"
      ::oGet:Assign()
      ::oGet:Picture := ::cPicture
      ::oGet:UpdateBuffer()
   endif

   #ifdef __CLIPPER__
      ::oGet:SetFocus()   // because Clipper set buffer to nil
   #endif

   If ! ::oGet:BadDate .and. ! ::lReadOnly .and. ;
      ( ::oGet:changed .or. ::oGet:unTransform() <> ::oGet:original )
      ::oGet:Assign()     // for adjust numbers
      ::oGet:UpdateBuffer()
      ::lChanged := .T.
   EndIf

   ::DispText()

   If ! ::oGet:BadDate
      ::oGet:KillFocus()
   Else
      ::oGet:Pos = 1
   EndIf

   If ::bLostFocus != Nil
      Eval( ::bLostFocus, nsLastKey, hCtlFocus )
   EndIf

Return 0

* ============================================================================
* METHOD TSGet:lValid() Version 8.0 Feb/01/2008
* ============================================================================

METHOD lValid() CLASS TSGet

   Local lRet := .T.

   ::oGet:Assign()
   ::oGet:UpdateBuffer()

   If ::oGet:BadDate
      Tone( 100, 3 )
      Return .F.
   Else
      If ValType( ::bValid ) == "B"
         lRet := Eval( ::bValid, ::Value()  )
      EndIf
   EndIf

Return lRet

* ============================================================================
* METHOD TSGet:RButtonDown() Version 8.0 Feb/01/2008
* ============================================================================

METHOD RButtonDown( nRow, nCol, nFlags ) CLASS TSGet

   Local oMenu, oClp, nLo, nHi, aMsg

   #ifdef _SPANISH_
      aMsg := { "&Deshacer","Cor&tar","&Copiar","&Pegar","&Borrar", ;
                "&Seleccionar Todo" }
   #else
      aMsg := { "&Undo","Cu&t","&Copy","&Paste","&Delete", ;
                "Select &All" }
   #EndIf

   ::GetSelPos( @nLo, @nHi )

   If GetFocus() != ::hWnd
      ::SetFocus()
      SysRefresh()
      If GetFocus() != ::hWnd
         Return Nil
      EndIf
   EndIf

   DEFINE CLIPBOARD oClp OF Self FORMAT TEXT

   If ::bRClicked != Nil
      Return Eval( ::bRClicked, nRow, nCol, nFlags )
   EndIf

   MENU oMenu POPUP

      If ::lReadOnly .or. ::GetText() == cValToChar( ::oGet:Original )
         MENUITEM aMsg[ 1 ] ACTION ::UnDo() disabled
      Else
         MENUITEM aMsg[ 1 ] ACTION ::UnDo()
      EndIf

      SEPARATOR

      If ::lReadOnly .or. nLo == nHi
         MENUITEM aMsg[ 2 ]  ACTION ::Cut() disabled
      Else
         MENUITEM aMsg[ 2 ]  ACTION ::Cut()
      EndIf

      If nLo != nHi
         MENUITEM aMsg[ 3 ] ACTION ::Copy()
      Else
         MENUITEM aMsg[ 3 ] ACTION ::Copy() disabled
      EndIf

      If ! Empty( oClp:GetText() ) .and. !::lReadOnly
         MENUITEM aMsg[ 4 ] ACTION ::Paste()
      Else
         MENUITEM aMsg[ 4 ] ACTION ::Paste() DISABLED
      EndIf

      If ::lReadOnly .or. nLo == nHi
         MENUITEM aMsg[ 5 ] action nil disabled
      Else
         MENUITEM aMsg[ 5 ] ACTION If( nHi != nLo,;
                ( ::GetDelSel( nLo, nHi ), ::EditUpdate() ),)
      EndIf

      SEPARATOR
      MENUITEM aMsg[ 6 ] ACTION ::SelectAll()
   ENDMENU

   ACTIVATE POPUP oMenu AT nRow - 60, nCol OF Self

Return 0

* ============================================================================
* METHOD TSGet:Spinner() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Spinner( bUp, bDown, bMin, bMax ) CLASS TSGet

   ::bMin := bMin
   ::bMax := bMax
   ::nRight -= 20

   DEFINE SCROLLBAR ::oVScroll VERTICAL OF Self

   DEFAULT bUp   := {|| Self++ } ,;
           bDown := {|| Self-- }

   ::oVScroll:bGoUp   := {|| If( GetFocus() != ::hWnd, ::SetFocus(), Nil ), ;
                             Eval( bUp, Self ) }
   ::oVScroll:bGoDown := {|| If( GetFocus() != ::hWnd, ::SetFocus(), Nil ), ;
                             Eval( bDown, Self ) }

Return Nil

* ============================================================================
* METHOD TGet:HandleEvent() Version 8.0 Feb/01/2008
* ============================================================================

METHOD HandleEvent( nMsg, nWParam, nLParam ) CLASS TSGet
// just used for some testings

/*   fDebug( "nMsg="+AllTrim(cValTochar(nMsg))+" nWParam="+;
           AllTrim(cValTochar(nWParam))+;
           " nLoWord="+AllTrim(cValTochar(nLoWord(nLParam)))+;
           " nHiWord="+AllTrim(cValTochar(nHiWord(nLParam)))+CRLF+;
           " ProcName="+ProcName(2)+Space(1)+LTStr(ProcLine(2))+space(1)+;
           ProcName(3)+Space(1)+LTStr(Procline(3)) ) */

Return Super:HandleEvent( nMsg, nWParam, nLParam )

* ============================================================================
* METHOD TGet:FillText() Version 8.0 Feb/01/2008
* ============================================================================

METHOD FillText( nKey ) CLASS TSGet

   Local nAt, cText, ;
         nLen := Len( ::Value() ), ;
         nPos := ::nPos

   Default ::lFilled := .F.

   cText := SubStr( ::cText, 1, nPos - 1 ) + Upper( Chr( nKey ) )

   If ( nAt := AScan( ::aFill, Upper( cText ) ) ) == 0
      ::cText( Padr( cText, nLen ) )
      ::SetPos( nPos )
   Else
      ::cText( Padr( ::aFill[ nAt ], nLen ) )
      ::SetPos( nPos )
      ::lFilled := .T.
   EndIf

Return Nil
