#include "FiveWin.ch"

#ifdef __CLIPPER__
   #define EM_GETSEL       (WM_USER+0)
#else
   #define EM_GETSEL               176
#endif

* ============================================================================
* CLASS TSMulti  Version 8.0 Feb/1/2008
* ============================================================================

CLASS TSMulti FROM TMultiGet

   Method KeyChar( nKey, nFlags )
   Method KeyDown( nKey, nFlags )
   Method LostFocus( hCtlFocus )
   Method lValid()

ENDCLASS

* ============================================================================
* METHOD TSMulti:KeyChar() Version 8.0 Feb/1/2008
* ============================================================================

METHOD KeyChar( nKey, nFlags ) CLASS TSMulti

   If GetKeyState( VK_CONTROL )
      nKey := If( Upper( Chr( nKey ) ) == "W" .or. nKey == VK_RETURN, VK_TAB, nKey )
   EndIf

   If nKey == VK_TAB .or. nKey == VK_ESCAPE
      Return 0
   Endif

RETURN Super:KeyChar( nKey, nFlags )

* ============================================================================
* METHOD TSMulti:KeyDown() Version 8.0 Feb/1/2008
* ============================================================================

METHOD KeyDown( nKey, nFlags ) CLASS TSMulti

   If GetKeyState( VK_CONTROL )
      nKey := If( Upper( Chr( nKey ) ) == "W" .or. nKey == VK_RETURN, VK_TAB, nKey )
   EndIf

   ::nLastKey := ::oWnd:nLastKey := nKey

   If nKey == VK_TAB .or. nKey == VK_ESCAPE

      If ::lValid()

         If ::bSetGet != Nil
            Eval( ::bSetGet, GetWindowText( ::hWnd ) )
         EndIf

         ::bLostFocus := Nil
         Eval( ::bKeyDown, nKey, nFlags, .T. )

      EndIf

      Return 0

   Endif

RETURN Super:KeyDown( nKey, nFlags )

* ============================================================================
* METHOD TSMulti:lValid() Version 8.0 Feb/1/2008
* ============================================================================

METHOD lValid() CLASS TSMulti

   Local lRet := .t.

   If ValType( ::bValid ) == "B"
      lRet := Eval( ::bValid, ::GetText() )
   EndIf

Return lRet

* ============================================================================
* METHOD TSMulti:LostFocus() Version 8.0 Feb/1/2008
* ============================================================================

METHOD LostFocus( hCtlFocus ) CLASS TSMulti

   ::lFocused := .F.

   ::nPos := nLoWord( ::SendMsg( EM_GETSEL ) )

   If ::bLostFocus != Nil
      Eval( ::bLostFocus, ::nLastKey, hCtlFocus )
   EndIf

Return 0
