* ============================================================================
* TSBrowse.PRG Version 8.0 Feb/01/2008
* ============================================================================

/* This Classs is a recapitulation of the code adapted by Luis Krause Mantilla,
   of FiveWin classes: TCBrowse, TWBrowse, TCColumn and Clipper Wrapers in C
   that support the visual Windows interface.

   Originally TCBrowse was a Sub-Class of TWBrowse, with this work, we have the
   new class "TSBrowse" that is no more a Sub-Class. Now, TSBrowse is an
   independent control that inherits directly from TControl class.

   My work has mainly consisted on putting pieces together with some extra from
      my own crop.

   Credits:
      Luis Krause Mantilla
      Selim Anter
      Stan Littlefield
      Marshall Thomas
      Eric Yang
      John Stolte
      Harry Van Tassell
      Martin Vogel
      Katy Hayes
      Jose Gimenez
      Hernan Diego Ceccarelli ( some ideas taked from his TWBrowse )
      Antonio Carlos Pantaglione ( Toninho@fwi.com.br )
      TSBtnGet is an adaptation of the Ricardo Ramirez TBtnGet Class
      Gianni Santamarina
      Ralph del Castillo
      Daniel Andrade
      Yamil Bracho
      Victor Manuel Toms (VikThor)
      FiveTechSoft (original classes)

      Many thanks to all of them.

      Regards.

      Manuel Mercado.  July 15th, 2004

    Aqu vamos ! |  Here we go !...  */

//----------------------------------------------------------------------------//

#include "C:\FWH\Include\Fivewin.ch"
#include "C:\TSBrowse\Include\TSBrowse.ch"

#ifdef __XPP__
   #define Super ::TControl
   #define New   _New
   #xtranslate   _DbSkipper => DbSkipper
#EndIf

#ifdef __HARBOUR__
   #xtranslate   _DbSkipper => DbSkipper
   #ifdef __HBOLE__
      #define __OLE__
   #EndIf
   EXTERN OrdKeyNo, OrdKeyCount, OrdKeyGoto
#EndIf

#ifdef __CLIPPER__
   #ifdef __OLE2__
      #define __OLE__
   #EndIf
#EndIf

// Windows 95 keyboard's "Context" key
// Tecla "Contexto" en el teclado Winsows 95
#define VK_CONTEXT         93

#define WM_SETFONT         48    // 0x0030
#define WM_ERASEBKGND      20    // 0x0014

// let's save DGroup space
// ahorremos espacio para DGroup
#define nsCol        asTSB[1]
#define nsWidth      asTSB[2]
#define nsOldPixPos  asTSB[3]
#define bCxKeyNo     asTSB[4]
#define bCmKeyNo     asTSB[5]
#define nGap			asTSB[6]
#define nNewEle      asTSB[7]
#define nKeyPressed  asTSB[8]
#define lNoAppend    asTSB[9]
#define nInstance    asTSB[10]

// api maximal vertical scrollbar position
#define MAX_POS 32767

// mouse wheel Windows message
#define WM_MOUSEWHEEL  522

// to detect formatted text in memo fields
#define GTF5 "GTF" + Chr( 5 )

Extern TOleAuto
Static asTSB  := { Nil, Nil, 0, Nil, Nil, 0, 0, Nil, Nil, Nil }
Static nLapsus, oToolTip, oTmr, hPrvWnd, hWndParent, lToolTip, nToolTip, hToolTip := 0

//----------------------------------------------------------------------------//

CLASS TSBrowse FROM TControl

   CLASSDATA lRegistered AS LOGICAL

   CLASSDATA aProperties AS ARRAY ;
      INIT { "aColumns", "cVarName", "nTop", "nLeft", "nWidth", "nHeight" }

   CLASSDATA lVScroll, lHScroll

   DATA   aActions                                   // actions to be executed on header's click
   DATA   aColors                                    // the whole colors kit
   DATA   aArray        AS ARRAY                     // browsed array
   DATA   aBitmaps      AS ARRAY INIT {}             // array with bitmaps handles
   DATA   aDefault      AS ARRAY INIT {}             // default values in append mode
   DATA   aClipBoard                                 // used by RButtonDown method
   DATA   aColSizes, aColumns, aHeaders              // the core of TSBrowse
   DATA   aDefValue     AS ARRAY INIT {}             // for array in append mode
   DATA   aIcons        AS ARRAY INIT {}             // array with icons names
   DATA   aImages       AS ARRAY INIT {}             // array with bitmaps names
   DATA   aJustify                                   // compatibility with TWBrowse
   DATA   aLine                                      // bLine as array
   DATA   aMsg          AS ARRAY INIT {}             // multi languaje feature
   DATA   aKeyRemap     AS ARRAY INIT {}             // to prevalidate keys at KeyChar method
   DATA   aPostList                                  // used by ComboWBlock function
   DATA   aSelected                                  // selected items in select mode
   DATA   aSuperHead                                 // array with SuperHeads properties

   DATA   bAddRec                                    // custom function for adding record (with your own message)
   DATA   bBitMapH                                   // bitmap handle
   DATA   bContext                                   // evaluates windows keyboard context key
   DATA   bDelete                                    // evaluated after user deletes a row with lCanDelete mode
   DATA   bFileLock                                  // custom function for locking database (with your own message)
   DATA   bGoToPos                                   // scrollbar block
   DATA   bFilter                                    // a simple filter tool
   DATA   bIconDraw, bIconText                       // icons drawing directives
   DATA   bInit                                      // code block to be evaluated on init
   DATA   bLine, bSkip, bGoTop, bGoBottom, ;
          bLogicLen, bChange                         // navigation codeblocks
   DATA   bKeyNo                                     // logical position on indexed databases
   DATA   bOnDraw                                    // evaluated in DrawSelect()
   DATA   bOnDrawLine                                // evaluated in DrawLine()
   DATA   bPostDel                                   // evaluated after record deletion
   DATA   bRecLock                                   // custom function for locking record (with your own message)
   DATA   bSeekChange                                // used by seeking feature
   DATA   bSelected                                  // to be evaluated in select mode
   DATA   bSetOrder                                  // used by seeking feature
   DATA   bTagOrder                                  // to restore index on GotFocus
   DATA   bUserKeys                                  // user code block to change the
                                                     // behavior of pressed keys
   DATA   cAlias                                     // data base alias or "ARRAY" or "TEXT_"
   DATA   cDriver                                    // RDD in use
   DATA   cField, uValue1, uValue2                   // SetFilter Params
   DATA   cOrderType                                 // index key type for seeking
   DATA   cPrefix                                    // used by TSBrowse search feature
   DATA   cSeek                                      // used by TSBrowse search feature

   DATA   hBmpCursor    AS NUMERIC                   // bitmap cursor for first column

   DATA   l2007         AS LOGICAL INIT .F.          // new look
   DATA   l3DLook       AS LOGICAL INIT .F. READONLY // internally control state of ::Look3D() in "Phantom" column
   DATA   lHitTop, lHitBottom, lCaptured, lMChange   // browsing flags
   DATA   lAppendMode   AS LOGICAL INIT .F. READONLY // automatic append flag
   DATA   lAutoCtx      AS LOGICAL                   // compatibility with TCBrowse
   DATA   lAutoEdit     AS LOGICAL INIT .F.          // activates continuous edition mode
   DATA   lAutoSkip     AS LOGICAL INIT .F.          // compatibility with TCBrowse
   DATA   lCanAppend    AS LOGICAL INIT .F. READONLY // activates auto append mode
   DATA   lCanDelete    AS LOGICAL INIT .F. HIDDEN   // activates delete capability
   DATA   lCanSelect    AS LOGICAL INIT .F.          // activates select mode
   DATA   lCellBrw                                   // celled browse flag
   DATA   lCellStyle    AS LOGICAL INIT .F.          // compatibility with TCBrowse
   DATA   lChanged      AS LOGICAL INIT .F.          // field has changed indicator
   DATA   lClipMore     AS LOGICAL INIT .F.          // ClipMore RDD
   DATA   lColDrag      AS LOGICAL                   // dragging feature
   DATA   lConfirm      AS LOGICAL INIT .T. HIDDEN   // ask for user confirm to delete a row
   DATA   lDbfObj       AS LOGICAL INIT .F.          // using database objects
   DATA   lDescend      AS LOGICAL INIT .F.          // descending indexes
   DATA   lDestroy                                   // flag to destroy bitmap created for selected records
   DATA   lDrawHeaders  AS LOGICAL INIT .T.          // condition for headers drawing
   DATA   lDrawFooters                               // condition for footers drawing
   DATA   lEditing      AS LOGICAL INIT .F. READONLY // to avoid lost focus at editing time
   DATA   lFilterMode   AS LOGICAL INIT .F. READONLY // index based filters with NTX RDD
   DATA   lFirstFocus   HIDDEN                       // controls some actions on init
   DATA   lFirstPaint                                // controls some actions on init
   DATA   lFixCaret     AS LOGICAL                   // TSGet fix caret at editing time
   DATA   lFooting      AS LOGICAL                   // indicates footers can be drawn
   DATA   lNoPaint                                   // to avoid unnecessary painting
   DATA   lGrasp        AS LOGICAL INIT .F. READONLY // used by drag & drop feature
   DATA   lHasChanged   AS LOGICAL INIT .F.          // browsed data has changed flag for further actions
   DATA   lHasFocus     AS LOGICAL INIT .F.          // focused flag
   DATA   lIconView     AS LOGICAL INIT .F.          // compatibility with TCBrowse
   DATA   lInitGoTop                                 // go to top on init, default = .T.
   DATA   lIsArr                                     // browsing an array
   DATA   lIsDbf        AS LOGICAL INIT .F. READONLY // browsed object is a database
   DATA   lIsTxt                                     // browsing a text file
   DATA   lIsV22        AS LOGICAL INIT .F.          // true if oBmp:hBmpPal is not defined
   DATA   lLineDrag     AS LOGICAL                   // TSBrowse dragging feature
   DATA   lLockFreeze   AS LOGICAL                   // avoids cursor positioning on frozen columns
   DATA   lMoveCols     AS LOGICAL                   // Choose between moving or exchanging columns (::moveColumn() or ::exchange())
   DATA   lNoChangeOrd  AS LOGICAL                   // avoids changing active order by double clicking on headers
   DATA   lNoExit       AS LOGICAL INIT .F.          // prevents edit exit with arrow keys
   DATA   lNoGrayBar    AS LOGICAL                   // don't show inactive cursor
   DATA   lNoHScroll    AS LOGICAL                   // disables horizontal scroll bar
   DATA   lNoLiteBar    AS LOGICAL                   // no cursor
   DATA   lNoMoveCols   AS LOGICAL INIT .F.          // avoids resize or move columns by the user
   DATA   lNoResetPos   AS LOGICAL                   // prevents to reset record position on gotfocus
   DATA   lNoVScroll    AS LOGICAL                   // disables vertical scroll bar
   DATA   lLogicDrop    AS LOGICAL                   // compatibility with TCBrowse
   DATA   lPageMode     AS LOGICAL INIT .F.          // paging mode flag
   DATA   lPainted      AS LOGICAL                   // controls some actions on init
   DATA   lRePaint      AS LOGICAL                   // bypass paint if false
   DATA   lPostEdit                                  // to detect postediting
   DATA   lUndo         AS LOGICAL INIT .F.          // used by RButtonDown method
   DATA   lUpdated      AS LOGICAL INIT .F.          // replaces lEditCol return value
   DATA   lUpperSeek    AS LOGICAL INIT .T.          // controls if char expresions are seek in uppercase or not
   DATA   lSeek         AS LOGICAL INIT .T.          // activates TSBrowse seeking feature
   DATA   lSelector     AS LOGICAL INIT .F.          // automatic first column with pointer bitmap
   DATA   lTransparent  AS LOGICAL INIT .F.          // NEW TRANSPARENT BROWSES

   DATA   nAdjColumn    AS NUMERIC                   // column expands to flush table window right
   DATA   nAligBmp      AS NUMERIC INIT 0            // bitmap layout in selected cell
   DATA   nCell         AS NUMERIC                   // actual column
   DATA   nClrHeadBack, nClrHeadFore                 // headers colors
   DATA   nClrFocuBack, nClrFocuFore                 // focused cell colors
   DATA   nClrEditBack, nClrEditFore                 // editing cell colors
   DATA   nClrFootBack, nClrFootFore                 // footers colors
   DATA   nClrSeleBack, nClrSeleFore                 // selected cell no focused
   DATA   nClrOrdeBack, nClrOrdeFore                 // order control column colors
   DATA   nClrLine                                   // grid line color
   DATA   nColOrder     AS NUMERIC                   // compatibility with TCBrowse
   DATA   nColPos       AS NUMERIC INIT 0            // grid column position
   DATA   nColSel       AS NUMERIC INIT 0            // column to mark in selected records
   DATA   nDragCol      AS NUMERIC                   // drag & drop  feature
   DATA   nFireKey                                   // key to start edition, defaults to VK_F2
   DATA   nFirstKey     AS NUMERIC INIT 0 HIDDEN     // First logic pos in filtered databases
   DATA   nFreeze       AS NUMERIC                   // 0,1,2.. freezes left most columns
   DATA   nHeightCell   AS NUMERIC INIT 0            // resizable cell height
   DATA   nHeightHead   AS NUMERIC INIT 0            //      "    header  "
   DATA   nHeightFoot   AS NUMERIC INIT 0            //      "    footer  "
   DATA   nHeightSuper  AS NUMERIC INIT 0            //      "    Superhead  "
   DATA   nIconPos                                   // compability with TCBrowse
   DATA   nLastPainted  AS NUMERIC INIT 0 HIDDEN     // last painted nRow
   DATA   nLastPos      AS NUMERIC                   // last record position before lost focus
   DATA   nLastnAt      AS NUMERIC INIT 0 HIDDEN     // last ::nAt value before lost focus
   DATA   nLen          AS NUMERIC                   // total number of browsed items
   DATA   nLineStyle                                 // user definable grid lines style
   DATA   nMaxFilter                                 // maximum number of records to count on index based filters
   DATA   nMemoHE, nMemoWE, nMemoHV, nMemoWV         // memo sizes on edit and view mode
                                                     // Height in lines and Width in pixels
                                                     // default: 3 lines height and 200 pixels width
   DATA   nOldCell      HIDDEN                       // to control column bGotfocus
   DATA   nOffset       AS NUMERIC INIT 0 HIDDEN     // offset marker for text viewer
   DATA   nPaintRow     AS NUMERIC                   // row being painted in DrawLine Method
   DATA   nPhantom      AS NUMERIC INIT PHCOL_GRID   // controls drawing state for "Phantom" column (-1 or -2) inside ::Look3D()
   DATA   nPrevRec                                   // internally used to go previous record back
   DATA   nRowPos, nAt  AS NUMERIC INIT 0            // grid row positions
   DATA   nWheelLines                                // lines to scroll with mouse wheel action

   DATA   oBmpCursor    AS OBJECT                    // first column pointer bitmap
   DATA   oDbf          AS OBJECT                    // TDbf / TDatabase object
   DATA   oCtx          AS OBJECT READONLY           // context object
   DATA   oGet                                       // get object
   DATA   oItem                                      // tree item object used by SetoTree()
   DATA   oPhant                                     // phantom column
   DATA   oTree                                      // tree object
   DATA   oTxtFile      AS OBJECT                    // for text files browsing (TTxtFile() class)

   DATA   uBmpSel                                    // bitmap to show in selected records
   DATA   uLastTag                                   // last TagOrder before losing focus

   METHOD New( nRow, nCol, nWidth, nHeigth, bLine, aHeaders, aColSizes, oWnd, cField, uVal1, uVal2, bChange, ;
               bLDblClick, bRClick, oFont, oCursor, lTransparent, aColors, cMsg, lUpdate, uAlias, lPixel, bWhen, ;
               lDesign, lCellBrw, nStyle, bLClick, aLine, oSelector ) CONSTRUCTOR

   METHOD ReDefine( nId, bLine, oDlg, aHeaders, aColSizes, cField, uVal1, uVal2, bChange, bLDblClick, bRClick, oFont, ;
                    oCursor, lTransparent, nClrFore, nClrBack, cMsg, lUpdate, uAlias, bWhen, lCellBrw, bLClick, ;
                    aLine, oSelector ) CONSTRUCTOR

   METHOD AddColumn( oColumn )

   METHOD AddSuperHead( nFromCol, nToCol, uHead, nHeight, aColors, l3dLook, uFont, uBitMap, lAdjust, lTransp, lGrid, ;
                        nHAlign, nVAlign )

   METHOD BeginPaint() INLINE If( ::lRepaint, Super:BeginPaint(), 0 )

   METHOD BugUp() INLINE ::UpStable()

   METHOD BiClr( uClrOdd, uClrPair )

   METHOD ChangeFont( oFont, nColumn, nLevel )

   METHOD CheckToolTip()

   METHOD DbSkipper( nToSkip )

   METHOD Default()

   METHOD Del( nItem )

   METHOD DeleteRow()

	METHOD DelColumn( nPos )

   METHOD Destroy()

   METHOD DestroyToolTip()

   METHOD Display()

   METHOD DrawFooters() INLINE ::DrawHeaders( .T. )

   MESSAGE DrawIcon METHOD _DrawIcon( nIcon, lFocused )

   METHOD DrawIcons()

   METHOD DrawLine( nRow )

   METHOD DrawPressed( nCell, lPressed )

   METHOD DrawSelect()

   METHOD DrawSuper()

   METHOD DrawHeaders()

   METHOD Edit( uVar, nCol, nKey, nFlags )

   METHOD EditExit( nCol, nKey, uVar, bValid, lLostFocus )

   METHOD EndPaint()   INLINE If( ::lRePaint, Super:EndPaint(), ( ::lRePaint := .T., 0 ) )

   METHOD ExcelOle( cXlsFile, lActivate, oMeter, cTitle, oFont, lSave, bExtern )

   METHOD Exchange( nCol1, nCol2 )  INLINE ::SwitchCols( nCol1, nCol2), ::SetFocus()

   METHOD ExpLocate( cExp )

   METHOD ExpSeek( cExp, lSoft )

   METHOD FreezeCol( lNext )

   METHOD GetColSizes() INLINE If( ValType( ::aColSizes ) == "A", ::aColSizes, Eval( ::aColSizes ) )

	METHOD GetColumn( nCol )

   METHOD GetDlgCode( nLastKey )

   METHOD GetRealPos( nRelPos )

   METHOD GetTxtRow( nRowPix ) INLINE RowFromPix( ::hWnd, nRowPix, ::nHeightCell, ;
                                                  If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
                                                  If( ::lFooting .and. ::lDrawFooters, ::nHeightFoot, 0 ), ;
                                                  If( ::lDrawHeaders, ::nHeightSuper, 0 ) )
   METHOD GoBottom()

   METHOD GoDown()

   METHOD GoEnd()

   METHOD GoHome()

   METHOD GoLeft()

   METHOD GoNext()

   METHOD GoPos( nNewRow, nNewCol )

   METHOD GoRight()

   METHOD GotFocus( hCtlLost )

   METHOD GoTop()

   METHOD GoUp()

   METHOD HandleEvent( nMsg, nWParam, nLParam )

   METHOD HiliteCell( nCol, nColPix )

   METHOD HScroll( nWParam, nLParam )

   METHOD HThumbDrag( nNewCol )

   METHOD Init( hDlg ) INLINE ::Initiate( hDlg )

   METHOD Initiate( hDlg ) INLINE Super:Initiate( hDlg ), ::Default()

   METHOD InsColumn( nPos, oColumn )

   METHOD Insert( cItem, nAt )

   METHOD Inspect( cData )

   METHOD IsColVisible( nCol )

   METHOD IsColVis2( nCol )

   METHOD IsEditable( nCol ) INLINE ::lCellBrw .and. ::aColumns[ nCol ]:lEdit .and. ;
                                    ( ::aColumns[ nCol ]:bWhen == Nil .or. Eval( ::aColumns[ nCol ]:bWhen, Self ) )

   METHOD KeyChar( nKey, nFlags )

   METHOD KeyDown( nKey, nFlags )

   METHOD KeyUp( nKey, nFlags )

   METHOD LButtonDown( nRowPix, nColPix, nKeyFlags )

   METHOD LButtonUp( nRowPix, nColPix, nKeyFlags )

   METHOD lCloseArea() INLINE If( ::lIsDbf .and. ! Empty( ::cAlias ), ( ( ::cAlias )->( DbCloseArea() ), ;
                                 ::cAlias := "", .T. ), .F. )

   METHOD LDblClick( nRowPix, nColPix, nKeyFlags )

   METHOD lEditCol( uVar, nCol, cPicture, bValid, nClrFore, nClrBack )

   METHOD lIgnoreKey( nKey, nFlags )

   METHOD LoadFields( lEditable, aNames )

   METHOD LoadRelated( cAlias, lEditable, aNames )

   METHOD Look3D( lOnOff, nColumn, nLevel, lPhantom )

   METHOD LostFocus( hCtlFocus )

   METHOD MButtonDown( nRow, nCol, nKeyFlags )

   METHOD MouseMove( nRowPix, nColPix, nKeyFlags )

   METHOD MouseWheel( nKeys, nDelta, nXPos, nYPos )

   METHOD MoveColumn( nColPos, nNewPos )

   METHOD nAtCol( nColPix, lActual )

   METHOD nAtIcon( nRow, nCol )

   METHOD nColCount() INLINE Len( ::aColumns )

   METHOD nLogicPos()

   METHOD nRowCount() INLINE CountRows( ::hWnd, ::nHeightCell, If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
                                        If( ::lFooting .and. ::lDrawFooters, ::nHeightFoot, 0 ), ;
                                        If( ::lDrawHeaders, ::nHeightSuper, 0 ) )
   METHOD PageUp( nLines )

   METHOD PageDown( nLines )

   METHOD Paint()

   METHOD PanHome()

   METHOD PanEnd()

   METHOD PanLeft()

   METHOD PanRight()

   METHOD PostEdit( uTemp, nCol, bValid )

   METHOD RButtonDown( nRowPix, nColPix, nKeyFlags )

   MESSAGE RecCount METHOD _RecCount( uSeekValue )

   METHOD Refresh( lPaint ) INLINE If( ::lFirstPaint == Nil .or. ::lFirstPaint, 0, ( ;
                                       ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                                       Eval( ::bLogicLen ) ), ::lNoPaint := .F., Super:Refresh( lPaint ) ) )

   METHOD RelPos( nLogicPos )

   METHOD Report( cTitle, lPreview, oFont, cCaption, lModal, aCols, cHeader, cFooter, lGrid, oDevice )


   METHOD Reset( cField, uVal1, uVal2 )

   METHOD ResetBarPos( lInit )

   METHOD ResetSeek()

   METHOD ReSize( nSizeType, nWidth, nHeight )

   METHOD TSBrwScroll( nDir ) INLINE TSBrwScroll( ::hWnd, nDir, If( ::oFont != nil, ::oFont:hFont, 0 ), ;
                                                  ::nHeightCell, If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
                                                  If( ValType( ::lDrawFooters ) == "L" .and. ;
                                                  ::lDrawFooters , ::nHeightFoot, 0 ), ;
                                                  ::nHeightSuper )

   METHOD Seek( nKey )

   METHOD Set3DText( lOnOff, nColumn, nLevel, nClrLight, nClrShadow )

   METHOD SetAlign( nColumn, nLevel, nAlign )

   METHOD SetAppendMode( lMode )

   METHOD SetArray( aArray )

   METHOD SetBtnGet( nCol, cResName, bAction, nBmpWidth )

   METHOD SetColMsg( cMsg, cEditMsg, nCol )

   METHOD SetColor( xColor1, xColor2, nColumn )

   METHOD SetColSize( nCol, nWidth )

   METHOD SetColumns( aData, aHeaders, aColSizes )

   METHOD SetDeleteMode( lOnOff, lConfirm, bDelete, bPostDel )

   METHOD SetHeaders( nHeight, aCols, aTitles, aAlign , al3DLook, aFonts, aActions )

   METHOD SetContext( oCtx )   INLINE If( oCtx == Nil, ::lAutoCtx := .F., ::oCtx := oCtx )

   METHOD SetData( nColumn, bData, aList )

   METHOD SetFilter( cField, uVal1, uVal2 )

   METHOD SetFont( oFont )

   METHOD SetIndexCols( aCols )

   METHOD SetItems( aItems ) INLINE ::SetArray( aItems, .T. )

   METHOD SetoDBF( oDbf )

   METHOD SetOrder( nColumn, cPrefix )

   METHOD SetSelectMode( lOnOff, bSelected, uBmpSel, nColSel, nAlign )

   METHOD SetSpinner( nColumn, lOnOff, bUp, bDown, bMin, bMax )

   METHOD SetTree( oTree )

   METHOD SetTxtFile( uTxtFile, cTitle, lOemToAnsi )

   METHOD ShowSizes()

   METHOD ShowToolTip( nRow, nCol, cToolTip )

   METHOD Skip( n )

   METHOD SortArray( nCol, lDescend )

   METHOD SwitchCols( nCol1, nCol2 )

	METHOD SyncChild( aoChildBrw, abAction )

   METHOD UpStable()

   METHOD Proper( cText )

   METHOD VertLine( nColPos, nColInit, nGapp )

   METHOD VScroll( nWParam, nLParam )

ENDCLASS

* ============================================================================
* METHOD TSBrowse:New() Version 8.0 Feb/01/2008
* ============================================================================

METHOD New( nRow, nCol, nWidth, nHeight, bLine, aHeaders, aColSizes, oWnd, cField, uVal1, uVal2, bChange, bLDblClick, ;
            bRClick, oFont, oCursor, lTransparent, aColors, cMsg, lUpdate, uAlias, lPixel, bWhen, lDesign, lCellBrw, ;
            nStyle, bLClick, aLine, oSelector, aActions, nLineStyle ) CLASS TSBrowse

   Local aTmpColor := Array( 15 ), ;
         cAlias    := Alias(), ;
         lSelector := ValType( oSelector ) == "O" .and. Upper( oSelector:ClassName() ) == "TBITMAP"

   #ifdef __XPP__
      #undef New
   #EndIf

   If aColors != Nil
      Aeval( aColors, { | bColor, nEle | aTmpColor[ nEle ] := bColor } )
   EndIf

   Default nRow            := 0, ;
           nCol            := 0, ;
           nHeight         := 100, ;
           nWidth          := 100, ;
           oWnd            := GetWndDefault(), ;
           nLineStyle      := LINES_ALL, ;
           aLine           := {}, ;
           lTransparent    := .F.

   Default aTmpColor[ 1 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrText
           aTmpColor[ 2 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrPane
           aTmpColor[ 3 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrHeadFore
           aTmpColor[ 4 ]  := GetSysColor( COLOR_BTNFACE )   , ; // nClrHeadBack
           aTmpColor[ 5 ]  := GetSysColor( COLOR_CAPTIONTEXT ), ; // nClrForeFocu
           aTmpColor[ 6 ]  := GetSysColor( COLOR_ACTIVECAPTION ) // nClrFocuBack

   Default aTmpColor[ 7 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrEditFore
           aTmpColor[ 8 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrEditBack
           aTmpColor[ 9 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrFootFore
           aTmpColor[ 10 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrFootBack
           aTmpColor[ 11 ] := CLR_HGRAY                      , ; // nClrSeleFore inactive focused
           aTmpColor[ 12 ] := CLR_GRAY                       , ; // nClrSeleBack inactive focused
           aTmpColor[ 13 ] := GetSysColor( COLOR_BTNTEXT )   , ; // nClrOrdeFore
           aTmpColor[ 14 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrOrdeBack
           aTmpColor[ 15 ] := GetSysColor( COLOR_BTNSHADOW )     // nClrLine

   Default lUpdate         := .F., ;
           lPixel          := .F., ;
           lDesign         := .F., ;
           aColSizes       := {}, ;
           lCellBrw        := .F.

   Default nStyle := nOr( WS_CHILD, WS_BORDER, WS_VISIBLE, WS_TABSTOP, 4, If( lDesign, WS_CLIPSIBLINGS, 0 ) )

   If ValType( uAlias ) == "A"
      cAlias := "ARRAY"
   ElseIf ValType( uAlias ) == "C" .and. "." $ uAlias
      cAlias := "TEXT_" + AllTrim( uAlias )
   ElseIf ValType( uAlias ) == "C"
      cAlias := Upper( uAlias )
   ElseIf ValType( uAlias ) == "O"

      If Upper( uAlias:ClassName() ) == "TDATABASE" .or. ;
         Upper( uAlias:ClassName() ) == "TDBF" .or. ;
         Upper( uAlias:ClassName() ) == "TMULTIDBF"

         cAlias := "ODBF"

      ElseIf Upper( uAlias:ClassName() ) == "TTXTFILE"
         cAlias := "TEXT_" + AllTrim( uAlias:cName )
      ElseIf Upper( uAlias:ClassName() ) == "TLINKLIST"
         cAlias := "TREE_"
      EndIf

   EndIf

   ::cCaption    = ""
   ::nTop        = nRow * If( lPixel, 1, BRSE_CHARPIX_H ) // 14
   ::nLeft       = nCol * If( lPixel, 1, BRSE_CHARPIX_W )  //8
   ::nBottom     = ::nTop + nHeight - 1
   ::nRight      = ::nLeft + nWidth - 1
   ::oWnd        = oWnd
   ::lHitTop     = .F.
   ::lHitBottom  = .F.
   ::lFocused    = .F.
   ::lCaptured   = .F.
   ::lMChange    = .T.
   ::nRowPos     = 1
   ::nAt         = 1
   ::nColPos     = 1
   ::nStyle      = nStyle
   ::lAutoCtx    = .T.
   ::lRePaint    = .F.
   ::lNoHScroll  = .F.
   ::lNoVScroll  = .F.
   ::lNoLiteBar  = .F.
   ::lNoGrayBar  = .F.
   ::lLogicDrop  = .F.
   ::lColDrag    = .F.
   ::lLineDrag   = .F.
   ::nFreeze     = 0
   ::aColumns    = {}
   ::nColOrder   = 0
   ::cOrderType  = ""
   ::lFooting    = .F.
   ::nCell       = 1
   ::lCellBrw    = lCellBrw
   ::lMoveCols   = .F.
   ::lLockFreeze = .F.
   ::lCanAppend  = .F.
   ::lAppendMode = .F.
   ::aImages     = {}
   ::aBitmaps    = {}
   ::nId         = ::GetNewId()
   ::cAlias      = cAlias
   ::bLine       = bLine
   ::aLine       = aLine
   ::lAutoEdit   = .F.
   ::lAutoSkip   = .F.
   ::lIconView   = .F.
   ::lCellStyle  = .F.
   ::nIconPos    = 0
   ::bChange     = bChange
   ::bLClicked   = bLClick
   ::bLDblClick  = bLDblClick
   ::bRClicked   = bRClick
   ::aHeaders    = aHeaders
   ::aColSizes   = aColSizes
   ::aJustify    = {}
   ::nLen        = 0
   ::lDrag       = lDesign
   ::lDesign     = lDesign
   ::lCaptured   = .F.
   ::lPainted    = .F.
   ::lNoResetPos = .T.
   ::oCursor     = oCursor
   ::cMsg        = cMsg
   ::lUpdate     = lUpdate
   ::bWhen       = bWhen
   ::aActions    = aActions
   ::aColors     = aTmpColor
   ::nLineStyle  = nLineStyle
   ::aSelected   = {}
   ::aSuperHead  = {}
   ::lFixCaret   = .F.
   ::oFont       = oFont
   ::lTransparent = lTransparent
   ::lSelector   = lSelector
   ::hBmpCursor  = If( lSelector, oSelector:hBitMap, Nil )
   ::SetColor( , aTmpColor )

   #ifdef __XPP__
      DEFAULT ::lRegistered := .F.
   #EndIf

   ::Register( nOr( CS_VREDRAW, CS_HREDRAW, CS_DBLCLKS ) )

   If ( ::lIsV22 := CheckBmpPal() )
      ::bBitMapH := &( "{|oBmp|If(oBmp!=Nil,oBmp:hBitMap,0)}" )
   Else
      ::bBitMapH := &( "{|oBmp|If(oBmp!=Nil,nLoWord(oBmp:hBmpPal),0)}" )
   EndIf

   ::lIsDbf := ! EmptyAlias( ::cAlias ) .and. ::cAlias != "ARRAY" .and. ! ( "TEXT_" $ ::cAlias ) .and. ;
               ::cAlias != "TREE_"

   ::aMsg := LoadMsg()

   If ! Empty( ::oWnd:hWnd )
      ::Create()

      If oFont != Nil
         ::SetFont( oFont )
      EndIf

      ::lVisible = .T.
      ::Default()
      ::oWnd:AddControl( Self )
   Else
      ::oWnd:DefControl( Self )

      If oFont != Nil
         ::SetFont( oFont )
      EndIf

      ::lVisible = .F.
   EndIf

   ::nHeightFoot := 0
   ::nHeightCell := ::nHeightHead :=  SBGetHeight( ::hWnd, If( ::oFont != Nil, ::oFont:hFont, 0 ), 0 )

   If lDesign
      ::CheckDots()
   EndIf

   ::SetFilter( cField, uVal1, uVal2 )

   If ::cAlias == "ARRAY"
      If ! Empty( uAlias ) .and. ValType( uAlias[ 1 ] ) != "A"
         ::SetItems( uAlias )
      Else
         ::SetArray( uAlias )
      EndIf
   ElseIf "TEXT_" $ ::cAlias
      ::SetTxtFile( uAlias )
   ElseIf ::cAlias == "ODBF"
      ::SetOdbf( uAlias )
   ElseIf ::cAlias == "TREE_"
      ::SetTree( uAlias )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:Redefine() Version 8.0 Feb/01/2008
* ============================================================================

METHOD ReDefine( nId, bLine, oDlg, aHeaders, aColSizes, cField, uVal1, uVal2, bChange, bLDblClick, bRClick, oFont, ;
                 oCursor, lTransparent, aColors, cMsg, lUpdate, uAlias, bWhen, lCellBrw, bLClick, aLine, aActions, ;
                 nLineStyle, oSelector ) CLASS TSBrowse

   Local aTmpColor := Array(15), ;
         cAlias    := Alias(), ;
         lSelector := ValType( oSelector ) == "O" .and. Upper( oSelector:ClassName() ) == "TBITMAP"

   If aColors != Nil
      Aeval(aColors, { | bColor, nEle | aTmpColor[ nEle ] := bColor } )
   EndIf

   Default oDlg            := GetWndDefault(), ;
           nLineStyle      := LINES_ALL, ;
           aLine           := {}, ;
           lTransparent    := .F., ;
           lSelector       := .F.

   Default aTmpColor[ 1 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrText
           aTmpColor[ 2 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrPane
           aTmpColor[ 3 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrHeadFore
           aTmpColor[ 4 ]  := GetSysColor( COLOR_BTNFACE )   , ; // nClrHeadBack
           aTmpColor[ 5 ]  := GetSysColor( COLOR_HIGHLIGHTTEXT ), ; // nClrFocuFore
           aTmpColor[ 6 ]  := GetSysColor( COLOR_HIGHLIGHT )     // nClrFocuBack

   Default aTmpColor[ 7 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrEditFore
           aTmpColor[ 8 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrEditBack
           aTmpColor[ 9 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrFootFore
           aTmpColor[ 10 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrFootBack
           aTmpColor[ 11 ] := CLR_HGRAY                      , ; // nClrSeleFore  NO focused
           aTmpColor[ 12 ] := CLR_GRAY                       , ; // nClrSeleBack  NO focused
           aTmpColor[ 13 ] := GetSysColor( COLOR_BTNTEXT )   , ; // nClrOrdeFore
           aTmpColor[ 14 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrOrdeBack
           aTmpColor[ 15 ] := GetSysColor( COLOR_BTNSHADOW )     // nClrLine

   Default lUpdate         := .F.,;
           aColSizes       := {},;
           lCellBrw        := .F.

   If ValType( uAlias ) == "A"
      cAlias := "ARRAY"
   ElseIf ValType( uAlias ) == "C" .and. "." $ uAlias
      cAlias := "TEXT_" + AllTrim( uAlias )
   ElseIf ValType( uAlias ) == "C"
      cAlias := Upper( uAlias )
   ElseIf ValType( uAlias ) == "O"

      If Upper( uAlias:ClassName() ) == "TDATABASE" .or. ;
         Upper( uAlias:ClassName() ) == "TDBF" .or. ;
         Upper( uAlias:ClassName() ) == "TMULTIDBF"

         cAlias := "ODBF"

      ElseIf Upper( uAlias:ClassName() ) == "TTXTFILE"
         cAlias := "TEXT_" + AllTrim( uAlias:cName )
      ElseIf Upper( uAlias:ClassName() ) == "TLINKLIST"
         cAlias := "TREE_"
      EndIf

   EndIf

   ::oWnd        = oDlg
   ::lHitTop     = .F.
   ::lHitBottom  = .F.
   ::lFocused    = .F.
   ::lCaptured   = .F.
   ::lMChange    = .T.
   ::nRowPos     = 1
   ::nAt         = 1
   ::nColPos     = 1
   ::lAutoCtx    = .T.
   ::lRePaint    = .F.
   ::lNoHScroll  = .F.
   ::lNoVScroll  = .F.
   ::lNoLiteBar  = .F.
   ::lNoGrayBar  = .F.
   ::lLogicDrop  = .F.
   ::lColDrag    = .F.
   ::lLineDrag   = .F.
   ::nFreeze     = 0
   ::aColumns    = {}
   ::nColOrder   = 0
   ::cOrderType  = ""
   ::lFooting    = .F.
   ::nCell       = 1
   ::lCellBrw    = lCellBrw
   ::lMoveCols   = .F.
   ::lLockFreeze = .F.
   ::lCanAppend  = .F.
   ::lAppendMode = .F.
   ::aImages     = {}
   ::aBitmaps    = {}
   ::nId         = nId
   ::cAlias      = cAlias
   ::bLine       = bLine
   ::aLine       = aLine
   ::lAutoEdit   = .F.
   ::lAutoSkip   = .F.
   ::lIconView   = .F.
   ::lCellStyle  = .F.
   ::lPainted    = .F.
   ::lNoResetPos = .T.
   ::nIconPos    = 0
   ::lMChange    = .T.
   ::bChange     = bChange
   ::bLClicked   = bLClick
   ::bLDblClick  = bLDblClick
   ::bRClicked   = bRClick
   ::aHeaders    = aHeaders
   ::aColSizes   = aColSizes
   ::aJustify    = {}
   ::nLen        = 0
   ::lDrag       = .F.
   ::lCaptured   = .F.
   ::oCursor     = oCursor
   ::cMsg        = cMsg
   ::lUpdate     = lUpdate
   ::bWhen       = bWhen
   ::aActions    = aActions
   ::aColors     = aTmpColor
   ::nLineStyle  = nLineStyle
   ::aSelected   = {}
   ::aSuperHead  = {}
   ::lFixCaret   = .F.
   ::oFont       = oFont
   ::lTransparent = lTransparent
   ::lSelector   = lSelector
   ::hBmpCursor  = If( lSelector, oSelector:hBitMap, Nil )
   ::SetColor( , aTmpColor )
   ::Register( nOr( CS_VREDRAW, CS_HREDRAW, CS_DBLCLKS ) )

   oDlg:DefControl( Self )

   If ( ::lIsV22 := CheckBmpPal() )
      ::bBitMapH := &( "{|oBmp|If(oBmp!=Nil,oBmp:hBitMap,0)}" )
   Else
      ::bBitMapH := &( "{|oBmp|If(oBmp!=Nil,nLoWord(oBmp:hBmpPal),0)}" )
   EndIf

   If oFont != Nil
      ::SetFont( oFont )
   EndIf

   ::nHeightFoot := 0
   ::nHeightCell := ::nHeightHead :=  SBGetHeight( ::hWnd, If( ::oFont != Nil, ::oFont:hFont, 0 ), 0 ) + 1

   ::aMsg := LoadMsg()

   ::lIsDbf := ! EmptyAlias( ::cAlias ) .and. ::cAlias != "ARRAY" .and. ! ( "TEXT_" $ ::cAlias ) .and. ::oTree == Nil

   ::SetFilter( cField, uVal1, uVal2 )

   If ::cAlias == "ARRAY"
      If ! Empty( uAlias ) .and. ValType( uAlias[ 1 ] ) != "A"
         ::SetItems( uAlias )
      Else
         ::SetArray( uAlias )
      EndIf
   ElseIf "TEXT_" $ ::cAlias
      ::SetTxtFile( uAlias )
   ElseIf ::cAlias == "ODBF"
      ::SetOdbf( uAlias )
   ElseIf ::cAlias == "TREE_"
      ::SetTree( uAlias )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:AddColumn() Version 8.0 Feb/01/2008
* ============================================================================

METHOD AddColumn( oColumn ) CLASS TSBrowse

   Local nHeight, nAt, cHeading, cRest, nOcurs, ;
         hFont := If( ::oFont != Nil, ::oFont:hFont, 0 )

   If ::lDrawHeaders
      cHeading := If( Valtype( oColumn:cHeading ) == "B", ;
                      Eval( oColumn:cHeading ), oColumn:cHeading )

      If Valtype( cHeading ) == "C" .and. ( nAt := At( Chr( 13 ), cHeading ) ) > 0
         nOcurs := 1
         cRest := Substr( cHeading, nAt + 2 )

         While ( nAt := At( Chr( 13 ), cRest ) ) > 0
            nOcurs++
            cRest := Substr( cRest, nAt + 2 )
         EndDo

         nHeight := SBGetHeight( ::hWnd, If( oColumn:oFontHead != Nil, ;
                                             oColumn:oFontHead:hFont, hFont ), 0 )
         nHeight *= ( nOcurs + 1 )

         If ( nHeight + 1 ) > ::nHeightHead
            ::nHeightHead := nHeight + 1
         EndIf

      EndIf

   EndIf

   If ValType( oColumn:cFooting ) $ "CB"
      ::lDrawFooters := If( ::lDrawFooters == Nil, .T., ::lDrawFooters )
      ::lFooting := ::lDrawFooters

      cHeading := If( Valtype( oColumn:cFooting ) == "B", ;
                      Eval( oColumn:cFooting ), oColumn:cFooting )

      If Valtype( cHeading ) == "C" .and. ( nAt := At( Chr( 13 ), cHeading ) ) > 0
         nOcurs := 1
         cRest := Substr( cHeading, nAt + 2 )

         While ( nAt := At( Chr( 13 ), cRest ) ) > 0
            nOcurs++
            cRest := Substr( cRest, nAt + 2 )
         EndDo

         nHeight := SBGetHeight( ::hWnd, If( oColumn:oFontFoot != Nil, ;
                                             oColumn:oFontFoot:hFont, hFont ), 0 )
         nHeight *= ( nOcurs + 1 )

         If ( nHeight + 1 ) > ::nHeightHead
            ::nHeightFoot := nHeight + 1
         EndIf

      Else
         nHeight := SBGetHeight( ::hWnd, If( oColumn:oFontFoot != Nil, ;
                                             oColumn:oFontFoot:hFont, hFont ), 0 ) + 1
         If nHeight > ::nHeightFoot .and. ::lFooting
            ::nHeightFoot := nHeight
         EndIf

      EndIf

   EndIf

   AAdd( ::aColumns , oColumn )
   AAdd( ::aColSizes, oColumn:nWidth )

   If ::aPostList != Nil // from ComboWBlock function

      If ATail( ::aColumns ):lComboBox

         If ValType( ::aPostList[ 1 ] ) == "A"
            ATail( ::aColumns ):aItems := ::aPostList[ 1 ]
            ATail( ::aColumns ):aData := ::aPostList[ 2 ]
            ATail( ::aColumns ):cDataType := ValType( ::aPostList[ 2, 1 ] )
         Else
            ATail( ::aColumns ):aItems := AClone( ::aPostList )
         EndIf

      EndIf

      ::aPostList := Nil

   EndIf


Return Self

* ============================================================================
* METHOD TSBrowse:AddSuperHead() Version 8.0 Feb/01/2008
* ============================================================================

Method AddSuperHead( nFromCol, nToCol, uHead, nHeight, aColors, l3dLook, uFont, uBitMap, lAdjust, lTransp, ;
                     lNoLines, nHAlign, nVAlign ) CLASS TSBrowse

   Local cHeading, nAt, nLheight, nOcurs, cRest, nLineStyle, nClrText, nClrBack, nClrLine, ;
         hFont := If( ::oFont != Nil, ::oFont:hFont, 0 )

   If Empty( ::aColumns )
//      Return Nil
   EndIf

   Default lAdjust  := .F., ;
           l3DLook  := ::aColumns[ nFromCol ]:l3DLookHead, ;
           nHAlign  := DT_CENTER, ;
           nVAlign  := DT_CENTER, ;
           lTransp  := .T., ;
           uHead    := ""

   uFont := If( uFont != Nil, If( ValType( uFont ) == "O", uFont:hFont, uFont ), uFont )

   If ! Empty( ::aColumns )
      hFont := If( ValType( ::aColumns[ nFromCol]:oFontHead ) == "O", ::aColumns[ nFromCol]:oFontHead:hFont, ;
               If( ::aColumns[ nFromCol]:oFontHead != Nil, ::aColumns[ nFromCol]:oFontHead, hFont ) )
   EndIf

   hFont := If( uFont != Nil, uFont, hFont )

   If ValType( aColors ) == "A"
      ASize( aColors, 3 )

      If ! Empty( ::aColumns )
         nClrText := If( aColors[ 1 ] != Nil, aColors[ 1 ], ::aColumns[ nFromCol ]:nClrHeadFore )
         nClrBack := If( aColors[ 2 ] != Nil, aColors[ 2 ], ::aColumns[ nFromCol ]:nClrHeadBack )
         nClrLine := If( aColors[ 3 ] != Nil, aColors[ 3 ], ::nClrLine )
      Else
         nClrText := If( aColors[ 1 ] != Nil, aColors[ 1 ], ::nClrHeadFore )
         nClrBack := If( aColors[ 2 ] != Nil, aColors[ 2 ], ::nClrHeadBack )
         nClrLine := If( aColors[ 3 ] != Nil, aColors[ 3 ], ::nClrLine )
      EndIf
   Else
      If ! Empty( ::aColumns )
         nClrText := ::aColumns[ nFromCol ]:nClrHeadFore
         nClrBack := ::aColumns[ nFromCol ]:nClrHeadBack
         nClrLine := ::nClrLine
      Else
         nClrText := ::nClrHeadFore
         nClrBack := ::nClrHeadBack
         nClrLine := ::nClrLine
      EndIf
   EndIf

   If uBitMap != Nil .and. ValType( uBitMap ) != "L"

      Default lNoLines := .T.
      cHeading := If( ValType( uBitMap ) == "B", Eval( uBitMap ), uBitMap )
      cHeading := If( ValType( cHeading ) == "O", Eval( ::bBitMapH, cHeading ), cHeading )
      nLheight := SBmpHeight( cHeading )

      If nHeight != Nil
         If nHeight < nLHeight .and. lAdjust
            nLheight := nHeight
         ElseIf nHeight > nLheight
            nLheight := nHeight
         EndIf
      EndIf

      If ( nLheight + 1 ) > ::nHeightSuper
         ::nHeightSuper := nLHeight + 1
      EndIf

   Else
      uBitMap := Nil
   EndIf

   cHeading := If( Valtype( uHead ) == "B", Eval( uHead ), uHead )

   Do Case

      Case Valtype( cHeading ) == "C" .and. ( nAt := At( Chr( 13 ), cHeading ) ) > 0

         Default lNoLines := .F.

         nOcurs := 1
         cRest := Substr( cHeading, nAt + 2 )

         While ( nAt := At( Chr( 13 ), cRest ) ) > 0
            nOcurs++
            cRest := Substr( cRest, nAt + 2 )
         EndDo

         nLheight := SBGetHeight( ::hWnd, hFont, 0 )
         nLheight *= ( nOcurs + 1 )
         nLheight := If( nHeight == Nil .or. nLheight > nHeight, nLheight, nHeight )

         If ( nLheight + 1 ) > ::nHeightSuper
            ::nHeightSuper := nLHeight + 1
         EndIf

      Case Valtype( cHeading ) == "C"
         Default lNoLines := .F.

         nLheight := SBGetHeight( ::hWnd, hFont, 0 )
         nLheight := If( nHeight == Nil .or. nLheight > nHeight, nLheight, nHeight )

         If ( nLheight + 1 ) > ::nHeightSuper
            ::nHeightSuper := nLHeight + 1
         EndIf

      Case Valtype( cHeading ) == "N" .or. ValType( cHeading ) == "O"
         Default lNoLines := .T.
         uBitMap := uHead

         If ValType( cHeading ) == "O"
            uHead := Eval( ::bBitMapH, cHeading )
         EndIf

         nLheight := SBmpHeight( uHead )
         uHead    := ""

         If nHeight != Nil
            If nHeight < nLHeight .and. lAdjust
               nLheight := nHeight
            ElseIf nHeight > nLheight
               nLheight := nHeight
            EndIf
         EndIf

         If ( nLheight + 1 ) > ::nHeightSuper
            ::nHeightSuper := nLHeight + 1
         EndIf

   EndCase

   nLineStyle := If( lNoLines, 0, 1 )

   AAdd( ::aSuperHead, { nFromCol, nToCol, uHead, nClrText, nClrBack, l3dLook, hFont, uBitMap, lAdjust, nLineStyle, ;
                         nClrLine, nHAlign, nVAlign, lTransp } )

Return Self

* ============================================================================
* METHOD TSBrowse:BiClr() Version 8.0 Feb/01/2008
* ============================================================================

METHOD BiClr( uClrOdd, uClrPair ) CLASS TSBrowse

   uClrOdd  := If( ValType( uClrOdd ) == "B", Eval( uClrOdd, Self ), ;
                   uClrOdd )

   uClrPair := If( ValType( uClrPair ) == "B", Eval( uClrPair, Self ), ;
                   uClrPair )

Return If( ::nAt % 2 > 0, uClrOdd, uClrPair )

* ============================================================================
* METHOD TSBrowse:ChangeFont() Version 8.0 Feb/01/2008
* ============================================================================

METHOD ChangeFont( oFont, nColumn, nLevel ) CLASS TSBrowse

   Local nEle, ;
         lDrawFooters := If( ::lDrawFooters != Nil, ::lDrawFooters, .F. )

   Default nColumn := 0   // all columns

   If nColumn == 0

      If nLevel == Nil

         For nEle := 1 TO Len( ::aColumns )
             ::aColumns[ nEle ]:oFont := oFont
         Next

         If ::lDrawHeaders

            For nEle := 1 TO Len( ::aColumns )
               ::aColumns[ nEle ]:oFontHead := oFont
            Next

         EndIf

         If ::lFooting .and. lDrawFooters

            For nEle := 1 TO Len( ::aColumns )
               ::aColumns[ nEle ]:oFontFoot := oFont
            Next

         EndIf

      Else

         Do Case

            Case nLevel == 1   // nLevel 1 = Cells

               For nEle := 1 TO Len( ::aColumns )
                  ::aColumns[ nEle ]:oFont := oFont
               Next

            Case nLevel == 2  .and. ::lDrawHeaders  // nLevel 2 = Headers

               For nEle := 1 TO Len( ::aColumns )
                  ::aColumns[ nEle ]:oFontHead := oFont
               Next

            Case nLevel == 3 .and. ::lFooting .and. lDrawFooters    // nLevel 3 = Footers

               For nEle := 1 TO Len( ::aColumns )
                  ::aColumns[ nEle ]:oFontFoot := oFont
               Next

         EndCase

      EndIf

   Else

      If nLevel == Nil

         ::aColumns[ nColumn ]:oFont := oFont

         If ::lDrawHeaders
            ::aColumns[ nColumn ]:oFontHead := oFont
         EndIf

         If ::lFooting .and. lDrawFooters
            ::aColumns[ nColumn ]:oFontFoot := oFont
         EndIf

      Else

         Do Case

            Case nLevel == 1    // nLevel 1 = Cells

               ::aColumns[ nColumn ]:oFont := oFont

            Case nLevel == 2 .and. ::lDrawHeaders  // nLevel 2 = Headers

               ::aColumns[ nColumn ]:oFontHead := oFont

            Case nLevel == 3 .and. ::lFooting .and. lDrawFooters    // nLevel 3 = Footers

               ::aColumns[ nColumn ]:oFontFoot := oFont

         EndCase

      EndIf

   EndIf

   If ::lPainted
      SetHeights( Self )
      ::Refresh( .F. )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:DbSkipper() Version 8.0 Feb/01/2008
* ============================================================================

METHOD DbSkipper( nToSkip ) CLASS TSBrowse

   Local nSkipped := 0

   Default nToSkip := 0, ;
           ::nAt := 1

   If nToSkip == 0 .or. ( ::cAlias )->( LastRec() ) == 0
      ( ::cAlias )->( DbSkip( 0 ) )
   ElseIf nToSkip > 0 .and. ! ( ::cAlias )->( EoF() ) // going down

      While nSkipped < nToSkip

         ( ::cAlias )->( DbSkip( 1 ) )

         If ::bFilter != Nil

            While ! Eval( ::bFilter ) .and. ! EoF()
              ( ::cAlias )->( DbSkip( 1 ) )
            EndDo

         EndIf

         If ( ::cAlias )->( Eof() )

            If ::lAppendMode
               nSkipped ++
            Else
               ( ::cAlias )->( DbSkip( -1 ) )
            EndIf

            Exit

         EndIf

         nSkipped ++

      Enddo

   ElseIf nToSkip < 0 .and. ! ( ::cAlias )->( BoF() )  // going up

      While nSkipped > nToSkip

         ( ::cAlias )->( DbSkip( -1 ) )

         If ::bFilter != Nil

            While ! Eval( ::bFilter ) .and. ! BoF()
               ( ::cAlias )->( DbSkip( -1 ) )
            EndDo

         EndIf

         If ( ::cAlias )->( Bof() )
            ( ::cAlias )->( DbGoTop() )
            Exit
         EndIf

         nSkipped --

      Enddo

   EndIf

   ::nAt += nSkipped

Return nSkipped

* ============================================================================
* METHOD TSBrowse:Default() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Default() CLASS TSBrowse

    Local nI, nTemp, nElements, aFields, nHeight, nStyle, nMin, nMax, nPage, ;
          bBlock, aJustify, cBlock, ;
          nWidth    := 0, ;
          nTxtWid   := 0, ;
          nMaxWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ), ;
          cAlias    := Alias(), ;
          hFont     := If( ::oFont != Nil, ::oFont:hFont, 0 ), ;
          nAdj      := ::nAdjColumn

   Default ::aHeaders  := {}, ;
           ::aColSizes := {}, ;
           ::nOldCell  := 1, ;
           ::lIsTxt    := "TEXT_" $ ::cAlias
           ::lIsArr    := ::cAlias == "ARRAY"

   If ::bLine == Nil .and. Empty( ::aColumns )

      If Empty( ::cAlias )
         ::cAlias := cAlias
      Else
         cAlias := ::cAlias
      EndIf

      If Upper( ::oWnd:ClassName() ) != "TDIALOG" .and. ::lFirstPaint == Nil

         If ::lDrag
            ::nHeightCell := ::nHeightHead :=  SBGetHeight( ::hWnd, hFont, 0 )
         EndIf

         Return Self

      EndIf

      If ! EmptyAlias( ::cAlias ) .and. ! ::lIsArr .and. ! ::lIsTxt
         ::LoadFields()
      EndIf

   EndIf

   ::lFirstPaint := .F.

   If ::bLine != Nil .and. Empty(::aColumns)

      Default nElements := Len( Eval(::bLine) )

      aJustify := Afill( Array( nElements ), 0 )

      If Len( ::aHeaders ) < nElements

         If ::oTree == Nil
            ::aHeaders := Array( nElements )

            For nI := 1 to nElements
                ::aHeaders[ nI ] := ( cAlias )->( FieldName( nI ) )
            Next
         Else
            ::aHeaders := Array( nElements )
            AFill( ::aHeaders, "" )
         EndIf
      EndIf

      If ValType( ::aColSizes ) == "B"
         ::aColSizes := Eval( ::aColSizes )
      EndIf

      aFields := Eval( ::bLine )

      If Len( ::GetColSizes() ) < nElements
         ::aColSizes := Afill( Array( nElements ), 0 )

         nTxtWid := SBGetHeight( ::hWnd, hFont, 1 )

         For nI := 1 TO nElements
            ::aColSizes[ nI ] := If( ValType( aFields[ nI ] ) != "C", 16, ; // Bitmap handle
                                     ( nTxtWid * Max( Len( ::aHeaders[ nI ] ), Len( aFields[ nI ] ) ) + 1 ) )
         Next

      EndIf

      If ::oItem != Nil
         ::nLineStyle := 0
      EndIf

      For nI := 1 To nElements

          If ValType( aFields[ nI ] ) == "N" .or. ValType( aFields[ nI ] ) == "D"
             aJustify[ nI ] := 2
          ElseIf ValType( aFields[ nI ] ) == "B"

             If ValType( Eval( aFields[ nI ] ) ) == "N" .or. ValType( Eval( aFields[ nI ] ) ) == "D"

                aJustify[ nI ] := 2
             Else
                aJustify[ nI ] := 0
             EndIf
          Else
             aJustify[ nI ] := 0
          EndIf
      Next

      For nI := 1 To nElements

         bBlock := If( ValType( Eval( ::bLine )[ nI ] ) == "B", Eval( ::bLine )[ nI ], MakeBlock( Self, nI ) )
         cBlock := If( ValType( Eval( ::bLine )[ nI ] ) == "B", ::aLine[ nI ], "{||" + cValToChar( ::aLine[ nI ] ) + ;
                       "}" )

         ::AddColumn( TSColumn():New( ::aHeaders[ nI ], bBlock,, { ::nClrText, ::nClrPane, ::nClrHeadFore, ;
                                      ::nClrHeadBack, ::nClrFocuFore, ::nClrFocuBack }, {aJustify[ nI ], 1}, ;
                                      ::aColSizes[ nI ],, ValType( Eval( ::bLine )[ nI ] ) == "B",,,,,,, ;
                                      5,, {.F., .T.},, Self, cBlock ) )
      Next

      If Upper( ::oWnd:ClassName() ) != "TDIALOG"

         If ::lDrag
            ::nHeightCell := ::nHeightHead := SBGetHeight( ::hWnd, hFont, 0 )
         EndIf

         Return Self
      EndIf

   EndIf

   ::lIsDbf := ! EmptyAlias( ::cAlias ) .and. ! ::lIsArr .and. ! ::lIsTxt .and. ::cAlias != "TREE_"
   ASize( ::aColSizes, Len( ::aColumns ) ) // make sure they match sizes

   // rebuild build the aColSize, it's needed to Horiz Scroll etc
   // and expand selected column to flush table window right

   For nI := 1 To Len( ::aColumns )

      nTemp := ::aColSizes[ nI ] := ::aColumns[ nI ]:nWidth

      If ! Empty( nAdj ) .and. ( nWidth + nTemp > nMaxWidth )

         If nAdj < nI
           ::aColumns[ nAdj ]:nWidth := ::aColSizes[ nAdj ] += ( nMaxWidth - nWidth )
         EndIf

         nAdj := 0
      EndIf

      nWidth += nTemp

      If ::lIsDbf .and. ! Empty( ::aColumns[ nI ]:cOrder ) .and. ! ::aColumns[ nI ]:lEdit

         If ::nColOrder == 0
            ::SetOrder( nI )
         EndIf

         ::aColumns[ nI ]:lIndexCol := .T.
      EndIf

      If ValType( ::aColumns[ nI ]:cFooting ) $ "CB" // informs browse that it has footings to display
         ::lDrawFooters := If( ::lDrawFooters == Nil, .T., ::lDrawFooters )
         ::lFooting := ::lDrawFooters
         nHeight := SBGetHeight( ::hWnd, If( ::aColumns[ nI ]:oFontFoot != Nil, ;
                                 ::aColumns[ nI ]:oFontFoot:hFont, hFont ), 0 ) + 1
         If nHeight > ::nHeightFoot .and. ::lFooting
            ::nHeightFoot := nHeight
         EndIf

      EndIf

   Next

   // now catch the odd-ball where last column doesn't fill box
   If ! Empty( nAdj ) .and. nWidth < nMaxWidth .and. nAdj < nI
      ::aColumns[ nAdj ]:nWidth := ::aColSizes[ nAdj ] += ( nMaxWidth - nWidth )
   EndIf

   If ::bLogicLen != Nil
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), Eval( ::bLogicLen ) )
   EndIf

   If ! ::lNoVScroll
      nMin  := Min( 1, ::nLen )
      nMax  := Min( ::nLen, MAX_POS )
      nPage := Min( ::nRowCount(), ::nLen )
      ::oVScroll := TScrollBar():WinNew( nMin, nMax, nPage, .T., Self )
   EndIf

   #ifdef USE_CONTEXT
   If ::oCtx == Nil .and. ! Empty( ::cAlias ) .and. ! ::lIsArr .and. ! ::lIsTxt .and. ::lAutoCtx

      // a context hasn't been established, and not browsing arrays
      If ::lDbfObj
        ::oCtx := TWAContext():New( ::oDbf:cAlias )
      Else
        ::oCtx := TWAContext():New( ::cAlias )
      EndIf

   EndIf
   #EndIf

   If ::cDriver == Nil
       ::ResetBarPos( .T. )   // first time call inits RDD specific ORD functions
   EndIf

   If ::oTree != Nil
      ::lDrawHeaders := .F.
      ::nLineStyle := 0
      ::lNoHScroll := .F.
      ::nFreeze := Min( 2, ( Len( ::aColumns ) - 1 ) )
   EndIf

   If ! ::lNoHScroll

      If ! Empty( ::cAlias ) .and. ::lIsTxt
         nTxtWid := Max( 1, GetTextWidth( 0, "B", hFont ) )
         nMin := 1
         nMax := ::oTxtFile:nMaxLineLength - Int( nMaxWidth / nTxtWid )
         ::oHScroll := TScrollBar():WinNew( nMin, nMax,, .F., Self )
      Else
         nMin := Min( 1, Len( ::aColumns ) )
         nMax := Len( ::aColumns )
         ::oHScroll := TScrollBar():WinNew( nMin, nMax,, .F., Self )
      EndIf

   EndIf

   For nI := 1 To Len( ::aColumns )

      If ::aColumns[ nI ]:oFont == Nil
         ::aColumns[ nI ]:oFont := ::oFont
      EndIf

      If ::aColumns[ nI ]:oFontHead == Nil
         ::aColumns[ nI ]:oFontHead := ::oFont
      EndIf

      If ::aColumns[ nI ]:oFontFoot == Nil
         ::aColumns[ nI ]:oFontFoot := ::oFont
      EndIf

      If ::lLockFreeze .and. ::nFreeze >= nI
         ::aColumns[ nI ]:lNoHilite := .T.
      EndIf

   Next

   ::nHeightHead := If( ::lDrawHeaders, ::nHeightHead, 0 )
   ::nHeightFoot := If( ::lFooting .and. ::lDrawFooters, ::nHeightFoot, 0 )

   If ! ::lNoVScroll
      nPage := Min( ::nRowCount(), ::nLen )
      ::oVScroll:SetPage( nPage, .T. )
   EndIf

   If ! ::lNoHScroll
      nPage := 1
      ::oHScroll:SetPage( nPage, .T. )
   EndIf

   If Len( ::aColumns ) > 0
      ::HiliteCell( Max( ::nCell, ::nFreeze + 1 ) )
   EndIf

   ::nOldCell := ::nCell
   nLapsus    := Seconds()

   If ::oBrush != Nil .and. ::oBrush:hBrush != ::oWnd:oBrush:hBrush
      ::oBrush:nCount++
   EndIf

   If Upper( ::oWnd:ClassName() ) == "TDIALOG"
      ::Move( ::nTop, ::nLeft, ::nWidth(), ::nHeight(), .T. )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:Del() Version 8.0 Feb/01/2008
* Only for array browse. (ListBox behavior)
* ============================================================================

METHOD Del( nItem ) CLASS TSBrowse

   Default nItem := ::nAt

   If ! ::lIsArr
      Return Self
   EndIf

   ADel( ::aArray, nItem )
   ASize( ::aArray, Len( ::aArray ) - 1 )
   ::nLen := Eval( ::bLogicLen )
   ::Refresh()

Return Self

* ============================================================================
* METHOD TSBrowse:DelColumn() Version 8.0 Feb/01/2008
* ============================================================================

METHOD DelColumn( nPos ) CLASS TSBrowse

   Local oCol, nMin, nMax, nI, ;
         nLen := Len( ::aSuperHead )

   Default nPos := 1

	If Len( ::aColumns ) == 1                     // cannot delete last column
		Return Nil                                 // ... or Nil if last column
   EndIf

	If nPos < 1
		nPos := 1
   ElseIf nPos > Len( ::aColumns )
		nPos := Len( ::aColumns )
   EndIf

   oCol := ::aColumns[ nPos ]
   ASize( ADel( ::aColumns, nPos ), Len( ::aColumns ) - 1 )
   ASize( ADel( ::aColSizes, nPos ), Len( ::aColSizes ) - 1 )

   If ::nColOrder == nPos                        // deleting a ::SetOrder() column
		::nColOrder := 0                           // to avoid runtime error
		::cOrderType := ""
   ElseIf ::nColOrder != 0 .and. ::nColOrder > nPos .and. ;
          ::nColOrder <= Len( ::aColumns )
		::nColOrder --
   EndIf

   If ::nCell > Len( ::aColSizes )
      If ! ::IsColVisible( ::nCell - 1 )
         ::GoLeft()
      Else
         ::nCell--
      EndIf
   EndIf

   ::HiliteCell( ::nCell )                       // make sure we have a hilited cell

   If ! ::lNoHScroll
      nMin := Min( 1, Len( ::aColumns ) )
      nMax := Len( ::aColumns )
      ::oHScroll := TScrollBar():WinNew( nMin, nMax,, .F., Self )
      ::oHScroll:SetRange( 1, Len( ::aColumns ) )
      ::oHScroll:SetPage( 1 , .T. )

      If ::nCell == Len( ::aColSizes )
         ::oHScroll:GoBottom()
      Else
         ::oHScroll:SetPos( ::nCell )
      EndIf

   EndIf

   If ! Empty( ::aSuperHead )

      For nI := 1 To nLen

         If nPos >= ::aSuperHead[ nI, 1 ] .and. nPos <= ::aSuperHead[ nI, 2 ]

            ::aSuperHead[ nI, 2 ] --

            If ::aSuperHead[ nI, 2 ] < ::aSuperHead[ nI, 1 ]
               ASize( ADel( ::aSuperHead, nI ), Len( ::aSuperHead ) - 1 )
            EndIf

         ElseIf nPos < ::aSuperHead[ nI, 1 ]
            ::aSuperHead[ nI, 1 ] --
            ::aSuperHead[ nI, 2 ] --
         EndIf

      Next

   EndIf

   ::SetFocus()
   ::Refresh( .F. )

Return oCol

* ============================================================================
* METHOD TSBrowse:DeleteRow() Version 8.0 Feb/01/2008
* ============================================================================

METHOD DeleteRow() CLASS TSBrowse

   Local lRecall, lUpStable, nAt, nRowPos, nRecNo, lRefresh, cAlias, ;
         lEval

   If ! ::lCanDelete
      Return Self
   EndIf

   If ::lDbfObj
      cAlias := ::oDbf:cAlias
   ElseIf ::lIsDbf
      cAlias := ::cAlias
   EndIf


   nRecNo := ( cAlias  )->( RecNo() )

   lRecall := ! Set( _SET_DELETED )
   lUpStable := ! lRecall

   If ! ::lIsTxt .and. ::oTree == Nil

      If ::lConfirm .and. ! MsgYesNo( If( ::lIsDbf, ::aMsg[ 37 ], ::aMsg[ 38 ] ), ::aMsg[ 39 ] )
         Return Self
      EndIf

      If ::lAppendMode
         Return Self
      EndIf

      ::SetFocus()

      If ::lIsDbf
         ( cAlias )->( DbGoTo( nRecNo ) )
      EndIf

      Do Case

         Case ::lIsDbf .and. ::oDbf == Nil

              lEval := .T.

              If ::bDelete != Nil
                 lEval := Eval( ::bDelete, nRecNo, Self )
              EndIf

              If ValType( lEval ) == "L" .and. ! lEval
                 Return Self
              EndIf

              If ! ( cAlias )->( RLock() )
                 MsgStop( ::aMsg[ 40 ] , ::aMsg[ 28 ] )
                 Return Self
              EndIf

              If ! ( cAlias )->( Deleted() )
                 ( cAlias )->( DbDelete() )
                 ( cAlias )->( DbUnlock() )
                 ::nLen := ( cAlias )->( Eval( ::bLogicLen ) )

                 If lUpStable
                    ( cAlias )->( DbSkip() )
                    lRefresh :=  ( cAlias )->( EOF() )
                    ( cAlias )->( DbSkip( -1 ) )
                    ::nRowPos -= If( lRefresh .and. ;
                                     ! ( cAlias )->( BOF() ), 1, 0 )
                    ::Refresh( .T. )
                 EndIf

              ElseIf lRecall
                 ( cAlias )->( DbRecall() )
                 ( cAlias )->( DbUnlock() )
              EndIf

              If ::lCanAppend .and. ::nLen == 0
                 ::nRowPos := ::nColPos := 1
                 ::PostMsg( WM_KEYDOWN, VK_DOWN, nMakeLong( 0, 0 ) )
              EndIf

              If ::bPostDel != Nil
                 Eval( ::bPostDel , Self )
              EndIf

              ::lHasChanged := .T.

         Case ::oDbf != Nil

              lEval := .T.

              If ::bDelete != Nil
                 lEval := Eval( ::bDelete, nRecNo, Self )
              EndIf

              If ( ValType( lEval ) == "L" .and. ! lEval )
                 Return Self
              EndIf

              If ! ( cAlias )->( Deleted() )

                 ::oDbf:Delete()
                 ::nLen := ( cAlias )->( Eval( ::bLogicLen ) )

                 If lUpStable
                    ( cAlias )->( DbSkip() )
                    lRefresh :=  ( cAlias )->( EOF() )
                    ( cAlias )->( DbSkip( -1 ) )
                    ::nRowPos -= If( lRefresh .and. ;
                                     ! ( cAlias )->( BOF() ), 1, 0 )
                    ::Refresh( .T. )
                 EndIf

              ElseIf lRecall
                 ::oDbf:Recall()
              EndIf

              If ::lCanAppend .and. ::nLen == 0
                 ::nRowPos := ::nColPos := 1
                 ::PostMsg( WM_KEYDOWN, VK_RETURN, nMakeLong( 0, 0 ) )
              EndIf

              If ::bPostDel != Nil
                 Eval( ::bPostDel , Self )
              EndIf

              ::lHasChanged := .T.

         Case ::lIsArr

              nAt := ::nAt
              nRowPos := ::nRowPos

              lEval := .T.

              If ::bDelete != Nil
                 lEval := Eval( ::bDelete, nAt, Self )
              EndIf

              If ValType( lEval ) == "L" .and. ! lEval
                 Return Self
              EndIf

              ADel( ::aArray, nAt )
              ASize( ::aArray, Len( ::aArray ) - 1 )

              If Len( ::aArray ) == 0
                 ::aArray := { AClone( ::aDefValue ) }
                 If ::aArray[ 1, 1 ] == Nil
                    ADel( ::aArray[ 1 ], 1 )
                    ASize( ::aArray[ 1 ], Len( ::aArray[ 1 ] ) - 1 )
                 EndIf
              EndIf

              If ::bPostDel != Nil
                 Eval( ::bPostDel , Self )
              EndIf

              ::lHasChanged := .T.
              ::nLen := Len( ::aArray )
              ::nAt := Min( nAt, ::nLen )
              ::nRowPos := Min( nRowPos, ::nLen )
              ::Refresh( .T. )
              ::DrawSelect()

      Endcase

   Else
      ::SetFocus()
      ::DrawSelect()
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:Destroy() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Destroy() CLASS TSBrowse


   Default ::lDestroy := .F.

   If ::uBmpSel != Nil .and. ::lDestroy
      ::uBmpSel:End()
   EndIf

   If ::oBmpCursor != Nil
      ::oBmpCursor:End()
   EndIf

   If ::oCtx != Nil
      ::oCtx:Destroy()
   EndIf

   If ::oTxtFile != Nil
      ::oTxtFile:Close()
   EndIf

   If ::oFont != Nil
      ::oFont:End()
   EndIf

   If ::oBrush != Nil
      ::oBrush:End()
   EndIf

   If ::oVScroll != Nil
      ::oVScroll:Destroy()
   EndIf

   If ::oHScroll != Nil
      ::oHScroll:Destroy()
   EndIf

   If ! Empty( ::hWnd )
      ::UnLink()
   EndIf

   ::hWnd = 0

Return Nil

* ============================================================================
* METHOD TSBrowse:Display() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Display() CLASS TSBrowse

   Local nRecs, nTxtWid, nMin, nMax, nPage, ;
         nMaxWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ), ;
         hFont     := If( ::oFont != Nil, ::oFont:hFont, 0 )

   Default ::lFirstPaint := .T.

   If Empty( ::aColumns ) .and. ! ::lFirstPaint
      Return 0
   EndIf

   ::BeginPaint()

   If ::oVScroll != Nil .and. ::nLen > ::nRowCount() .and. ::oVScroll:nMax != Min( ::nLen, MAX_POS )

      nMin  := Min( 1, ::nLen )
      nMax  := Min( ::nLen, MAX_POS )
      nPage := Min( ::nRowCount(), ::nLen )
      ::oVScroll := TScrollBar():WinNew( nMin, nMax, nPage, .T., Self )
      ::ResetBarPos()

   EndIf

   If ::oHScroll != Nil

      If ::lIsTxt
			 nTxtWid := Max( 1, GetTextWidth( 0, "B", hFont ) )
			::oHScroll:SetRange( 1, ::oTxtFile:nMaxLineLength - Int( nMaxWidth / nTxtWid ) )
		Else
			::oHScroll:SetRange( 1, Len( ::aColumns ) )
      EndIf

   EndIf

   ::Paint()
   ::EndPaint()

Return 0

* ============================================================================
* METHOD TSBrowse:DrawHeaders() Version 8.0 Feb/01/2008
* ============================================================================

METHOD DrawHeaders( lFooters ) CLASS TSBrowse

   Local nI, nJ, nBegin, nStartCol, oColumn, l3DLook, nClrFore, lAdjBmp, nAlign, nClrBack, hFont, cFooting, ;
         cHeading, hBitMap, nLastCol, lMultiLine, nVertText, nClrTo, lOpaque, lBrush, ;
         nMaxWidth    := ::nWidth() , ;
         aColSizes    := AClone( ::aColSizes ), ;   // use local copies for speed
         nHeightHead  := ::nHeightHead, ;
         nHeightFoot  := ::nHeightFoot

   Local nHeightSuper := ::nHeightSuper, ;
         nVAlign      := 1, ;
         l3DText, nClr3dL, nClr3dS

   Local hWnd         := ::hWnd, ;
         hDC          := ::hDc, ;
         nClrText     := ::nClrText, ;
         nClrPane     := ::nClrPane, ;
         nClrHeadFore := ::nClrHeadFore, ;
         nClrHeadBack := ::nClrHeadBack, ;
         nClrFootFore := ::nClrFootFore, ;
         nClrFootBack := ::nClrFootBack, ;
         nClrOrdeFore := ::nClrOrdeFore, ;
         nClrOrdeBack := ::nClrOrdeBack, ;
         nClrLine     := ::nClrLine

   Default lFooters := .F.

   If Empty( ::aColumns )
      Return Self
   EndIf

   If ::aColSizes == Nil .or. Len( ::aColSizes ) < Len( ::aColumns )
      ::aColSizes := {}
      For nI := 1 To Len( ::aColumns )
         AAdd( ::aColSizes, ::aColumns[ nI ]:nWidth )
      Next
   EndIf

   nClrBack := If( ::nPhantom == -1, ATail( ::aColumns ):nClrHeadBack, nClrPane )
   nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )
   nClrFore := If( ::nPhantom == -1, ATail( ::aColumns ):nClrFootBack, nClrPane )
   nClrFore := If( ValType( nClrFore ) == "B", Eval( nClrFore ), nClrFore )
   l3DLook  := If( ::nPhantom == -1, ATail( ::aColumns ):l3DLookHead, .F. )

   If ::oPhant == Nil
      // "Phantom" column; :nPhantom hidden IVar
      ::oPhant := TSColumn():New(        "", ; // cHeading
                              {|| "" }, ; // bdata
                                   nil, ; // cPicture
                 { nClrText, nClrPane,, ;
              nClrBack,,,,,,nClrFore }, ; // aColors
                                   nil, ; // aAlign
                            ::nPhantom, ; // nWidth
                                   nil, ; // lBitMap
                                   nil, ; // lEdit
                                   nil, ; // bValid
                                   .T., ; // lNoLite
                                   nil, ; // cOrder
                                   nil, ; // cFooting
                                   nil, ; // bPrevEdit
                                   nil, ; // bPostEdit
                                   nil, ; // nEditMove
                                   nil, ; // lFixLite
                  { l3DLook, l3DLook }, ;
                                   nil, ;
                                  Self  )
      Else
         ::oPhant:nClrFore := nClrText
         ::oPhant:nClrBack := nClrBack
         ::oPhant:nWidth   := ::nPhantom
         ::oPhant:l3DLookHead := l3DLook
      EndIf

   nLastCol := Len( ::aColumns ) + 1
   AAdd( aColSizes, ::nPhantom )

   nJ := nStartCol := 0

   nBegin := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1, ::nColPos - ::nFreeze ), ;
                      ::nColPos - ::nFreeze ), nLastCol )

   If Empty( ::aColumns )
      Return Self
   EndIf

   If ! Empty( ::aSuperHead ) .and. ! lFooters
      ::DrawSuper()
   EndIf

   For nI := nBegin To nLastCol

      If nStartCol > nMaxWidth
         Exit
      EndIf

      nJ := If( nI < ::nColPos, nJ + 1, nI )

      oColumn := If( nJ > Len( ::aColumns ), ::oPhant, ::aColumns[ nJ ] )

      If ::lDrawHeaders .and. ! lFooters

         nVertText := 0

         If nLoWord( oColumn:nHAlign ) == DT_VERT

            If oColumn:oFontHead != Nil
               cHeading := oColumn:oFontHead:cFaceName
               nAlign   := oColumn:oFontHead:nHeight
               nVAlign  := oColumn:oFontHead:nWidth
            ElseIf ::oFont != Nil
               cHeading := ::oFont:cFaceName
               nAlign   := ::oFont:nHeight
               nVAlign  := ::oFont:nWidth
            Else
               cHeading := "Arial"
               nAlign   := -11
               nVAlign  := 0
            EndIf

            hFont := CreateFont( { nAlign, nVAlign, 900, 0, 0, .F., .F., .F., 1, 0, 0, 0, 0, cHeading } )

            nVAlign   := 2
            nAlign    :=  1
            nVertText := 1

         Else
            hFont    := If( oColumn:oFontHead == Nil, ::oFont, oColumn:oFontHead )
            hFont    := If( ValType( hFont ) == "B", Eval( hFont, 0, nJ, Self ), ;
                           hFont )
            hFont    := If( hFont == Nil, 0, hFont:hFont )
         EndIf

         l3DLook := oColumn:l3DLookHead
         nAlign  := If( ValType( oColumn:nHAlign ) == "B", ;
                       Eval( oColumn:nHAlign ), oColumn:nHAlign )

         If ( nClrFore := If( ::nColOrder == nI, oColumn:nClrOrdeFore, oColumn:nClrHeadFore ) ) == Nil
            nClrFore := If( ::nColOrder == nI, nClrOrdeFore, nClrHeadFore )
         EndIf

         nClrFore := If( ValType( nClrFore ) == "B", Eval( nClrFore ), nClrFore )

         If ( nClrBack := If( ::nColOrder == nI, oColumn:nClrOrdeBack, oColumn:nClrHeadBack ) ) == Nil
            nClrBack := If( ::nColOrder == nI, nClrOrdeBack, nClrHeadBack )
         EndIf

         nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )
         lBrush   := Valtype( nClrBack ) == "O"

         If ValType( nClrBack ) == "A"
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo   := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )
         Else
            nClrTo   := nClrBack
         EndIf

         cHeading   := If( Valtype( oColumn:cHeading ) == "B", Eval( oColumn:cHeading ), oColumn:cHeading )
         hBitMap    := If( ValType( oColumn:uBmpHead ) == "B", Eval( oColumn:uBmpHead ), oColumn:uBmpHead )
         hBitMap    := If( ValType( hBitMap ) == "O", Eval( ::bBitMapH, hBitMap ), hBitMap )
         lAdjBmp    := oColumn:lAdjBmpHead
         lOpaque    := lAnd( oColumn:nOpaque, 2 )
         lMultiLine := Valtype( cHeading ) == "C" .and. At( Chr( 13 ), cHeading ) > 0
         Default hBitMap := 0

         If lMultiLine
            nVAlign := DT_TOP
         EndIf

         If oColumn:l3DTextHead != Nil
            l3DText := oColumn:l3DTextHead
            nClr3dL := oColumn:nClr3DLHead
            nClr3dS := oColumn:nClr3DSHead
            nClr3dL := If( ValType( nClr3dL ) == "B", ;
                           Eval( nClr3dL, 0, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", ;
                           Eval( nClr3dS, 0, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(      hWnd, ;  // 1
                           hDC, ;  // 2
                             0, ;  // 3
                     nStartCol, ;  // 4
               aColSizes[ nJ ], ;  // 5
                      cHeading, ;  // 6
                        nAlign, ;  // 7
                      nClrFore, ;  // 8
                      nClrBack, ;  // 9
                         hFont, ;  // 10
                       hBitMap, ;  // 11
                   nHeightHead, ;  // 12
                       l3DLook, ;  // 13
                             1, ;  // 14 nLineStyle
                      nClrLine, ;  // 15
                             1, ;  // 16 1=Header 2=Footer 3=Super
                   nHeightHead, ;  // 17
                   nHeightFoot, ;  // 18
                  nHeightSuper, ;  // 19
                       lAdjBmp, ;  // 20
                    lMulTiLine, ;  // 21
                       nVAlign, ;  // 22
                     nVertText, ;  // 23
                        nClrTo, ;  // 24
                       lOpaque, ;  // 25
                    If( lBrush, ;
          nClrBack:hBrush, 0 ), ;  // 26
                       l3DText, ;  // 27  3D text
                       nClr3dL, ;  // 28  3D text light color
                       nClr3dS )   // 29  3D text shadow color

         nVAlign := 1

         If nLoWord( oColumn:nHAlign ) == DT_VERT
            DeleteObject( hFont )
         EndIf

      EndIf

      If ::lFooting .and. ::lDrawFooters

         hFont   := If( oColumn:oFontFoot == Nil, ::oFont, oColumn:oFontFoot )
         hFont   := If( ValType( hFont ) == "B", Eval( hFont, 0, nJ, Self ), ;
                        hFont )
         hFont   := If( hFont == Nil, 0, hFont:hFont )
         l3DLook := oColumn:l3DLookFoot

         ::oPhant:l3DLookFoot := l3DLook

         nAlign   := If( ValType( oColumn:nFAlign ) == "B", Eval( oColumn:nFAlign ), oColumn:nFAlign )
         nClrFore := If( oColumn:nClrFootFore != Nil, oColumn:nClrFootFore , nClrFootFore )
         nClrFore := If( ValType( nClrFore ) == "B", Eval( nClrFore ), nClrFore )
         nClrBack := If( oColumn:nClrFootBack != Nil, oColumn:nClrFootBack, nClrFootBack )
         nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )
         lBrush   := Valtype( nClrBack ) == "O"

         If ValType( nClrBack ) == "A"
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo   := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", ;
                            Eval( nClrBack ), nClrBack )
         Else
            nClrTo   := nClrBack
         EndIf

         cFooting := If( Valtype( oColumn:cFooting ) == "B", ;
                           Eval( oColumn:cFooting ), oColumn:cFooting )

         If ValType( cFooting ) == "O"
            oColumn:uBmpFoot := cFooting
            cFooting := ""
         EndIf

         hBitMap    := If( ValType( oColumn:uBmpFoot ) == "B", Eval( oColumn:uBmpFoot ), oColumn:uBmpFoot )
         hBitMap    := If( ValType( hBitMap ) == "O", Eval( ::bBitMapH, hBitMap ), hBitMap )
         lOpaque    := lAnd( oColumn:nOpaque, 4 )
         lAdjBmp    := oColumn:lAdjBmpFoot
         lMultiLine := Valtype( cFooting ) == "C" .and. At( Chr( 13 ), cFooting ) > 0
         Default hBitMap := 0

         If oColumn:l3DTextFoot != Nil
            l3DText := oColumn:l3DTextFoot
            nClr3dL := oColumn:nClr3DLFoot
            nClr3dS := oColumn:nClr3DSFoot
            nClr3dL := If( ValType( nClr3dL ) == "B", ;
                           Eval( nClr3dL, 0, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", ;
                           Eval( nClr3dS, 0, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(     hWnd, ;  // 1
                          hDC, ;  // 2
                ::nRowCount(), ;  // 3
                    nStartCol, ;  // 4
                aColSizes[nJ], ;  // 5
                     cFooting, ;  // 6
                       nAlign, ;  // 7
                     nClrFore, ;  // 8
                     nClrBack, ;  // 9
                        hFont, ;  // 10
                      hBitMap, ;  // 11
                  nHeightFoot, ;  // 12
                      l3DLook, ;  // 13
                            1, ;  // 14  nLineStyle
                     nClrLine, ;  // 15
                            2, ;  // 16  1=Header 2=Footer 3=Super
                  nHeightHead, ;  // 17
                  nHeightFoot, ;  // 18
                 nHeightSuper, ;  // 19
                      lAdjBmp, ;  // 20
                   lMultiLine, ;  // 21
                      nVAlign, ;  // 22
                            0, ;  // 23 nVertText
                       nClrTo, ;  // 24
                      lOpaque, ;  // 25
                   If( lBrush, ;
         nClrBack:hBrush, 0 ), ;  // 26
                      l3DText, ;  // 27  3D text
                      nClr3dL, ;  // 28  3D text light color
                      nClr3dS )   // 29  3D text shadow color
      EndIf

      nStartCol += aColSizes[nJ]

   Next

Return Self

* ============================================================================
* METHOD TSBrowse:_DrawIcon() Version 8.0 Feb/01/2008
* ============================================================================

METHOD _DrawIcon( nIcon, lFocused ) CLASS TSBrowse

   Local nIconsByRow := Int( ::nWidth() / 50 )
   Local nRow := Int( --nIcon / nIconsByRow )
   Local nCol := If( nRow > 0, nIcon % ( nRow * nIconsByRow ), nIcon )

   DEFAULT lFocused := .F.

   If lFocused
      DrawIconFocus( ::GetDC(), ( nRow * 50 ) + 10, ( nCol * 50 ) + 10,;
                     ExtractIcon( "user.exe" ) )
   Else
      DrawIcon( ::GetDC(), ( nRow * 50 ) + 10, ( nCol * 50 ) + 10,;
                ExtractIcon( "user.exe" ) )
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:DrawIcons() Version 8.0 Feb/01/2008
* ============================================================================

METHOD DrawIcons() CLASS TSBrowse

   Local oFont, cText, nFntSize, cSysFont, ;
         nWidth := ::nWidth(), ;
         nHeight := ::nHeight(), ;
         nRow := 10, ;
         nCol := 10, ;
         n := 1

   Local nIcons := Int( nWidth / 50 ) * Int( nHeight / 50 ), ;
         hIcon := ExtractIcon( "user.exe", 0 )

   cSysFont := GetSysFont()                              // initialize "default" font
   nFntSize := If( cSysFont == "Tahoma", -11, -8 )

   DEFINE FONT oFont NAME cSysFont SIZE 0, nFntSize UNDERLINE

   SelectObject( ::hDC, oFont:hFont )
   SetBkColor( ::hDC, CLR_BLUE )
   SetTextColor( ::hDC, CLR_WHITE )

   While n <= nIcons .and. ! ( ::cAlias )->( EoF() )
      If ::bIconDraw != nil .and. ::aIcons != nil
         hIcon := ::aIcons[ Eval( ::bIconDraw, Self ) ]
      EndIf

      DrawIcon( ::hDC, nRow, nCol, hIcon )

      If ::bIconText != nil
         cText := cValToChar( Eval( ::bIconText, Self ) )
      Else
         cText := Str( ( ::cAlias )->( RecNo() ) )
      EndIf

      DrawText( ::hDC, cText, { nRow + 35, nCol - 5, nRow + 48, nCol + 40 }, 1 )

      nCol += 50

      If nCol >= nWidth - 32
         nRow += 50
         nCol := 10
      EndIf

      ( ::cAlias )->( DbSkip() )
      n ++

   Enddo

   ( ::cAlias )->( DbSkip( 1 - n ) )

   oFont:End()

Return Nil

* ============================================================================
* METHOD TSBrowse:DrawLine() Version 8.0 Feb/01/2008
* ============================================================================

METHOD DrawLine( xRow ) CLASS TSBrowse

   Local nI, nJ, nBegin, nStartCol, oColumn, hBitMap, cPicture, hFont, nClrTo, nClrFore, nClrBack, uData, nLastCol, ;
         lAdjBmp, lMultiLine, nAlign, lOpaque, lBrush, lCheck, uBmpCell, ;
         nVertText   := 0, ;
         nVAlign     := 1, ;
         lSelected   := .F., ;
         nMaxWidth   := ::nWidth(), ;
         nRowPos     := ::nRowPos, ;
         nClrText    := ::nClrText, ;
         nClrPane    := ::nClrPane, ;
         lBrushed    := ValType( ::oBrush ) == "O" .and. ::oBrush:hBitMap > 0

   Local l3DText, nClr3dL, nClr3dS, l3DLook

   Local aColSizes    := AClone( ::aColSizes ), ;
         hWnd         := ::hWnd, ;
         hDC          := ::hDC, ;
         nLineStyle   := ::nLineStyle, ;
         nClrLine     := ::nClrLine, ;
         nHeightCell  := ::nHeightCell, ;
         nHeightHead  := If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
         nHeightFoot  := If( ::lDrawFooters != Nil .and. ::lDrawFooters, ::nHeightFoot, 0 ), ;
         nHeightSuper := If( ::lDrawHeaders, ::nHeightSuper, 0 )

   Default xRow := If( ::lDrawHeaders, Max( 1, ::nRowPos ), ::nRowPos )

   ::nPaintRow := xRow
   lSelected   := ::lCanSelect .and. ( AScan( ::aSelected, If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt ) ) ) > 0

   nClrBack := If( ::nPhantom = -1, ATail( ::aColumns ):nClrBack, nClrPane )
   nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack, ::nAt, Len( ::aColumns ), Self ), nClrBack )
   l3DLook  := If( ::nPhantom == -1, ATail( ::aColumns ):l3DLook, .F. )

   If ::nLen > 0

      If ::oPhant == Nil
         //  "Phantom" column; :nPhantom hidden IVar
         ::oPhant := TSColumn():New(        "", ; // cHeading
                                 {|| "" }, ; // bdata
                                      Nil, ; // cPicture
                   { nClrText, nClrBack }, ; // aColors
                                      Nil, ; // aAlign
                               ::nPhantom, ; // nWidth
                                      Nil, ; // lBitMap
                                      Nil, ; // lEdit
                                      Nil, ; // bValid
                                      .T., ; // lNoLite
                                      Nil, ; // cOrder
                                      Nil, ; // cFooting
                                      Nil, ; // bPrevEdit
                                      Nil, ; // bPostEdit
                                      Nil, ; // nEditMove
                                      Nil, ; // lFixLite
                              { l3DLook }, ;
                                      Nil, ;
                                     Self )
      Else
         ::oPhant:nClrFore := nClrText
         ::oPhant:nClrBack := nClrBack
         ::oPhant:nWidth   := ::nPhantom
         ::oPhant:l3DLook  := l3DLook
      EndIf

      AAdd( aColSizes, ::nPhantom )

      nJ := nStartCol := 0
      nLastCol := Len( ::aColumns ) + 1
      nBegin := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1, ;
                  ::nColPos - ::nFreeze ), ::nColPos - ::nFreeze ), nLastCol )

      If ::bOnDrawLine != Nil
         Eval( ::bOnDrawLine, Self )
      EndIf

      For nI := nBegin To nLastCol

         If nStartCol > nMaxWidth
            Exit
         EndIf

         nJ := If( nI < ::nColPos, nJ + 1, nI )

         lSelected := If( nJ == nLastCol, .F., lSelected )
         oColumn  := If( nJ > Len( ::aColumns ), ::oPhant, ::aColumns[ nJ ] )
         cPicture := oColumn:cPicture
         lCheck   := oColumn:lCheckBox
         lAdjBmp  := oColumn:lAdjBmp
         hFont    := If( oColumn:oFont == Nil, ::oFont, oColumn:oFont )
         hFont    := If( ValType( hFont ) == "B", Eval( hFont, ::nAt, nJ, Self ), ;
                        hFont )
         hFont    := If( hFont == Nil, 0, hFont:hFont )

         If ::lIsArr .and. ( ::lAppendMode .or. ::nAt > Len( ::aArray ) )
            uData := ""                     // append mode for arrays
         Else
            uData := Eval( oColumn:bData )
         EndIf

         uData := If( ValType( uData ) == "C" .and. SubStr( uData, 1, 4 ) == GTF5, ;
                      LTrim( GTFToTxt( uData ) ), uData )

         nVertText := 0

         If lCheck .and. ValType( uData ) == "L"
            nVertText := If( uData, 3, 4 )
         EndIf

         nAlign := oColumn:nAlign

         If ::oTree == Nil

            uBmpCell := oColumn:uBmpCell

            If nJ == ::nColSel .and. ::uBmpSel != Nil .and. lSelected
               uBmpCell := ::uBmpSel
               nAlign   := nMakeLong( nLoWord( nAlign ), ::nAligBmp )
            ElseIf oColumn:lBitMap .and. Valtype( uData ) == "N" .and. ! Empty( ::aBitMaps )
               uBmpCell := ::aBitMaps[ uData ]
               nAlign := nMakeLong( oColumn:nAlign, oColumn:nAlign )
               uData    := ""
            ElseIf Empty( cPicture  )
               uData := If( Valtype( uData ) != "C", cValToChar( uData ), uData )
            Else
               uData := Transform( uData, cPicture )
            EndIf

         ElseIf ValType( uData ) == "N"
            uBmpCell := uData
            nAlign := nMakeLong( oColumn:nAlign, oColumn:nAlign )
            uData := ""
         EndIf

         nAlign := If( ValType( nAlign ) == "B", Eval( nAlign ), nAlign )

         If ( nClrFore := oColumn:nClrFore ) == Nil .or. ( lSelected .and. ::uBmpSel == Nil )
            nClrFore := If( ! lSelected, nClrText, ::nClrSeleFore )
         EndIf

         nClrFore := If( Valtype( nClrFore ) == "B", Eval( nClrFore, ::nAt, nJ, Self ), nClrFore )

         If ( nClrBack := oColumn:nClrBack ) == Nil .or. ( lSelected .and. ::uBmpSel == Nil )
            nClrBack := If( ! lSelected, nClrPane, ::nClrSeleBack )
         EndIf

         nClrBack := If( Valtype( nClrBack ) == "B", Eval( nClrBack, ::nAt, nJ, Self ), nClrBack )

         If ( ::lTransparent .and. lBrushed ) .or. ( ::lTransparent .and. ::oWnd:oBrush != Nil )
            nClrBack := If( lBrushed, ::oBrush, ::oWnd:oBrush )
         EndIf

         lBrush   := Valtype( nClrBack ) == "O"

         If ValType( nClrBack ) == "A"
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )
         Else
            nClrTo := nClrBack
         EndIf

         hBitMap := If( ValType( uBmpCell ) == "B", Eval( uBmpCell ), uBmpCell )
         hBitMap := If( ValType( hBitMap ) == "O", Eval( ::bBitMapH, hBitMap ), hBitMap )
         Default hBitMap := 0
         lAdjBmp := If( ::oTree == Nil, oColumn:lAdjBmp, .F. )
         lOpaque := lAnd( oColumn:nOpaque, 1 )
         lMultiLine := Valtype( uData ) == "C" .and. At( Chr( 13 ), uData ) > 0

         If oColumn:l3DTextCell != Nil
            l3DText := oColumn:l3DTextCell
            nClr3dL := oColumn:nClr3DLCell
            nClr3dS := oColumn:nClr3DSCell
            nClr3dL := If( ValType( nClr3dL ) == "B", Eval( nClr3dL, ::nAt, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", Eval( nClr3dS, ::nAt, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(                    hWnd, ; // 1
                                         hDC, ; // 2
                                        xRow, ; // 3
                                  nStartCol , ; // 4
                             aColSizes[ nJ ], ; // 5
                                       uData, ; // 6
                                     nAlign , ; // 7
                                    nClrFore, ; // 8
                                    nClrBack, ; // 9
                                       hFont, ; // 10
                                     hBitMap, ; // 11
                                 nHeightCell, ; // 12
                             oColumn:l3DLook, ; // 13
                                  nLineStyle, ; // 14
                                    nClrLine, ; // 15
                                           0, ; // 16 header/footer/super
                                 nHeightHead, ; // 17
                                 nHeightFoot, ; // 18
                                nHeightSuper, ; // 19
                                     lAdjBmp, ; // 20
                                  lMultiline, ; // 21
                                     nVAlign, ; // 22
                                   nVertText, ; // 23
                                      nClrTo, ; // 24
                                     lOpaque, ; // 25
            If( lBrush, nClrBack:hBrush, 0 ), ; // 26
                                    l3DText, ;  // 27  3D text
                                    nClr3dL, ;  // 28  3D text light color
                                    nClr3dS )   // 29  3D text shadow color
         nStartCol += aColSizes[ nJ ]

      Next

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:DrawPressed() Version 8.0 Feb/01/2008
* Header pressed effect
* ============================================================================

METHOD DrawPressed( nCell, lPressed ) CLASS TSBrowse

   Local nI, nLeft, nTop, nBottom, nRight, hOldPen
   Local hDC       := GetDC( ::hWnd ), ;
         hGrayPen  := CreatePen( PS_SOLID, 1, ::nClrLine ), ;
         hWhitePen := CreatePen( PS_SOLID, 1, GetSysColor( COLOR_BTNHIGHLIGHT ) )

   Default lPressed := .T.

   nKeyPressed := Nil

   If Empty( nCell ) .or. nCell > Len( ::aColumns ) .or. ! ::lDrawHeaders
      Return Self
   ElseIf ! lPressed .and. ! ::aColumns[ nCell ]:l3DLookHead
      ::DrawHeaders()
      Return Self
   EndIf

   nLeft := 0

   If ::nFreeze > 0
      For nI := 1 To Min( ::nFreeze , nCell - 1 )
         nLeft += ::GetColSizes()[ nI ]
      Next
   EndIf

   For nI := ::nColPos To nCell - 1
      nLeft += ::GetColSizes()[ nI ]
   Next

   nTop    := ::nHeightSuper
   nTop    -= If( nTop > 0, 1, 0 )
   nRight  := nLeft + ::aColSizes[ nCell ]
   nBottom := nTop + ::nHeightHead
   hOldPen := SelectObject( hDC, If( lPressed, hGrayPen, hWhitePen ) )

   MoveTo( hDC, nLeft, nBottom )
	LineTo( hDC, nLeft, nTop )
	LineTo( hDC, nRight , nTop )
   SelectObject( hDC, If( lPressed, hWhitePen, hGrayPen ) )
   MoveTo( hDC, nLeft, nBottom - 1 )
	LineTo( hDC, nRight - 1, nBottom - 1 )
	LineTo( hDC, nRight - 1, nTop - 1 )
   SelectObject( hDC, hOldPen )
   DeleteObject( hGrayPen )
   DeleteObject( hWhitePen )
   ReleaseDC( ::hWnd, hDC )

   If lPressed
      nKeyPressed := nCell
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:DrawSelect() Version 8.0 Feb/01/2008
* ============================================================================

METHOD DrawSelect( xRow ) CLASS TSBrowse

   Local nI, nJ, nBegin, nStartCol, oColumn, nLastCol, hBitMap, hFont, nAlign, cPicture, nClrFore, nClrBack, ;
         lNoLite, uData, l3DLook, lMulti, nClrTo, lOpaque, lBrush, nCursor, lCheck, uBmpCell, cMsg, ;
         nVertText := 0, ;
         lAdjBmp   := .F., ;
         lSelected := .F., ;
         nMaxWidth := ::nWidth(), ;     // use local copies for speed
         nRowPos   := ::nRowPos, ;
         aColSizes := AClone( ::aColSizes ), ;
         hWnd      := ::hWnd, ;
         hDC       := ::hDc, ;
         lFocused  := ::lFocused := GetFocus() == ::hWnd, ;
         nVAlign   := 1, ;
         lBrushed  := ValType( ::oBrush ) == "O" .and. ::oBrush:hBitMap > 0

   Local l3DText, nClr3dL, nClr3dS

   Local nClrText     := ::nClrText, ;
         nClrPane     := ::nClrPane, ;
         nClrFocuFore := ::nClrFocuFore, ;
         nClrFocuBack := ::nClrFocuBack, ;
         nClrLine     := ::nClrLine, ;
         nLineStyle   := ::nLineStyle, ;
         nClrSeleBack := ::nClrSeleBack, ;
         nClrSeleFore := ::nClrSeleFore, ;
         nHeightCell  := ::nHeightCell, ;
         nHeightHead  := If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
         nHeightFoot  := If( ::lDrawFooters != Nil .and. ::lDrawFooters, ::nHeightFoot, 0 ), ;
         nHeightSuper := If( ::lDrawHeaders, ::nHeightSuper, 0 )

   Default xRow := nRowPos

   ::nPaintRow := xRow

   If Empty( ::aColumns )
      Return Self
   EndIf

   lSelected := ::lCanSelect .and. ( AScan( ::aSelected, If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt ) ) ) > 0

   If ( ::lNoLiteBar .or. ( ::lNoGrayBar .and. ! lFocused ) ) .and. ::hBmpCursor == Nil
      ::DrawLine()   // don't want hilited cursor bar of any color
   ElseIf ::nLen > 0

      nClrBack := If( ::nPhantom = -1 .and. ! Empty( ::aColumns ), ATail( ::aColumns ):nClrBack, nClrPane )
      nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack, ::nAt, Len( ::aColumns ), Self ), nClrBack )
      l3DLook  := If( ::nPhantom = -1 .and. ! Empty( ::aColumns ), ATail( ::aColumns ):l3DLook, .F. )

      If ::oPhant == Nil
         // "Phantom" column; :nPhantom hidden IVar
         ::oPhant := TSColumn():New(        "", ; // cHeading
                                 {|| "" }, ; // bdata
                                      nil, ; // cPicture
                   { nClrText, nClrBack }, ; // aColors
                                      nil, ; // aAlign
                               ::nPhantom, ; // nWidth
                                      nil, ; // lBitMap
                                      nil, ; // lEdit
                                      nil, ; // bValid
                                      .T., ; // lNoLite
                                      nil, ; // cOrder
                                      nil, ; // cFooting
                                      nil, ; // bPrevEdit
                                      nil, ; // bPostEdit
                                      nil, ; // nEditMove
                                      nil, ; // lFixLite
                                {l3DLook}, ;
                                      nil, ;
                                     Self )
      Else
         ::oPhant:nClrFore := nClrText
         ::oPhant:nClrBack := nClrBack
         ::oPhant:nWidth   := ::nPhantom
         ::oPhant:l3DLook  := l3DLook
      EndIf

      AAdd( aColSizes, ::nPhantom )
      nJ := nStartCol := 0
      nLastCol := Len( ::aColumns ) + 1
      nBegin   := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1, ::nColPos - ::nFreeze ), ;
                           ::nColPos - ::nFreeze ), nLastCol )

      For nI := nBegin To nLastCol

         If nStartCol > nMaxWidth
            Exit
         EndIf

         nJ := If( nI < ::nColPos, nJ + 1, nI )
         oColumn := If( nJ > Len( ::aColumns ), ::oPhant, ::aColumns[ nJ ] )

         hFont    := If( oColumn:oFont == Nil, ::oFont, oColumn:oFont )
         hFont    := If( ValType( hFont ) == "B", Eval( hFont, ::nAt, nI, Self ), hFont )
         hFont    := If( hFont == Nil, 0, hFont:hFont )
         uBmpCell := oColumn:uBmpCell
         lAdjBmp  := oColumn:lAdjBmp
         nAlign   := oColumn:nAlign
         lOpaque  := lAnd( oColumn:nOpaque, 1 )

         If nJ == 1 .and. ! Empty( ::hBmpCursor )
            uBmpCell := ::hBmpCursor
            uData    := ""
            nAlign   := nMakeLong( oColumn:nAlign, oColumn:nAlign )
            lNoLite := .T.
            lAdjBmp := .F.
         Else
            If ::lIsArr .and. ( ::lAppendMode .or. ::nAt > Len( ::aArray ) )
               uData := ""                         // append mode for arrays
            Else
               uData := Eval( oColumn:bData )
            EndIf

            uData := If( ValType( uData ) == "C" .and. SubStr( uData, 1, 4 ) == GTF5, ;
                         LTrim( GTFToTxt( uData ) ), uData )
            cPicture := oColumn:cPicture
            lCheck   := oColumn:lCheckBox
            lNoLite  := oColumn:lNoLite
            nVertText := 0

            If lCheck .and. ValType( uData ) == "L"
               nVertText := If( uData, 3, 4 )
            EndIf

            If ::oTree == Nil

               uBmpCell := oColumn:uBmpCell

               If nJ == ::nColSel .and. ::uBmpSel != Nil .and. lSelected
                  uBmpCell := ::uBmpSel
                  nAlign   := nMakeLong( nLoWord( nAlign ), ::nAligBmp )
               ElseIf oColumn:lBitMap .and. Valtype( uData ) == "N" .and. ! Empty( ::aBitMaps )
                  uBmpCell := ::aBitMaps[ uData ]
                  nAlign := nMakeLong( nLoWord( nAlign ), nAlign )
                  uData    := ""
               ElseIf Empty( cPicture )
                  uData := If( Valtype( uData ) != "C", cValToChar( uData ), uData )
               Else
                  uData := Transform( uData, cPicture )
               EndIf

            ElseIf ValType( uData ) == "N"
               uBmpCell := uData
               nAlign   := nMakeLong( nLoWord( nAlign ), nAlign )
               lAdjBmp  := .F.
               lNoLite  := .T.
               uData    := ""
            EndIf

         EndIf

         nAlign := If( ValType( nAlign ) == "B", Eval( nAlign ), nAlign )

         If lNoLite
            If ( nClrFore := oColumn:nClrFore ) == Nil
               nClrFore := nClrText
            EndIf

            nClrFore := If( Valtype( nClrFore ) == "B", Eval( nClrFore, ::nAt, nJ, Self ), nClrFore )

            If ( nClrBack := oColumn:nClrBack ) == Nil
               nClrBack := nClrPane
            EndIf

            nClrBack := If( Valtype( nClrBack ) == "B", Eval( nClrBack, ::nAt, nJ, Self ), nClrBack )
            nCursor  := 0
         Else
            If ( nClrFore := If( lFocused, oColumn:nClrFocuFore, oColumn:nClrSeleFore ) ) == Nil
               nClrFore := If( lFocused, nClrFocuFore, nClrSeleFore )
            EndIf

            nClrFore := If( Valtype( nClrFore ) == "B", Eval( nClrFore, ::nAt, nJ, Self ), nClrFore )

            If ( nClrBack := If( lFocused, oColumn:nClrFocuBack, oColumn:nClrSeleBack ) ) == Nil
               nClrBack := If( lFocused, nClrFocuBack, nClrSeleBack )
            EndIf

            nClrBack := If( Valtype( nClrBack ) == "B", Eval( nClrBack, ::nAt, nJ, Self ), nClrBack )

            If ValType( nClrBack ) == "N" .and. nClrBack < 0

               nCursor := Abs( nClrBack )

               If ( nClrBack := oColumn:nClrBack ) == Nil
                  nClrBack := nClrPane
               EndIf

               nClrBack := If( Valtype( nClrBack ) == "B", Eval( nClrBack, ::nAt, nJ, Self ), nClrBack )
            Else
               nCursor := 0
            EndIf

         EndIf

         If ( ::lTransparent .and. ::lCellBrw .and. lBrushed ) .or. ;
            ( ::lTransparent .and. ::lCellBrw .and. ValType( ::oWnd:oBrush ) == "O" )

               nClrBack := If( lBrushed, ::oBrush, ::oWnd:oBrush )
         EndIf

         lBrush := Valtype( nClrBack ) == "O"

         If ValType( nClrBack ) == "A"
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )
         Else
            nClrTo := nClrBack
         EndIf

         l3DLook := oColumn:l3DLook
         hBitMap := If( ValType( uBmpCell ) == "B", Eval( uBmpCell ), uBmpCell )
         hBitMap := If( ValType( hBitMap ) == "O", Eval( ::bBitMapH, hBitMap ), hBitMap )
         Default hBitMap := 0
         lMulti  := Valtype( uData ) == "C" .and. At( Chr( 13 ), uData ) > 0

         If oColumn:l3DTextCell != Nil
            l3DText := oColumn:l3DTextCell
            nClr3dL := oColumn:nClr3DLCell
            nClr3dS := oColumn:nClr3DSCell
            nClr3dL := If( ValType( nClr3dL ) == "B", Eval( nClr3dL, ::nAt, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", Eval( nClr3dS, ::nAt, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(            hWnd, ; //  1
                                 hDC, ; //  2
                             nRowPos, ; //  3
                           nStartCol, ; //  4
                     aColSizes[ nJ ], ; //  5
                               uData, ; //  6
                              nAlign, ; //  7
                            nClrFore, ; //  8
                            nClrBack, ; //  9
                               hFont, ; // 10
                             hBitMap, ; // 11
                         nHeightCell, ; // 12
                             l3DLook, ; // 13
                          nLineStyle, ; // 14
                            nClrLine, ; // 15
                                   0, ; // 16 Header/Footer/Super
                         nHeightHead, ; // 17
                         nHeightFoot, ; // 18
                        nHeightSuper, ; // 19
                             lAdjBmp, ; // 20
                              lMulti, ; // 21 Multiline text
                             nVAlign, ; // 22
                           nVertText, ; // 23
                              nClrTo, ; // 24
                             lOpaque, ; // 25
                          If( lBrush, ;
                nClrBack:hBrush, 0 ), ; // 26
                            l3DText, ;  // 27  3D text
                            nClr3dL, ;  // 28  3D text light color
                            nClr3dS, ;  // 29  3D text shadow color
                            nCursor )   // 30  Rect cursor

         nStartCol += aColSizes[ nJ ]

      Next

   EndIf

   If ::bOnDraw != Nil
      Eval( ::bOnDraw, Self )
   EndIf

   If ::lCellBrw
      cMsg := If( ! Empty( ::AColumns[ ::nCell ]:cMsg ), ::AColumns[ ::nCell ]:cMsg, ::cMsg )
      cMsg := If( ValType( cMsg ) == "B", Eval( cMsg, Self, ::nCell ), cMsg )

      If ! Empty( cMsg )
         ::SetMsg( cMsg )
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:DrawSuper() Version 8.0 Feb/01/2008
* ============================================================================

METHOD DrawSuper() CLASS TSBrowse

   Local nI, nJ, nBegin, nStartCol, l3DLook, nClrFore, lAdjBmp, nClrTo, lOpaque, nClrBack, hFont, cHeading, hBitMap, ;
         nLastCol, lMulti, lDegrad, nHAlign, nVAlign, nWidth, nS, nLineStyle, lTransp, lBrush, ;
         nMaxWidth    := ::nWidth() , ;
         aColSizes    := AClone( ::aColSizes ), ;   // use local copies for speed
         aSuperHead   := AClone( ::aSuperHead ), ;
         nHeightHead  := ::nHeightHead, ;
         nHeightFoot  := ::nHeightFoot, ;
         nHeightSuper := ::nHeightSuper

   Local hWnd         := ::hWnd, ;
         hDC          := ::hDc, ;
         nClrText     := ::nClrText, ;
         nClrPane     := ::nClrPane, ;
         nClrLine     := ::nClrLine

   Local l3DText, nClr3dL, nClr3dS

   If Empty( ::aColumns )
       Return Nil
   EndIf

   nLastCol := Len( ::aColumns )

   nClrText   := aSuperHead[ 1, 4 ]
   nClrBack   := aSuperHead[ 1, 5 ]
   l3DLook    := aSuperHead[ 1, 6 ]
   hFont      := aSuperHead[ 1, 7 ]
   nLineStyle := aSuperHead[ 1, 10 ]
   nClrLine   := aSuperHead[ 1, 11 ]

   nBegin := nI := 1

   While nI <= Len( aSuperHead )

      If aSuperHead[ nI, 1 ] > nBegin
         nJ := aSuperHead[ nI, 1 ] - 1
         ASize( aSuperHead, Len( aSuperHead ) + 1 )
         AIns( aSuperHead, nI )
         aSuperHead[ nI ] := { nBegin, nJ, "", nClrText, nClrBack, l3DLook , hFont, .F., .F., nLineStyle, ;
                               nClrLine, 1, 1, .F. }
         nBegin := nJ + 1
      Else
         nBegin := aSuperHead[ nI++, 2 ] + 1
      EndIf

   EndDo

   nI := Len( aSuperHead )
   nClrText   := aSuperHead[ nI, 4 ]
   nClrBack   := aSuperHead[ nI, 5 ]
   l3DLook    := aSuperHead[ nI, 6 ]
   hFont      := aSuperHead[ nI, 7 ]
   nLineStyle := aSuperHead[ nI, 10 ]
   nClrLine   := aSuperHead[ nI, 11 ]


   If ( nI := ATail( aSuperHead )[  2 ] ) < Len( ::aColumns )
        AAdd( aSuperHead, { nI + 1, Len( ::aColumns ), "", nClrText, nClrBack, l3DLook, hFont, .F., .F., nLineStyle, ;
                            nClrLine, 1, 1, .F. } )
   EndIf

   nStartCol := nWidth := 0

   nBegin := If( ::nColPos == ::nFreeze + 1, ::nColPos - ::nFreeze, ::nColPos )

   For nS := 1 To Len( aSuperHead )

      If nBegin >= aSuperHead[ nS, 1 ] .and. nBegin <= aSuperHead[ nS, 2 ]
         Do Case
            Case nBegin > aSuperHead[ nS, 1 ] .and. nS == 1
               For nJ := aSuperHead[ nS, 1 ] To nBegin - 1
                  nStartCol -= ::aColSizes[ nJ ]
               Next

               For nJ := aSuperHead[ nS, 1 ]  To aSuperHead[ nS, 2 ]
                  nWidth += aColSizes[ nJ ]
               Next

            Case nBegin > aSuperHead[ nS, 1 ] .and. nS > 1
               For nJ := 1 To ::nFreeze
                  nStartCol += ::aColSizes[ nJ ]
               Next

               For nJ := nBegin  To aSuperHead[ nS, 2 ]
                   nWidth += aColSizes[ nJ ]
               Next

            OtherWise
               If nBegin > 1
                  For nJ := 1 To ::nFreeze
                     nStartCol += ::aColSizes[ nJ ]
                  Next
               EndIf

               For nJ := aSuperHead[ nS, 1 ]  To aSuperHead[ nS, 2 ]
                  nWidth += aColSizes[ nJ ]
               Next

         EndCase

         Exit

      EndIf

   Next

   For nI := nS To Len( aSuperHead ) + 1

      If nStartCol > nMaxWidth
         Exit
      EndIf

      If nI <= Len( aSuperHead )
         nClrFore := If( ValType( aSuperHead[ nI, 4 ] ) == "B", Eval( aSuperHead[ nI, 4 ] ), aSuperHead[ nI, 4 ] )
         nClrBack := If( ValType( aSuperHead[ nI, 5 ] ) == "B", Eval( aSuperHead[ nI, 5 ] ), aSuperHead[ nI, 5 ] )
         lBrush   := Valtype( nClrBack ) == "O"

         If ValType( nClrBack ) == "A"
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo   := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )
         Else
            nClrTo   := nClrBack
         EndIf

         cHeading := aSuperHead[ nI, 3 ]
         cHeading := If( Valtype( cHeading ) == "B", Eval( cHeading ), cHeading )
         lMulti   := Valtype( cHeading ) == "C" .and. At( Chr( 13 ), cHeading ) > 0

         l3DLook    := aSuperHead[ nI, 6 ]
         hFont      := aSuperHead[ nI, 7 ]
         hBitMap    := aSuperHead[ nI, 8 ]
         hBitMap    := If( ValType( hBitMap ) == "B", Eval( hBitMap ), hBitMap )
         hBitMap    := If( ValType( hBitMap ) == "O", Eval( ::bBitMapH, hBitMap ), hBitMap )
         lAdjBmp    := aSuperHead[ nI, 9 ]
         nLineStyle := aSuperHead[ nI, 10 ]
         nClrLine   := aSuperHead[ nI, 11 ]
         nHAlign    := aSuperHead[ nI, 12 ]
         nVAlign    := aSuperHead[ nI, 13 ]
         lOpaque    := aSuperHead[ nI, 14 ]

         Default hBitMap := 0, ;
                 lOpaque := .T.
         lOpaque := ! lOpaque
      Else
         cHeading := ""
         nWidth   := ::nPhantom
         hBitmap  := 0
         lOpaque  := .F.
         nClrBack := If( ::nPhantom == -2, nClrPane, nClrBack )
         nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )
         nClrTo   := nClrBack
      EndIf

      If nI <= Len( aSuperHead ) .and. ::aColumns[ aSuperHead[ nI, 1 ] ]:l3DTextHead != Nil
         l3DText := ::aColumns[ aSuperHead[ nI, 1 ] ]:l3DTextHead
         nClr3dL := ::aColumns[ aSuperHead[ nI, 1 ] ]:nClr3DLHead
         nClr3dS := ::aColumns[ aSuperHead[ nI, 1 ] ]:nClr3DSHead
         nClr3dL := If( ValType( nClr3dL ) == "B", Eval( nClr3dL, 0, nStartCol ), nClr3dL )
         nClr3dS := If( ValType( nClr3dS ) == "B", Eval( nClr3dS, 0, nStartCol ), nClr3dS )
      Else
         l3DText := nClr3dL := nClr3dS := Nil
      EndIf

      TSDrawCell(      hWnd, ;  // 1
                        hDC, ;  // 2
                          0, ;  // 3
                  nStartCol, ;  // 4
                     nWidth, ;  // 5
                   cHeading, ;  // 6
                    nHAlign, ;  // 7
                   nClrFore, ;  // 8
                   nClrBack, ;  // 9
                      hFont, ;  // 10
                    hBitMap, ;  // 11
                nHeightHead, ;  // 12
                    l3DLook, ;  // 13
                 nLineStyle, ;  // 14
                   nClrLine, ;  // 15
                          3, ;  // 16 1=Header 2=Footer 3=Super
                nHeightHead, ;  // 17
                nHeightFoot, ;  // 18
               nHeightSuper, ;  // 19
                    lAdjBmp, ;  // 20
                     lMulTi, ;  // 21 Multiline text
                    nVAlign, ;  // 22
                          0, ;  // 23 nVertLine
                     nClrTo, ;  // 24
                    lOpaque, ;  // 25
                 If( lBrush, ;
       nClrBack:hBrush, 0 ), ;  // 26
                    l3DText, ;  // 27  3D text
                    nClr3dL, ;  // 28  3D text light color
                    nClr3dS )   // 29  3D text shadow color

      nStartCol += nWidth

      nWidth := 0

      If nI < Len( aSuperHead )
         For nJ := aSuperHead[ nI + 1, 1 ] To aSuperHead[ nI + 1, 2 ]
            nWidth += aColSizes[ nJ ]
         Next
      EndIf

   Next

Return Nil

* ============================================================================
* METHOD TSBrowse:Edit() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Edit( uVar, nCell, nKey, nKeyFlags, cPicture, bValid, nClrFore, nClrBack ) CLASS TSBrowse

   Local nRow, nHeight, oFont, cType, uValue, nI, aGet, oCol, cMsg, aRct, cError, bChange, lSpinner, bUp, bDown, ;
         bMin, bMax, nStartX, nWidth, lCombo, lMulti, nCol, lLogicDrop, nTxtHeight, oClp, cText, ;
         nFireKey := ::nFireKey

   Default nCell       := ::nCell, ;
           ::lPostEdit := .F., ;
           ::lNoPaint  := .F.

   oCol := ::aColumns[ nCell ]

   Default ::nHeightSuper := 0, ;
           nKey           := VK_RETURN, ;
           nKeyFlags      := 0, ;
           nFireKey       := VK_F2, ;
           uVar           := Eval( oCol:bData ), ;
           cPicture       := oCol:cPicture, ;
           bValid         := oCol:bValid, ;
           nClrFore       := oCol:nClrEditFore, ;
           nClrBack       := oCol:nClrEditBack

   uValue   := uVar
   cType    := If( Empty( oCol:cDataType ), ValType( uValue ), oCol:cDataType )
   cMsg     := oCol:cMsgEdit
   cError   := oCol:cError
   bChange  := oCol:bChange
   lSpinner := oCol:lSpinner
   bUp      := oCol:bUp
   bDown    := oCol:bDown
   bMin     := oCol:bMin
   bMax     := oCol:bMax
   nStartX  := 0
   lCombo   := lMulti := .F.
   ::oGet   := ::oWnd:bValid
   ::oWnd:bValid := { || ! ::lEditing }

   If oCol:bPassWord != Nil

      If ! Eval( oCol:bPassWord, uValue, nCell, ::nAt, Self )
         Return Nil
      EndIf

   EndIf

   ::lEditing   := .T.
   ::lHitBottom := .F.

   If ::nLen > 0
      ::lNoPaint := .T.
   EndIf

   If oCol:bPrevEdit != Nil
      Eval( oCol:bPrevEdit, uValue, Self )
   EndIf

   cMsg := If( ValType( cMsg ) == "B", Eval( cMsg, Self, nCell ), cMsg )

   If cType == "L" .and. oCol:lCheckBox

      If nKey != VK_RETURN

         If Upper( Chr( nKey ) ) $ "YCST1"
            ::lChanged := uVar == .F.
            uVar := .T.
         ElseIf Upper( Chr( nKey ) ) $ "FN0"
            ::lChanged := uVar == .T.
            uVar := .F.
         ElseIf nKey == VK_SPACE
            uVar := ! uVar
            ::lChanged := .T.
         Else
            Return 0
         EndIf

         ::lHasChanged := If( ::lChanged, .T., ::lHasChanged )
         ::oWnd:nLastKey := VK_RETURN
         ::PostEdit( uVar, nCell )
         ::lPostEdit := .F.
         Return 0

      Else

         ::lPostEdit := .T.
         ::lChanged := .F.
         ::oWnd:nLastKey := nKey
         ::PostEdit( uVar, nCell )
         ::lPostEdit := .F.
         Return 0

      EndIf

   EndIf

   If oCol:bExtEdit != Nil  // external edition

      ::lNoPaint := ::lEditing := .F.
      uVar := Eval( oCol:bExtEdit, uValue, Self )
      ::lChanged := ValType( uVar ) != ValType( uValue ) .or. uVar != uValue
      ::lPostEdit := .T.
      ::oWnd:nLastKey := VK_RETURN
      ::PostEdit( uVar, nCell, bValid )
      Return Nil

   EndIf

   If Upper( Chr( nKey ) ) == "V" .and. ValType( cPicture ) == "L"  // paste from clipboard

      cPicture := Set( _SET_INSERT )

      DEFINE CLIPBOARD oClp OF Self FORMAT TEXT

      If oClp:Open()
         cText = oClp:GetText()
         oClp:Close()
      Else
         Return Nil
      EndIf

      If ! Empty( cText )

         Do Case
            Case ValType( uVar ) == "C"

               If cPicture
                  uVar := cText + uVar
               Else
                  uVar := cText
               EndIf
            Case ValType( uVar ) == "N"
               uVar := Val( AllTrim( cText ) )
            case ValType( uVar ) == "D"
               uVar := CtoD( cText )
         EndCase

      Else
         Return Nil
      EndIf

      ::lNoPaint := ::lEditing := .F.
      ::lChanged := uVar != uValue
      ::lPostEdit := .T.
      ::oWnd:nLastKey := VK_RETURN
      ::PostEdit( uVar, nCell, bValid )
      Return Nil

   EndIf

   oFont := If( oCol:oFontEdit != Nil, oCol:oFontEdit, If( oCol:oFont != Nil, oCol:oFont, ::oFont ) )

   If oCol:oEdit != Nil
      oCol:oEdit:End()
	EndIf

   If ::nFreeze > 0
      For nI := 1 To Min( ::nFreeze , nCell - 1 )
         nStartX += ::GetColSizes()[ nI ]
      Next
   EndIf

   For nI := ::nColPos To nCell - 1
      nStartX += ::GetColSizes()[ nI ]
   Next

   nClrFore := If( ValType( nClrFore ) == "B", Eval( nClrFore, ::nAt, nCell, Self ), nClrFore )
   nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack, ::nAt, nCell, Self ), nClrBack )
   nRow     := ::nRowPos - 1
   nRow     := ( nRow * ::nHeightCell ) + ::nHeightHead + ::nHeightSuper + If( oCol:l3DLook, 2, 0 )
   nCol     := nStartX + If( oCol:l3DLook, 2, 0 )
   nWidth   := ::GetColSizes()[ nCell ] - If( oCol:l3DLook, 4, 2 )
   nHeight  := ::nHeightCell - If( oCol:l3DLook, 3, 1 )

   If oCol:cResName != Nil

      oCol:oEdit := TSBtnGet():New( 0, 0, bSETGET( uValue ), Self, 0, 0, cPicture,, nClrFore, nClrBack, oFont,,,, ;
                                    cMsg,,,,, bChange,,, .T.,, oCol:cResName, oCol:bAction, lSpinner .and. ;
                                    cType $ "ND", bUp, bDown, bMin, bMax, oCol:nBmpWidth )
      oCol:oEdit:Hide()
      oCol:oEdit:nFireKey := nFireKey
      oCol:oEdit:aFill := oCol:aFill
      oCol:oEdit:lFixCaret := ::lFixCaret

   ElseIf ( cType == "C" .and. Chr( 13 ) $ uValue ) .or. cType == "M"

      Default uValue := ""

      If ::nMemoHE == Nil

         If ! Empty( uValue )
            nHeight := Max( 4, StrCharCount( uValue, Chr( 10 ) ) )
         Else
            nHeight := 4
         EndIf

      Else
         nHeight := ::nMemoHE
      EndIf

      aRct := GetClientRect( ::hWnd )

      If ::nMemoWE == Nil .or. Empty( ::nMemoWE )
         nWidth := Max( nWidth, GetTextWidth( 0, SubStr( uValue, 1, At( Chr( 13 ), uValue ) - 1 ), ;
                                              If( oFont != Nil, oFont:hFont, 0 ) ) )
         nWidth := Min( nWidth, Int( aRct[ 4 ] * .8 ) )
      Else
         nWidth := ::nMemoWE
      EndIf

      nTxtHeight := SBGetHeight( ::hWnd, If( oFont != Nil, oFont:hFont, 0 ), 0 )

      While ( nRow + ( nTxtHeight * nHeight ) ) > aRct[ 3 ]
         nRow -= nTxtHeight
      EndDo

      nI := nCol + nWidth - aRct[ 4 ]
      nCol -= If( nI < 0, 0, nI )
      nCol := Max( 10, nCol )
      nHeight *= nTxtHeight

      If SubStr( uValue, 1, 4 ) == GTF5
         oCol:oEdit := TSFGet():New( 0, 0, bSETGET( uValue ), Self, 0, 0, oFont )
         oCol:oEdit:OnResize := {||oCol:oEdit:VScrAdjust()}
      Else
         oCol:oEdit := TSMulti():New( 0, 0, bSETGET( uValue ), Self, 0, 0, oFont,,nClrFore, nClrBack )
         oCol:oEdit:bGotFocus := { || oCol:oEdit:HideSel(), oCol:oEdit:SetPos( 0 ) }
      EndIf

      lMulti := .T.
      oCol:oEdit:Hide()
      SetWindowLong( oCol:oEdit:hWnd, GWL_STYLE, nOr( oCol:oEdit:nStyle, WS_THICKFRAME ) )

   ElseIf ( cType == "L" .and. ::lLogicDrop ) .or. oCol:lComboBox

      lCombo := .T.

      If oCol:lComboBox

         aGet := oCol:aItems

         If Empty( aGet )
            Return Nil
         EndIf

         If nKey == VK_RETURN

            If oCol:uDefFirstVal != Nil
               uValue := oCol:uDefFirstVal
            ElseIf oCol:cDataType != Nil .and. oCol:cDataType == "N"
               uValue := Max( 1, AScan( aGet, AllTrim( uValue ) ) )
            Else
               uValue := aGet[ Max( 1, AScan( aGet, AllTrim( uValue ) ) ) ]
            EndIf
         Else
            If oCol:cDataType != Nil .and. oCol:cDataType == "N"
               uValue := Max( 1, AScan( aGet, Upper( Chr( nKey ) ) ) )
            Else
               uValue := aGet[ Max( 1, AScan( aGet, Upper( Chr( nKey ) ) ) ) ]
            EndIf
         EndIf

         nHeight := Max( 10, Min( 10, Len( aGet ) ) ) * ::nHeightCell

      Else

         aGet := { ::aMsg[ 1 ], ::aMsg[  2 ] }

         If nKey == VK_RETURN
            uValue := If( uValue, 1,  2 )
         EndIf

         nHeight := ::nHeightCell * 2

      EndIf

      nRow -= 4
      oCol:oEdit := TSCombo():New( 1000, 0, bSETGET( uValue ), aGet, 0, 0, Self,,bChange,, nClrFore, ;
                                   nClrBack, .T., oFont, cMsg )

      oCol:oEdit:bCloseUp := {|o|o:PostMsg( WM_KEYDOWN, VK_RETURN, 0 )}
      oCol:oEdit:lAppend := ::lAppendMode
      oCol:oEdit:Hide()

   Else

      oCol:oEdit := TSGet():New( 0, 0, bSETGET( uValue ), Self, 0, 0, cPicture,, nClrFore, nClrBack, oFont,,,, ;
                                 cMsg,,,,, bChange,,, .T.,, lSpinner .and. cType $ "ND", bUp, bDown, bMin, bMax )
      oCol:oEdit:Hide()
      oCol:oEdit:aFill := oCol:aFill
      oCol:oEdit:lFixCaret := ::lFixCaret

   EndIf

   oCol:oEdit:bLostFocus := { | nKey | ::EditExit( nCell, nKey, uValue, bValid, .T. ) }
   oCol:oEdit:bKeyDown   := { | nKey, nFlags, lExit | ;
                              If( ValType( lExit ) == "L" .and. lExit, ::EditExit( nCell, nKey, uVar, bValid ), Nil ) }

   oCol:oEdit:oJump := Self
   oCol:oEdit:Move( nRow, nCol, nWidth, nHeight, ! lCombo )

   If oCol:cResName != Nil
      oCol:oEdit:Default()
   EndIf

   oCol:oEdit:SetFocus()

   If nKey != Nil .and. nKey > 31

      If ! lCombo .and. ! lMulti
         oCol:oEdit:lRightLeftExit := .T.
         oCol:oEdit:KeyChar( nKey, nKeyFlags )
      EndIf

   EndIf

   oCol:oEdit:Show()
   ::SetMsg( oCol:cMsgEdit )

   If oCol:bEditing != Nil
      Eval( oCol:bEditing, uVar, Self )
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:EditExit() Version 8.0 Feb/01/2008
* ============================================================================

METHOD EditExit( nCol, nKey, uVar, bValid, lLostFocus ) CLASS TSBrowse

   Local uValue, cType, oCol, lCombo, cMsg

   Default lLostFocus  := .F., ;
           ::lPostEdit := .F., ;
           nCol        := ::nCell

   oCol   := ::aColumns[ nCol ]
   lCombo := ValType( oCol:oEdit ) == "O" .and. "COMBO" $ Upper( oCol:oEdit:ClassName() )

   If ! lLostFocus .and. nKey > 0 .and. nKey != VK_ESCAPE .and. ValType( oCol:oEdit ) == "O"

      ::lPostEdit := .T.
      HideCaret( oCol:oEdit:hWnd )

      If lCombo

         cType := If( oCol:cDataType != Nil, oCol:cDataType, ValType( uVar ) )

         If cType == "L"
            uValue := oCol:oEdit:nAt == 1
            uVar := If( ValType( uVar ) == "C", AScan( oCol:aItems, uVar ) == 1, ;
                    If( ValType( uVar ) == "N", uVar == 1, uVar ) )
         Else

            If oCol:aData != Nil
               uValue := oCol:aData[ oCol:oEdit:nAt ]
               If ValType( uValue ) == "N" .and. ValType( uVar ) == "C"
                  uVar := AScan( oCol:aData, uVar )
               EndIf
            Else
               uValue := If( cType == "N", oCol:oEdit:nAt, ;
                             oCol:oEdit:aItems[ oCol:oEdit:nAt ] )

               If cType == "N"
                  uValue := oCol:oEdit:nAt
               Else
                  uValue := Substr( uValue, 1, Len( uVar ) )
               EndIf

            EndIf

            ::lChanged    := uValue != uVar
            ::lHasChanged := If( ::lChanged, .T., ::lHasChanged )

         EndIf

         ::oWnd:nLastKey := nKey

         If oCol:bEditEnd != Nil
            Eval( oCol:bEditEnd, uValue, Self, .T. )
         EndIf

         ::lAppendMode := oCol:oEdit:lAppend
         ::lEditing := .F.
         oCol:oEdit:Hide()
         oCol:oEdit:End()
         oCol:oEdit := Nil
         ::PostEdit( uValue, nCol, bValid )
         ::oWnd:bValid := ::oGet
         cMsg := If( ! Empty( oCol:cMsg ), oCol:cMsg, ::cMsg )
         cMsg := If( Valtype( cMsg ) == "B", Eval( cMsg, Self, ::nCell ), cMsg )
         ::SetMsg( cMsg )
         Return Nil

      EndIf

      uValue := oCol:oEdit:VarGet()

      If oCol:bCustomEdit != Nil
         uValue := Eval( oCol:bCustomEdit, uValue, oCol:oEdit, Self )
      EndIf

      If ::lAppendMode .and. Empty( oCol:oEdit:VarGet() ) .and. nKey != VK_RETURN

         bValid := {||.F.}

      EndIf

      If oCol:bEditEnd != Nil
         Eval( oCol:bEditEnd, uValue, Self, .T. )
      EndIf

      ::lChanged := ValType( uValue ) != ValType( uVar ) .or. uValue != uVar
      ::lHasChanged := If( ::lChanged, .T., ::lHasChanged )
      ::oWnd:nLastKey := nKey
      oCol:oEdit:Hide()
      oCol:oEdit:End()
      oCol:oEdit := Nil
      ::oWnd:bValid := ::oGet
      ::PostEdit( uValue, nCol, bValid )
      cMsg := If( ! Empty( oCol:cMsg ), oCol:cMsg, ::cMsg )
      cMsg := If( Valtype( cMsg ) == "B", Eval( cMsg, Self, ::nCell ), cMsg )
      ::SetMsg( cMsg )

   Else

      If ::lPostEdit
         Return Nil
      EndIf

      If oCol:bEditEnd != Nil .and. ValType( oCol:oEdit ) == "O"
         Eval( oCol:bEditEnd, uValue, Self, .F. )
      EndIf

      If lCombo
         ::lAppendMode := oCol:oEdit:lAppend
      EndIf

      ::oWnd:bValid := ::oGet

      If ValType( oCol:oEdit ) == "O"
         ::lEditing := .F.
         oCol:oEdit:Hide()
         oCol:oEdit:End()
         oCol:oEdit := Nil
      EndIf

      ::oWnd:nLastKey := VK_ESCAPE
      ::lChanged := .F.
      ::SetMsg( oCol:cMsg )
      ::lEditing := .F.

      If ::lAppendMode

         ::lAppendMode := .F.
         ::lHitBottom  := .F.
         ::lNoPaint    := .F.

         If ::nLen <= ::nRowCount()
            ::Refresh( .T. )
            ::GoBottom()
         Else
            ::GoBottom()
         EndIf

      EndIf

      cMsg := If( ! Empty( oCol:cMsg ), oCol:cMsg, ::cMsg )
      cMsg := If( Valtype( cMsg ) == "B", Eval( cMsg, Self, ::nCell ), cMsg )
      ::SetMsg( cMsg )

   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:ExcelOle() Version 8.0 Feb/01/2008
* Requires TOleAuto class
* Many thanks to Victor Manuel Toms for the core of this method
* ============================================================================

METHOD ExcelOle( cXlsFile, lActivate, oMeter, cTitle, oFont, lSave, bExtern, aColSel, bPrintRow ) CLASS TSBrowse

   Local oExcel, oBook, oSheet, nRow, nCol, uData, nEvery, oRange, cRange, cCell, cLet, nColHead, ;
         bError, cText, oClip, nStart, aRepl, ;
         nLine  := 1, ;
         nCount := 0, ;
         nRecNo := ( ::cAlias )->( RecNo() ), ;
         nAt    := ::nAt, ;
         aCol := { 26, 52, 78, 104, 130, 156 }, ;
         aLet := { "", "A", "B", "C", "D", "E" }

   Default lActivate := Empty( cXlsFile ), ;
           cTitle    := "", ;
           lSave     := .F., ;
           cXlsFile  := ""

   CursorWait()
   cLet := aLet[ AScan( aCol, {|e| Len( If( aColSel != Nil, aColSel, ::aColumns ) ) <= e } ) ]

   If ! Empty( cLet )
      nCol := AScan( aLet, cLet ) - 1
      cLet += Chr( 64 + Len( If( aColSel != Nil, aColSel, ::aColumns ) ) - aCol[ Max( 1, nCol ) ] )
   Else
      cLet := Chr( 64 + Len( If( aColSel != Nil, aColSel, ::aColumns ) ) )
   EndIf

   aRepl      := {}
   ::lNoPaint := .F.

   If oMeter != Nil
      oMeter:nTotal := ( ::nLen + 1 ) * Len( ::aColumns ) + 30
      oMeter:Set( 0 )
      oMeter:Refresh()
      nEvery := Max( 1, Int( oMeter:nTotal * .02 ) ) // refresh ometer every 2 %
   EndIf

   If ! Empty( cXlsFile )
      cXlsFile := AllTrim( StrTran( Upper( cXlsFile ), ".XLS" ) )
   EndIf

   cTitle   := AllTrim( cTitle )
   bError   := ErrorBlock( { | x | Break( x ) } )

   Begin Sequence
      oExcel := TOleAuto():New("Excel.Application")
   Recover
      ErrorBlock( bError )
      CursorArrow()
      MsgStop( "No Ole.lib searched", "Error" )
      Return Nil
   End Sequence

   ErrorBlock( bError )

   If oMeter != Nil
      nCount -= 15
      oMeter:Set( nCount )
   EndIf

   oExcel:WorkBooks:Add()
   oBook  := oExcel:Get( "ActiveWorkBook")
   oSheet := oExcel:Get( "ActiveSheet" )

   If oMeter != Nil
      nCount -= 15
      oMeter:Set( nCount )
   EndIf

   ( ::cAlias )->( Eval( ::bGoTop ) )

   cText := ""

   For nRow := 1 To ::nLen

      If nRow == 1

         If ! Empty( cTitle )
            oSheet:Cells( nLine++, 1 ):Value := AllTrim( cTitle )
            oSheet:Range( "A1:" + cLet + "1" ):Set( "HorizontalAlignment", 7 )
            ++nLine
            nStart := nLine
         Else
            nStart := nLine
         EndIf

         If ! Empty( ::aSuperHead )

            For nCol := 1 To Len( ::aSuperHead )
               uData := If( ValType( ::aSuperhead[ nCol, 3 ] ) == "B", Eval( ::aSuperhead[ nCol, 3 ] ), ;
                                     ::aSuperhead[ nCol, 3 ] )
               oSheet:Cells( nLine, ::aSuperHead[ nCol, 1 ] ):Value := uData
               cRange :=  Chr( 64 + ::aSuperHead[ nCol, 1 ] ) + LTrim( Str( nLine ) ) + ":" + ;
                          Chr( 64 + ::aSuperHead[ nCol, 2 ] ) + LTrim( Str( nLine ) )
               oSheet:Range( cRange ):Borders():LineStyle := 1
               oSheet:Range( cRange ):Set( "HorizontalAlignment", 7 )
            Next

            nStart := nLine ++
         EndIf

         nColHead := 0

         For nCol := 1 To Len( ::aColumns )

            If aColSel != Nil .and. AScan( aColSel, nCol ) == 0
               Loop
            EndIf

            uData := If( ValType( ::aColumns[ nCol ]:cHeading ) == "B", Eval( ::aColumns[ nCol ]:cHeading ), ;
                                  ::aColumns[ nCol ]:cHeading )

            If ValType( uData ) != "C"
               Loop
            EndIf

            uData := StrTran( uData, CRLF, Chr( 10 ) )
            nColHead ++
            oSheet:Cells( nLine, nColHead ):Value := uData

            If oMeter != Nil

               If nCount % nEvery == 0
                  oMeter:Set( nCount )
               EndIf

               nCount ++

            EndIf

         Next

         nStart := ++ nLine

      EndIf

      If bPrintRow != Nil .and. ! Eval( bPrintRow, nRow )
         ::Skip( 1 )
         Loop
      EndIf

      For nCol := 1 To Len( ::aColumns )

         If aColSel != Nil .and. AScan( aColSel, nCol ) == 0
            Loop
         EndIf

         uData := Eval( ::aColumns[ nCol ]:bData )

         If ValType( uData ) == "C" .and. At( CRLF, uData ) > 0
            uData := StrTran( uData, CRLF, "&&" ) // Chr( 10 ) )

            If AScan( aRepl, nCol ) == 0
               AAdd( aRepl, nCol )
            EndIf
         EndIf


         If ::aColumns[ nCol ]:cPicture != Nil
            uData := Transform( uData, ::aColumns[ nCol ]:cPicture )
         EndIf

         uData  :=  IIF( ValType( uData )=="D", DtoC( uData ), ;
                    IIF( ValType( uData )=="N", Str( uData ) , ;
                    IIF( ValType( uData )=="L", IIF( uData ,".T." ,".F." ), cValToChar( uData ) ) ) )

         cText += Trim( uData ) + Chr( 9 )

         If oMeter != Nil

            If nCount % nEvery == 0
               oMeter:Set( nCount )
            EndIf

            nCount ++

         EndIf

      Next

      ::Skip( 1 )
      cText += Chr( 13 )

      ++nLine
      /*
         Cada 20k volcamos el texto a la hoja de Excel , usando el portapapeles , algo muy rapido y facil ;-)
         Every 20k set text into excel sheet , using Clipboard , very easy and faster.
      */

      IF Len( cText ) > 20000

         oClip := TClipBoard():New()
         oClip:Clear()
         oClip:SetText( cText )
         cCell := "A" + Alltrim( Str( nStart ) )
         oRange := oSheet:Range( cCell )
         oRange:Select()
         oSheet:Paste()
         oClip:End()
         cText := ""
         nStart := nLine + 1

      EndIf

   Next

   If AScan( ::aColumns, { |o| o:cFooting != Nil  } ) > 0

      For nCol := 1 To Len( ::aColumns )

         If ( aColSel != Nil .and. AScan( aColSel, nCol ) == 0 ) .or. ::aColumns[ nCol ]:cFooting == Nil
            Loop
         EndIf

         uData := If( ValType( ::aColumns[ nCol ]:cFooting ) == "B", Eval( ::aColumns[ nCol ]:cFooting ), ;
                      ::aColumns[ nCol ]:cFooting )
         uData := cValTochar( uData )
         uData := StrTran( uData, CRLF, Chr( 10 ) )
         oSheet:Cells( nLine, nCol ):Value := uData

      Next

   EndIf

   If ::lIsDbf
      ( ::cAlias )->( DbGoTo( nRecNo ) )
   EndIf

   ::nAt := nAt

   If Len( cText ) > 0
      oClip := TClipBoard():New()
      oClip:Clear()
      oClip:SetText( cText )
      cCell := "A" + Alltrim( Str( nStart ) )
      oRange := oSheet:Range( cCell )
      oRange:Select()
      oSheet:Paste()
      oClip:End()
      cText := ""
   EndIf

   nLine := If( ! Empty( cTitle ), 3, 1 )
   nLIne += If( ! Empty( ::aSuperHead ), 1, 0 )
   cRange := "A" + LTrim( Str( nLine ) ) + ":" + cLet + Alltrim( Str( oSheet:UsedRange:Rows:Count() ) )
   oRange := oSheet:Range( cRange )

   If oFont != Nil // let the programmer to decide the font he wants, otherwise use Excel's default
      oRange:Font:Name := oFont:cFaceName
      oRange:Font:Size := oFont:nSize()
      oRange:Font:Bold := oFont:lBold
   EndIf

   If ! Empty( aRepl )
      For nCol := 1 To Len( aRepl )
         oSheet:Columns( Chr( 64 + aRepl[ nCol ] ) ):Replace( "&&", Chr( 10 ) )
      Next
   EndIf

   If bExtern != Nil
      Eval( bExtern, oSheet, Self )
   EndIf

   oRange:Borders():LineStyle := 1
   oRange:Columns:AutoFit()

   If ! Empty( aRepl )
      For nCol := 1 To Len( aRepl )
         oSheet:Columns( Chr( 64 + aRepl[ nCol ] ) ):WrapText := .T.
      Next
   EndIf

   If oMeter != Nil
      oMeter:Set( oMeter:nTotal )
   EndIf

   If ! Empty( cXlsFile ) .and. lSave
      oBook:SaveAs( cXlsFile, -4143 )   // -4143 = Normal
   EndIf

   oSheet:Range( "A1" ):Select()
   CursorArrow()

   If lActivate
      oExcel:Visible := .T.
   EndIf

   OleUninitialize()
   ::Reset()

Return Nil

* ============================================================================
* METHOD TSBrowse:ExpLocate() Version 8.0 Feb/01/2008
* ============================================================================

METHOD ExpLocate( cExp, nCol ) CLASS TSBrowse

   Local uExp, bExp, nEle, ;
         nLines := ::nRowCount(), ;
         nRecNo := ( ::cAlias )->( RecNo() ), ;
         bError := ErrorBlock( { | x | Break( x ) } )

   ::lValidating := .T.

   Begin Sequence
      uExp := &( cExp )
   Recover
      ErrorBlock( bError )
      Tone( 500, 1 )
      Return .F.
   End Sequence

   ErrorBlock( bError )

   bExp := &( "{||(" + Trim( cExp ) + ")}" )

   If Eval( bExp )
      ::Skip( 1 )
   EndIf

   ( ::cAlias )->( __dbLocate( bExp,,,, .T. ) )

   If EoF()
      ( ::cAlias)->( DbGoTo( nRecNo ) )
      Tone( 500, 1 )
      Return .F.
   EndIf

   If ::lDbfObj
      If nRecNo != ::oDbf:RecNo()
         ::Refresh( .F. )
         If ::nLastPainted < ::nRowCount()
            ::Refresh( .T. )
         EndIf
         ::ResetBarPos()
         ::nAt := ::nLogicPos()
      EndIf
   Else
      If nRecNo != ( ::cAlias )->( RecNo() ) .and. ::nLen > nLines

         nRecNo := ( ::cAlias )->( RecNo() )
         ( ::cAlias )->( DbSkip( nLines - ::nRowPos ) )

         If ( ::cAlias )->( EoF() )

            Eval( ::bGoBottom )
            ::nRowPos := nLines
            ::nAt := ::nLogicPos()

            While ::nRowPos > 1 .and. ( ::cAlias )->( RecNo() ) != nRecNo
               ::Skip( -1 )
               ::nRowPos --
            EndDo
         Else
            ( ::cAlias )->( DbGoTo( nRecNo ) )
            ::nAt := ::nLogicPos()
         EndIf

         ::Refresh( .F. )
         ::ResetBarPos()
      ElseIf nRecNo != ( ::cAlias )->( RecNo() )
         nRecNo := ( ::cAlias )->( RecNo() )
         Eval( ::bGoTop )
         ::nAt := ::nRowPos := 1

         While nRecNo != ( ::cAlias )->( RecNo() )
            ::Skip( 1 )
            ::nRowPos++
         EndDo
         ::Refresh( .F. )
         ::ResetBarPos()
      EndIf
   EndIf

   If ::bChange != Nil
      Eval( ::bChange, Self, 0 )
   EndIf

   If ::lIsArr .and. ::bSetGet != Nil
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, ::nAt )
      ElseIf ::nLen > 0
         Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
      Else
         Eval( ::bSetGet, "" )
      EndIf
   EndIf

   ::lHitTop := ::lHitBottom := .F.

Return .T.

* ============================================================================
* METHOD TSBrowse:ExpSeek() Version 8.0 Feb/01/2008
* ============================================================================

METHOD ExpSeek( cExp, lSoft ) CLASS TSBrowse

   Local nQuote, uExp, ;
         nRecNo := ( ::cAlias )->( RecNo() ), ;
         nLines := ::nRowCount(), ;
         cType  := ValType( Eval( &("{||" + ;
                                  ( ::cAlias )->( IndexKey() ) + "}") ) ), ;
         bError := ErrorBlock( { | x | Break( x ) } )

   ::lValidating := .T.

   nQuote := At( '"', cExp )
   nQuote := If( nQuote == 0, At( "'", cExp ), nQuote )

   cExp := If( cType == "C" .and. nQuote == 0, '"' + Trim( cExp ) + '"', ;
               If( cType == "D" .and. At( "CTOD", Upper( cExp ) ) == 0, 'CtoD( "' + AllTrim( cExp ) + '")', ;
           If( cType == "N", AllTrim( cExp ), If( cType == "L", If( AllTrim( cExp ) == "T", ".T.", ".F." ), ;
               AllTrim( cExp ) ) ) ) )

   Begin Sequence
      uExp := &( cExp )
   Recover
      ErrorBlock( bError )
      Tone( 500, 1 )
      Return .F.
   End Sequence

   ErrorBlock( bError )

   ( ::cAlias )->( DbSeek( uExp, lSoft ) )

   If EoF()
      ( ::cAlias )->( DbGoTo( nRecNo ) )
      Tone( 500, 1 )
      Return .F.
   EndIf

   If ::lDbfObj

      If nRecNo != ::oDbf:RecNo()
         ::Refresh( .F. )

         If ::nLastPainted < ::nRowCount()
            ::Refresh( .T. )
         EndIf

         ::ResetBarPos()
         ::nAt := ::nLogicPos()

      EndIf

   Else

      If nRecNo != ( ::cAlias )->( RecNo() ) .and. ::nLen > nLines

         nRecNo := ( ::cAlias )->( RecNo() )
         ( ::cAlias )->( DbSkip( nLines - ::nRowPos ) )

         If ( ::cAlias )->( EoF() )

            Eval( ::bGoBottom )
            ::nRowPos := nLines
            ::nAt := ::nLogicPos()

            While ::nRowPos > 1 .and. ( ::cAlias )->( RecNo() ) != nRecNo
               ::Skip( -1 )
               ::nRowPos --
            EndDo
         Else
            ( ::cAlias )->( DbGoTo( nRecNo ) )
            ::nAt := ::nLogicPos()
         EndIf

         ::Refresh( .F. )
         ::ResetBarPos()

      ElseIf nRecNo != ( ::cAlias )->( RecNo() )

         nRecNo := ( ::cAlias )->( RecNo() )
         Eval( ::bGoTop )
         ::nAt := ::nRowPos := 1

         While nRecNo != ( ::cAlias )->( RecNo() )
            ::Skip( 1 )
            ::nRowPos ++
         EndDo

         ::Refresh( .F. )
         ::ResetBarPos()

      EndIf

   EndIf

   If ::bChange != Nil
      Eval( ::bChange, Self, 0 )
   EndIf

   If ::lIsArr .and. ::bSetGet != Nil
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, ::nAt )
      ElseIf ::nLen > 0
         Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
      Else
         Eval( ::bSetGet, "" )
      EndIf
   EndIf

   ::lHitTop := ::lHitBottom := .F.

Return .T.

* ============================================================================
* METHOD TSBrowse:FreezeCol() Version 8.0 Feb/01/2008
* ============================================================================

METHOD FreezeCol( lNext ) CLASS TSBrowse

   Local nFreeze := ::nFreeze

   Default lNext := .T.

	If lNext                                      // freeze next available column
		::nFreeze := Min( nFreeze + 1, Len( ::aColumns ) )
	Else                                          // unfreeze previous column
		::nFreeze := Max( nFreeze - 1, 0 )
   EndIf

   If ::nFreeze != nFreeze                        // only update if necessary
      If( ! lNext, ::PanHome(), Nil )
		::HiliteCell( ::nFreeze + 1 )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GetColumn() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GetColumn( nCol ) CLASS TSBrowse

	Default nCol := 1

	If nCol < 1
		nCol := 1
   ElseIf nCol > Len( ::aColumns )
		nCol := Len( ::aColumns )
   EndIf

Return ::aColumns[ nCol ]                       // returns a Column object

* ============================================================================
* METHOD TSBrowse:GetDlgCode() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GetDlgCode( nLastKey ) CLASS TSBrowse

   // This method is very similar to TControl:GetDlgCode() but it is
   // necessary to have WHEN working

   If ! ::oWnd:lValidating
      If nLastKey == VK_UP .or. nLastKey == VK_DOWN ;
         .or. nLastKey == VK_RETURN .or. nLastKey == VK_TAB
         ::oWnd:nLastKey := nLastKey
      Else
         ::oWnd:nLastKey := 0
      EndIf
   EndIf

Return If( IsWindowEnabled( ::hWnd ) .and. nLastKey != VK_ESCAPE, ;
           DLGC_WANTALLKEYS, 0 )

* ============================================================================
* METHOD TSBrowse:GetRealPos() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GetRealPos( nRelPos ) CLASS TSBrowse

   Local nLen

   If ::nLen == 0
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), Eval( ::bLogicLen ) )
   EndIf

   nLen := ::nLen

   nRelPos := If( nLen > MAX_POS, Int( ( nRelPos / MAX_POS ) * nLen ), nRelPos )

Return nRelPos

* ============================================================================
* METHOD TSBrowse:GoBottom() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GoBottom() CLASS TSBrowse

   Local nLines := ::nRowCount()

   If ::nLen == 0
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), Eval( ::bLogicLen ) )
   EndIf

   If ::nLen < 1
      Return Self
   EndIf

   ::lAppendMode := .F.
	::ResetSeek()

   If ! ::lHitBottom

      Eval( ::bGoBottom )
      ::lHitBottom := .T.
      ::lHitTop    := .F.
      ::nRowPos    := Min( nLines, ::nLen )
      ::nAt        := ::nLastnAt := ::nLogicPos()

      If ::lIsDbf
         ::nLastPos := ( ::cAlias )->( RecNo() )
      EndIf

      If ::bChange != Nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      EndIf

      If ::oVScroll != Nil
         ::oVScroll:SetPos( ::oVScroll:nMax )
      EndIf

      ::Refresh( ::nLen < nLines )

      If ::lIsArr .and. ::bSetGet != Nil
         If ValType( Eval( ::bSetGet ) ) == "N"
            Eval( ::bSetGet, ::nAt )
         ElseIf ::nLen > 0
            Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
         Else
            Eval( ::bSetGet, "" )
         EndIf
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GoDown() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GoDown() CLASS TSBrowse

   Local nSkipped, nFirst, ;
         nLines    := ::nRowCount(), ;
         lRePaint  := .F., ;
         lEditable := .F., ;
         lTranspar := ::lTransparent .and. ( ::oBrush != Nil .or. ::oWnd:oBrush != Nil )

   If ::nLen < 1       // for empty dbfs or arrays
		If ::lCanAppend
			::nRowPos := 1
		Else
      	Return Self
      EndIf
   EndIf

   ::ResetSeek()

   If ::nLen <= nLines .and. ::lNoLiteBar
      Return Self
   EndIf

   If ::lNoLiteBar
      nFirst := nLines - ::nRowPos
      ::Skip( nFirst )
      ::nRowPos := nLines
   EndIf

   ::nRowPos := Max( 1, ::nRowPos )
   AEval( ::aColumns, { |o,n| If( ::lCanAppend .and. ;
                                  o:lEdit, lEditable := .T., Nil ) } )

   If ! ::lAppendMode
      ::nPrevRec := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )
   EndIf

   If ! ::lHitBottom

      If ! ::lAppendMode .and. ! ::lIsTxt
         ::DrawLine()
      EndIf

      If ::Skip( 1 ) == 1
         ::lHitTop := .F.

         If ::nRowPos < nLines
            ::nRowPos++
         Else
            If ::lPageMode
               lRePaint := If( ( ::nLogicPos + nLines - 1 ) > ::nLen, .T., .F. )
               ::nRowPos := 1
               ::Refresh( lRePaint )
            Else
               If lTranspar
                  ::Paint()
               Else
                  ::nRowPos := nLines
                  ::lRePaint := .F.
                  ::TSBrwScroll( 1 )
                  ::Skip( -( nLines - 1 ) )
                  ::Skip( nLines - 1 )
               EndIf
            EndIf

         EndIf

      Else
         Eval( ::bGoBottom )
         ::lHitBottom := .T.
      EndIf

      If ! ::lAppendMode .and. ! ::lEditing
         ::DrawSelect()
      EndIf

      If ::oVScroll != Nil .and. ! ::lAppendMode
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
      EndIf

      If ! ::lHitBottom .and. ! ::lAppendMode .and. ::bChange != nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      EndIf

   ElseIf ::lCanAppend .and. lEditable .and. ! ::lAppendMode

      ::lAppendMode := .T.
      nFirst := 0
      Aeval( ::aColumns, { | oCol, nCol | nFirst := If( ::IsEditable( nCol ) .and. nFirst == 0, nCol, nFirst ) } )

      If nFirst == 0
         ::lAppendMode := .F.
         ::lHitTop := ::lHitBottom := .F.
         Return Self
      EndIf

      If ::nCell != nFirst .and. ! ::IsColVisible( nFirst )

         While ! ::IsColVisible( nFirst )
            ::nColPos += If( nFirst < ::nCell, -1, 1 )
         EndDo

      EndIf

      ::lHitTop := ::lHitBottom := .F.
      ::nCell := nFirst

      If ::lIsArr
         ::lAppendMode := .F.
         ::DrawLine()
         ::lAppendMode := .T.
      Else
         ::DrawLine()
      EndIf

      ::GoDown()                // recursive call to force entry to itself
      ::nLastKey := ::oWnd:nLastKey := VK_RETURN
      ::DrawLine()

      If ! ::lAutoEdit
         ::PostMsg( WM_KEYDOWN, VK_RETURN, nMakeLong( 0, 0 ) )
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GoEnd() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GoEnd() CLASS TSBrowse

   Local nTxtWid, nI, nLastCol, nBegin, ;
         nWidth   := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ), ;
         nWide    := 0, ;
         nCols    := Len( ::aColumns ), ;
         nPos     := ::nColPos

   If ::lIsTxt
      nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::oFont != Nil, ::oFont:hFont, 0 ) ) )

      If ::nAt < ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
			::nAt := ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
         ::Refresh( .F. )
         If ::oHScroll != Nil
				::oHScroll:SetPos( ::nAt )
         EndIf
      EndIf

      Return Self
   EndIf

   nLastCol := Len( ::aColumns )
   nBegin := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1,;
                  ::nColPos - ::nFreeze ), ::nColPos - ::nFreeze ), nLastCol )

   nWide := 0

   For nI := nBegin To nPos
       nWide += ::aColSizes[ nI ]
   Next

   nBegin := ::nCell

   For nI := nPos + 1 To nCols
      If nWide + ::aColSizes[ nI ] <= nWidth    // only if column if fully visible
         nWide += ::aColSizes[ nI ]
         ::nCell := nI
		Else
			Exit
      EndIf
	Next

   If nBegin == ::nCell
      Return Self
   EndIf

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

   EndIf

   ::Refresh( .F. )

   If ::oHScroll != Nil
		::oHScroll:SetPos( ::nCell )
   EndIf

	::nOldCell := ::nCell
	::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:GoHome() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GoHome() CLASS TSBrowse

   ::nOldCell := ::nCell

   If ::lIsTxt

		If ::nAt > 1
			::nAt := 1
         ::Refresh( .F. )
         If ::oHScroll != Nil
				::oHScroll:SetPos( ::nAt )
         EndIf
      EndIf
		Return Self
   EndIf

	::nCell := ::nColPos

   If ::nCell == ::nOldCell
      Return Self
   EndIf

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

   EndIf

   ::Refresh( .F. )

   If ::oHScroll != Nil
		::oHScroll:SetPos( ::nCell )
   EndIf

	::nOldCell := ::nCell
	::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:GoLeft() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GoLeft()  CLASS TSBrowse

   Local nCell, nSkip, ;
         lLock := ::nFreeze > 0 .and. ::lLockFreeze, ;
         lDraw := .F.

   ::nOldCell := ::nCell

   If ::lIsTxt
      If ::nOffset > 5
         ::nOffset -= 5
      Else
         ::nOffset := 1
      EndIf
      ::Refresh( .F. )

      If ::oHScroll != Nil
         ::oHScroll:SetPos( ::nOffset )
      EndIf
      Return Self
   EndIf

   ::ResetSeek()

   If ::lCellBrw

      nCell := ::nCell
      nSkip := 0

      While nCell > ( If( lLock, ::nFreeze + 1, 1 ) )

         nCell --
         nSkip ++

         If ! ::aColumns[ nCell ]:lNoHilite
            Exit
         EndIf

      EndDo

      If nSkip == 0
         Return Self
      EndIf

      While ::nColPos > ( ::nFreeze + 1 ) .and. ! ::IsColVisible( nCell )
         lDraw := .T.
         ::nColPos --
      EndDo

      ::nCell := nCell

      If lDraw
         ::Refresh( .F. )
      EndIf

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      If( ::oHScroll != Nil, ::oHScroll:SetPos( ::nCell ), Nil )
      ::nOldCell := ::nCell
      ::HiliteCell( ::nCell )
      ::DrawSelect()

	Else

      If ::nCell > ( ::nFreeze + 1 )

         ::nColPos := ::nCell := ::nFreeze + 1
         ::Refresh( .F. )

         If ::oHScroll != Nil
            ::oHScroll:GoTop()
         EndIf

      EndIf

   EndIf

Return Self

// ============================================================================
// METHOD TSBrowse:GoNext() Version 8.0 Feb/01/2008
// Post-edition cursor movement.  Cursor goes to next editable cell, right
// or first-down according to the position of the last edited cell.
// This method is activated when the MOVE clause of ADD COLUMN command is
// set to 5 ( DT_MOVE_NEXT )
// ============================================================================

METHOD GoNext() CLASS TSBrowse

   Local nEle, ;
         nFirst := 0

   ::nOldCell   := ::nCell
//   ::lHitBottom := ::lHitTop := .F.

   For nEle := ( ::nCell  + 1 ) To Len( ::aColumns )

      If ::IsEditable( nEle ) .and. ! ::aColumns[ nEle ]:lNoHiLite

         nFirst := nEle
         Exit

      EndIf

   Next

   If nFirst > 0

      If ::IsColVisible( nFirst )

         ::nCell := nFirst
         ::HiLiteCell( ::nCell )

         If ! ::lAutoEdit
            ::DrawSelect()
         Else
            ::DrawLine()
         EndIf

      Else

         While ! ::IsColVisible( nFirst ) .and. ::nColPos < nFirst
            ::nColPos ++
         EndDo

         ::lNoPaint := .F.
         ::nCell := nFirst
         ::HiliteCell( nFirst )
         ::Refresh( .F. )
      EndIf

      If ::oHScroll != Nil
         ::oHScroll:SetPos( ::nCell )
      EndIf

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell
      Return Self

   EndIf

   Aeval( ::aColumns, { | oCol, nCol | ;
                        nFirst := If( ::IsEditable( nCol ) .and. nFirst == 0, ;
                                      nCol, nFirst ) } )
   If nFirst == 0
      Return Self
   EndIf

   If ::IsColVisible( nFirst )
      ::nCell := nFirst
      ::lNoPaint := .F.
   Else

      ::nColPos := Min( nFirst, ::nFreeze + 1 )
      ::nCell   := nFirst

      While ::nColPos < ::nCell .and. ! ::IsColVisible( ::nCell )
         ::nColPos ++
      EndDo

      ::lNoPaint := .F.
      ::Refresh( .F. )

   EndIf

   ::HiliteCell( ::nCell )

   If( ::oHScroll != Nil, ::oHScroll:SetPos( ::nCell ), Nil )

   If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
      Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
   EndIf

   If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
      Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
   EndIf

   If ::lAutoEdit
      SysRefresh()
   EndIf

   ::nOldCell := ::nCell
   ::lHitBottom := ::nAt == ::nLen
   ::GoDown()

Return Self

// ============================================================================
// METHOD TSBrowse:GoPos() Version 8.0 Feb/01/2008
// ============================================================================

METHOD GoPos( nNewRow, nNewCol ) CLASS TSBrowse

   Local nSkip, cAlias, nRecNo, ;
         nTotRow := ::nRowCount(), ;
         nOldRow := ::nLogicPos(), ;
         nOldCol := ::nCell

   Default nNewRow := ::nLogicPos, ;
           nNewCol := ::nCell

   ::lNoPaint := ::lFirstFocus := .F.

   If ValType( nNewRow ) != "N" .or. ValType( nNewCol ) != "N" .or. ;
      nNewCol > Len( ::aColumns ) .or. nNewRow > ::nLen .or. ;
      nNewCol <= 0 .or. nNewRow <= 0

      Tone( 500, 1 )
      Return Nil

   EndIf

   If ::lDbfObj
      cAlias := ::oDbf:cAlias
   Else
      cAlias := ::cAlias
   EndIf

   nSkip := nNewRow - nOldRow

   If ( ::nRowPos + nSkip ) <= nTotRow .and. ( ::nRowPos + nSkip ) >= 1

      ::Skip( nSkip )
      ::nRowPos += nSkip

   ElseIf ! ::lIsDbf
      ::nAt := nNewRow
   ElseIf Empty( ::nLogicPos() )

      While ::nAt != nNewRow

         If ::nAt < nNewRow
            ::Skip( 1 )
         Else
            ::Skip( -1 )
         EndIf

      EndDo

   ElseIf ! Empty( ::nLogicPos() )

      ( cAlias )->( DbSkip( nSkip ) )
      ::nAt := ::nLogicPos()

   Else
      ( cAlias )->( Eval( ::bGoToPos, nNewRow ) )
      ::nAt := ::nLogicPos()
   EndIf

   If nNewRow != nOldRow .and. ::nLen > nTotRow .and. nNewRow > nTotRow

      If ::lIsDbf

         nRecNo := ( cAlias )->( RecNo() )

         ( cAlias )->( DbSkip( nTotRow - ::nRowPos ) )

         If ( cAlias )->( EoF() )

            Eval( ::bGoBottom )
            ::nRowPos := nTotRow

            While ::nRowPos > 1 .and. ( cAlias )->( RecNo() ) != nRecNo
               ::Skip( -1 )
               ::nRowPos --
            EndDo

         Else
            ( cAlias )->( DbGoTo( nRecNo ) )
         EndIf

      Else

         If ( ::nAt + nTotRow - ::nRowPos ) > ::nLen

            Eval( ::bGoBottom )
            ::nRowPos := nTotRow

            While ::nRowPos > 1 .and. ::nAt != nNewRow
               ::Skip( -1 )
               ::nRowPos --
            EndDo

         EndIf

      EndIf

   ElseIf nNewRow != nOldRow .and. ::nLen > nTotRow

      If ::lIsDbf

         nRecNo := ( cAlias )->( RecNo() )
         Eval( ::bGoTop )
         ::nRowPos := ::nAt := 1

         While ::nRowPos < nTotRow .and. ( cAlias )->( RecNo() ) != nRecNo
            ::Skip( 1 )
            ::nRowPos ++
         EndDo

      Else

         Eval( ::bGoTop )
         ::nRowPos := ::nAt := 1

         While ::nRowPos < nTotRow .and. ::nAt != nNewRow
            ::Skip( 1 )
            ::nRowPos ++
         EndDo

      EndIf

   EndIf

   If nNewCol != nOldCol

      While ! ::IsColVisible( nNewCol ) .and. ::nColpos >= 1 .and. ::nColPos

         If nNewCol < ::nCell
            ::nColPos --
         Else
            ::nColPos ++
         EndIf

      EndDo

   EndIf

   ::nCell := nNewCol
   ::Refresh( .F. )

   If ::bChange != Nil .and. nNewRow != nOldRow
      Eval( ::bChange, Self, 0 )
   EndIf

   If ::oVScroll != Nil .and. nNewRow != nOldRow
      ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
   EndIf

   If ::oHScroll != Nil .and. nNewCol != nOldCol
      ::oHScroll:SetPos( nNewCol )
   EndIf

   ::lHitTop := ::nAt == 1

   If ::lIsArr .and. ::bSetGet != Nil
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, ::nAt )
      ElseIf ::nLen > 0
         Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
      Else
         Eval( ::bSetGet, "" )
      EndIf
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:GoRight() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GoRight() CLASS TSBrowse

   Local nI, nLeftPix, nTxtWid, nWidth, nCell, nSkip, ;
         lRefresh := .F.

   ::nOldCell := ::nCell
   nWidth   := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If ::lIsTxt
      nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::oFont != nil, ::oFont:hFont, 0 ) ) )
      If ::nOffset < ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
         ::nOffset += 5
         ::Refresh( .F. )
         If ::oHScroll != Nil
            ::oHScroll:SetPos( ::nOffset )
         EndIf
      EndIf
		Return Self
   EndIf

   ::ResetSeek()

   If ::lCellBrw

      If ::nCell == Len( ::aColumns ) .and. ;  // avoid undesired displacement  //::GetColSizes()
         ::IsColVisible( ::nCell )
         Return Self
      EndIf

      nCell := ::nCell
      nSkip := 0

      While nCell < Len( ::aColumns )
         nCell ++
         nSkip ++
         If nCell <= Len( ::aColumns ) .and. ! ::aColumns[ nCell ]:lNoHilite
            Exit
         EndIf
      EndDo

      If nCell > Len( ::aColumns )
         Return Self
      EndIf

      While nSkip > 0
         ::nCell ++
         nSkip --
      EndDo

      While ! ::IsColVisible( ::nCell ) .and. ::nColPos < ::nCell
         ::nColPos ++
         lRefresh := .T.
      EndDo

      ::HiliteCell( ::nCell )

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      If lRefresh
         ::lNoPaint := .F.
         ::Refresh( .F. )
      ElseIf ! ::lEditing
         ::DrawSelect()
      EndIf

      If( ::oHScroll != Nil, ::oHScroll:SetPos( ::nCell ), Nil )

      ::nOldCell := ::nCell

   Else

      If ::nCell == Len( ::aColumns ) .and. ;  // avoid undesired displacement  //::GetColSizes()
         ::IsColVisible( ::nCell )
         Return Self
      EndIf

      If ::oHScroll != Nil
         ::HScroll( SB_PAGEDOWN )
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GotFocus() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GotFocus( hCtlLost ) CLASS TSBrowse

   Local cMsg

   Default ::lPostEdit   := .F., ;
           ::lFirstFocus := .T., ;
           ::lNoPaint    := .F., ;
           ::lInitGoTop  := .T.

   If ::lEditing .or. ::lPostEdit
      Return 0
   EndIf

   If ::oCtx != Nil
      ::oCtx:Restore()
   EndIf

   If ::lDrag
      Return Super:GotFocus( hCtlLost )
   EndIf

   ::lFocused       := .T.
   ::oWnd:nResult   := Self
   ::oWnd:oCtlFocus := Self
   ::oWnd:hCtlFocus := ::hWnd

   If ::bGotFocus != Nil
      Eval( ::bGotFocus, Self, hCtlLost )
   EndIf

   If ::lIsDbf .and. ::lPainted .and. ! ::lFirstFocus .and. ! ::lNoResetPos .and. ;
      ! ::lValidating .and. ! ::lNoPaint

      If ::uLastTag != Nil
         ( ::cAlias )->( Eval( ::bTagOrder, ::uLastTag ) )
      EndIf

      ( ::cAlias )->( DbGoTo( ::nLastPos ) )
      ::nAt := ::nLastnAt

   ElseIf ::lIsDbf .and. ::lFirstFocus .and. ! ::lNoResetPos .and. ! ::lValidating

      ::nLastPos := ( ::cAlias )->( RecNo() )
      ::nAt := ::nLastnAt := ::nLogicPos()

   EndIf

   ::lFirstFocus := .F.

   If ::nLen > 0 .and. ! EmptyAlias( ::cAlias ) .and. ! ::lIconView .and. ;
      ::lPainted
      ::DrawSelect()
   EndIf

   ::lHasFocus   := .T.
   ::lValidating := .F.

   If ::lCellBrw .and. ::lPainted
      cMsg := If( ! Empty( ::AColumns[ ::nCell ]:cMsg ), ;
                  ::AColumns[ ::nCell ]:cMsg, ::cMsg )
      cMsg := If( ValType( cMsg ) == "B", Eval( cMsg, Self, ::nCell ), cMsg )
      ::SetMsg( cMsg )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:GoTop() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GoTop() CLASS TSBrowse

   Local nAt       := ::nAt, ;
         nLines    := ::nRowCount, ;
         nRowPos   := ::nRowPos

   If ::nLen == 0
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), Eval( ::bLogicLen ) )
   EndIf

   If ::nLen < 1
      Return Self
   EndIf

   ::lAppendMode := .F.
	::ResetSeek()

   If ! ::lHitTop

      If ::lPainted .and. nAt < nLines
         ::DrawLine()
      EndIf

      Eval( ::bGoTop )

      ::lHitBottom := .F.
      ::nRowPos    := ::nAt := ::nLastnAt := 1
      ::lHitTop    := .T.

      If ::lIsDbf
         ::nLastPos := ( ::cAlias )->( RecNo() )
      EndIf

      If ::lPainted
         If nAt < nLines
            ::DrawSelect()
         Else
            ::Refresh( ::nLen < nLines )
         EndIf
      EndIf

      If ::oVScroll != Nil
         ::oVScroll:GoTop()
      EndIf

      If ::lPainted .and. ::bChange != Nil
         Eval( ::bChange, Self, VK_UP )
      EndIf

      If ::lIsArr .and. ::bSetGet != Nil
         If ValType( Eval( ::bSetGet ) ) == "N"
            Eval( ::bSetGet, ::nAt )
         ElseIf ::nLen > 0
            Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
         Else
            Eval( ::bSetGet, "" )
         EndIf
      EndIf

		::HiliteCell( ::nCell )

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GoUp() Version 8.0 Feb/01/2008
* ============================================================================

METHOD GoUp() CLASS TSBrowse

   Local nSkipped, ;
         nLines := ::nRowCount(), ;
         lTranspar := ::lTransparent .and. ( ::oBrush != Nil .or. ::oWnd:oBrush != Nil )

   If ::nLen < 1

      If ::lCanAppend .and. ::lAppendMode        // append mode being canceled
         ::lAppendMode := ::lHitBottom := .F.
			::nRowPos--                             // for empty dbfs
      Else
      	Return Self
      EndIf

   EndIf

   ::ResetSeek()

   If ::nLen <= nLines .and. ::lNoLiteBar
      Return Self
   EndIf

   If ::lNoLiteBar
      nSkipped := 1 - ::nRowPos
      ::Skip( nSkipped )
      ::nRowPos := 1
   EndIf

   If ::lAppendMode .and. ::lFilterMode .and. ::nPrevRec != Nil
      ( ::cAlias )->( DbGoTo( ::nPrevRec ) )
   EndIf

   If ! ::lHitTop

      If ! ::lAppendMode
         ::DrawLine()
      EndIf

      If ::Skip( -1 ) == -1

         ::lHitBottom := .F.

         If ::nRowPos > 1

            If ! ::lAppendMode .or. ( ::lAppendMode .and. ::nLen < nLines )
               ::nRowPos--
            EndIf

            If ::lAppendMode

               If ::lFilterMode
                  ::Skip( 1 )
               EndIf

               ::Refresh( If( ::nLen < nLines, .T., .F. ) )
               ::HiliteCell( ::nCell )

            EndIf

         Else

            If ::lPageMode
               ::nRowPos := nLines
               ::Refresh( .F. )
            Else
               If ! lTranspar
                  ::lRePaint := .F.
                  ::TSBrwScroll( -1 )
                  ::Skip( 1 )
                  ::DrawLine( 2 )
                  ::Skip( -1 )
               Else
                  ::Paint()
               EndIf
            EndIf

         EndIf

      ElseIf ! ::lAppendMode
         ::lHitTop := .T.
      EndIf

      ::DrawSelect()

      If ::oVScroll != Nil .and. ! ::lAppendMode
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
      EndIf

      If ::bChange != Nil
         Eval( ::bChange, Self, VK_UP )
      EndIf

   EndIf

   ::lAppendMode := .F.
	::nPrevRec := Nil

Return Self

* ==============================================================================
* METHOD TSBrowse:KeyChar()  Version 8.0 Feb/01/2008
* ==============================================================================

METHOD KeyChar( nKey, nFlags )  CLASS TSBrowse

   /* Next lines were added to filter keys according with
      the data type of columns to start editing cells. Also were defined
      two static functions IsChar() and IsNumeric() to do the job */

   Local cComp, lProcess, cTypeCol

   Default ::nLastKey := nKey

   If ::nLastKey == 255  // from KeyDown() method
      Return 0
   EndIf

   If ::lAppendMode
      Return 0
   EndIf

   ::lNoPaint := .F.
   cTypeCol := ValType( Eval( ::aColumns[ ::nCell ]:bData ) )

   If Upper( ::aMsg[ 1 ] ) == "YES"
      cComp := "TFYN10"
   else
      cComp := "TF10" + SubStr( ::aMsg[ 1 ], 1, 1 ) + SubStr( ::aMsg[ 2 ], 1, 1 )
   EndIf

   lProcess := IF(( cTypeCol == "C" .or. cTypeCol == "M") .and. IsChar( nKey ), .T., ;
               IF(( cTypeCol == "N" .or. cTypeCol == "D") .and. IsNumeric( nKey ), .T., ;
               IF( ( cTypeCol == "L" .and. Upper( Chr( nKey ) ) $ cComp ) .or. ;
                   ( cTypeCol == "L" .and. ::aColumns[ ::nCell ]:lCheckBox .and. nKey == VK_SPACE ), .T., .F. ) ) )

   // here we process direct cell editing with keyboard, not just the Enter key !
   If lProcess .and. ::IsEditable( ::nCell ) .and. ! ::aColumns[ ::nCell ]:lSeek

      If ::aColumns[ ::nCell ]:oEdit == Nil
         ::Edit( , ::nCell, nKey, nFlags )
      Else
         PostMessage( ::aColumns[ ::nCell ]:oEdit:hWnd, WM_CHAR, nKey, nFlags )
      EndIf

   ElseIf ::aColumns[ ::nCell ]:lSeek .and. nKey >= 32
      ::Seek( nKey )
   Else
		Super:KeyChar( nKey, nFlags )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:KeyDown() Version 8.0 Feb/01/2008
* ============================================================================

METHOD KeyDown( nKey, nFlags ) CLASS TSBrowse

   Local uTemp, aMoveCell, bRecLock, bAddRec, uVal, uReturn, ;
         lEditable := .F., ;
         nFireKey  := ::nFireKey, ;
         nCol      := ::nCell

   Default nFireKey := VK_F2

   ::lNoPaint := .F.
   ::oWnd:nLastKey := ::nLastKey := nKey

   If ::bUserKeys != Nil

      uReturn := Eval( ::bUserKeys, nKey, nFlags, Self )

      If uReturn != Nil .and. ValType( uReturn ) == "N" .and. ;
         uReturn < 200      // interpreted as a virtual key code to change
         nKey := uReturn    // the original key pressed
      ElseIf uReturn != Nil .and. ValType( uReturn ) == "L" .and. ;
             ! uReturn
                            // want to inhibit the KeyDown and KeyChar
         ::nLastKey := 255  // Methods for key pressed
         Return 0

      EndIf

   EndIf

   lEditable := ::IsEditable( nCol )

   Do Case                                       // Maintain Clipper behavior for key navigation
      Case ::lIgnoreKey( nKey, nFlags )          // has to go before any other case statement

           Super:KeyDown( nKey, nFlags )

      Case GetKeyState( VK_CONTROL ) .and. GetKeyState( VK_SHIFT )   // Ctrl+Shift+key

         If nKey == VK_RIGHT                     // Ctrl+Shift+Right Arrow
            ::aColumns[ nCol ]:nEditMove := DT_MOVE_RIGHT
         ElseIf nKey == VK_DOWN                  // Ctrl+Shift+Down Arrow
            ::aColumns[ nCol ]:nEditMove := DT_MOVE_DOWN
         ElseIf nKey == VK_UP                    // Ctrl+Shift+Up Arrow
            ::aColumns[ nCol ]:nEditMove := DT_MOVE_UP
         ElseIf nKey == VK_LEFT                  // Ctrl+Shift+Left Arrow
            ::aColumns[ nCol ]:nEditMove := DT_MOVE_LEFT
         EndIf

      Case GetKeyState( VK_CONTROL )

         If nKey == VK_HOME                      // Ctrl+Home
			   ::GoTop()
				::PanHome()
         ElseIf nKey == VK_END                   // Ctrl+End
            If ::lHitBottom
               ::PanEnd()
            Else
               ::GoBottom()
            EndIf
         ElseIf nKey == VK_PRIOR                 // Ctrl+PgUp
		      ::GoTop()
         ElseIf nKey == VK_NEXT                  // Ctrl+PgDn
		      ::GoBottom()
         ElseIf nKey == VK_LEFT                  // Ctrl+Left
				::PanLeft()
         ElseIf nKey == VK_RIGHT                 // Ctrl+Right
				::PanRight()
			Else
				Super:KeyDown( nKey, nFlags )
         EndIf

      Case GetKeyState( VK_SHIFT ) .and. nKey < 48 .and. nKey != VK_SPACE

         If nKey == VK_HOME                      // Shift+Home
				::PanHome()
         ElseIf nKey == VK_END                   // Shift+End
				::PanEnd()

         ElseIf nKey == VK_DOWN .or. nKey == VK_UP .and. ::lCanSelect

            uVal := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

            If ( uTemp := AScan( ::aSelected, uVal ) ) > 0
               ADel( ::aSelected, uTemp )
               ASize( ::aSelected, ( Len( ::aSelected ) - 1 ) )
               ::DrawSelect()
               If ::bSelected != Nil
                  Eval( ::bSelected, Self, uVal, .F. )
               EndIf
            Else
               AAdd( ::aSelected, uVal )
               ::DrawSelect()
               If ::bSelected != Nil
                  Eval( ::bSelected, Self, uVal, .T. )
               EndIf
            EndIf

         Else
				Super:KeyDown( nKey, nFlags )
         EndIf

      Case nKey == VK_HOME
			::GoTop()
      Case nKey == VK_END
			::GoBottom()
      Case lEditable .and. ( nKey == VK_RETURN .or. nKey == nFireKey )

         If nKey == nFireKey
            nKey := VK_RETURN
         EndIf

         If ::nRowPos == 0

            If ::nLen == 0 .and. ! ::lCanAppend
               Return 0
            EndIf

         EndIf

         ::oWnd:nLastKey := nKey

         If ::aColumns[ nCol ]:bPrevEdit != Nil

            uVal := Eval( ::aColumns[ nCol ]:bPrevEdit  )

            If ValType( uVal ) == "L" .and. ! uVal
               Return 0
            EndIf

         EndIf

         If ::lAppendMode .and. ::lIsArr

            If ! Empty( ::aDefault )

               If Len( ::aDefault ) < Len( ::aColumns )
                  ASize( ::aDefault, Len( ::aColumns ) )
               EndIf

               uTemp := If( ::aDefault[ nCol ] == Nil, ;
                            If( ::aDefValue[ 1 ] == Nil, ;
                                ::aDefValue[ nCol + 1 ], ;
                                ::aDefValue[ nCol ] ), ;
                        If( ValType( ::aDefault[ nCol ] ) == "B", ;
                           Eval( ::aDefault[ nCol ], Self ), ::aDefault[ nCol ] ) )
            Else
               uTemp := If( nCol <= Len( ::aDefValue ), ;
                            ::aDefValue[ nCol ], Space( 10 ) )
            EndIf

         ElseIf ::lAppendMode .and. ::aDefault != Nil

            If Len( ::aDefault ) < Len( ::aColumns )
               ASize( ::aDefault, Len( ::aColumns ) )
            EndIf

            uTemp := If( ::aDefault[ nCol ] != Nil, If( ValType( ::aDefault[ nCol ] ) == "B", ;
                         Eval( ::aDefault[ nCol ], Self ), ::aDefault[ nCol ] ), Eval( ::aColumns[ nCol ]:bData ) )
         Else
            uTemp := Eval( ::aColumns[ nCol ]:bData )
         EndIf

         ::Edit( uTemp, nCol, nKey, nFlags )

      Case nKey == VK_UP

           ::GoUp()

      Case nKey == VK_DOWN

           ::GoDown()

      Case nKey == VK_LEFT

           ::GoLeft()

      Case nKey == VK_RIGHT

           ::GoRight()

      Case nKey == VK_PRIOR
           nKeyPressed := .T.
           ::PageUp()

      Case nKey == VK_NEXT
           nKeyPressed := .T.
           ::PageDown()

      Case nKey == VK_DELETE .and. ::lCanDelete

           ::DeleteRow()

      Case nKey == VK_CONTEXT .and. nFlags == 22872065

           If ::bContext != Nil
              Eval( ::bContext, ::nRowPos, ::nColPos, Self )
           EndIf

      Otherwise

           Super:KeyDown( nKey, nFlags )

   EndCase

Return 0

* ============================================================================
* METHOD TSBrowse:KeyUp() Version 8.0 Feb/01/2008
* ============================================================================

METHOD KeyUp( nKey, nFlags ) CLASS TSBrowse

   If lNoAppend != Nil
      ::lCanAppend := .T.
      lNoAppend := Nil
   EndIf

   If nKeyPressed != Nil

      ::Refresh( .F. )
      nKeyPressed := Nil

      If ::bChange != Nil
         Eval( ::bChange, Self, nKey )
      EndIf

   EndIf

Return Super:KeyUp( nKey, nFlags )

* ============================================================================
* METHOD TSBrowse:LButtonDown() Version 8.0 Feb/01/2008
* ============================================================================

METHOD LButtonDown( nRowPix, nColPix, nKeyFlags ) CLASS TSBrowse

   Local nClickRow, nSkipped, nI, lHeader, lFooter, nIcon, nAtCol, bLClicked, lMChange, ;
         nColPixPos := 0, ;
         uPar1    := nRowPix, ;
         uPar2    := nColPix, ;
         nBParam  := 0, ;
         nColInit := ::nColPos - 1, ;
         lDrawRow := .F., ;
         lDrawCol := .F., ;
         nLines   := ::nRowCount()

   ::lNoPaint := .F.

   If ::lDrag
      Return Super:LButtonDown( nRowPix, nColPix, nKeyFlags )
   EndIf

   If ::nFreeze > 0

      For nI := 1 To ::nFreeze
         nColPixPos += ::GetColSizes()[ nI ]
      Next

   EndIf

   nClickRow := ::GetTxtRow( nRowPix )
   nAtCol    := ::nAtCol( nColPix )
   lHeader   := nClickRow == 0 .and. ::lDrawHeaders
   lFooter   := nClickRow < 0 .and. ::lDrawFooters
   nBParam   := ::aColumns[ nAtCol ]:nBParam
   ::oWnd:nLastKey := 0
   uPar1 := If( nBParam == 2, TSPoint():New( uPar1, uPar2 ), If( nBParam == 1, nClickRow, uPar1 ) )
   uPar2 := If( nBParam == 2, TSPoint():New( nClickRow, nAtCol ), If( nBParam == 1, nAtCol, uPar2 ) )

   If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus != ::hWnd
      SendMessage( ::oWnd:hCtlFocus, WM_KILLFOCUS, ::hWnd )
   EndIf

   If ::lIconView

      If ( nIcon := ::nAtIcon( nRowPix, nColPix ) ) != 0
         ::DrawIcon( nIcon )
      EndIf

      Return Nil

   EndIf

   ::SetFocus()

   If ::nLen < 1 .or. ::lIsTxt

      If ! ::lCanAppend .or. ::lIsTxt
         Return 0
      ElseIf nClickRow > 0
         ::PostMsg( WM_KEYDOWN, VK_DOWN, nMakeLong( 0, 0 ) )
         Return 0
      EndIf

   EndIf

   If lHeader  .and. Valtype( nKeyFlags ) == "N"

      lMChange   := ::lMChange
      ::lMChange := .F.

      If ::nHeightSuper == 0 .or. ( ::nHeightSuper > 0 .and. nRowPix >= ::nHeightSuper )
         ::DrawPressed( nAtCol )
      EndIf

      If ::aActions != Nil .and. nAtCol <= Len( ::aActions )

         If ::aActions[ nAtCol ] != Nil
            ::DrawHeaders()
            Eval( ::aActions[ nAtCol ], Self, uPar1, uPar2 )

            If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus != ::hWnd
               ReleaseCapture()
               CursorArrow()
               Return 0
            EndIf

            ::DrawHeaders()

         EndIf

      EndIf

      If ::aColumns[ nAtCol ]:bHLClicked != Nil
         ::DrawHeaders()
         Eval( ::aColumns[ nAtCol ]:bHLClicked, uPar1, uPar2, ::nAt )

         If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus != ::hWnd
            ReleaseCapture()
            CursorArrow()
            Return 0
         EndIf

         ::DrawHeaders()

      EndIf

      ::lMChange := lMChange

   ElseIf lFooter

      lMChange   := ::lMChange
      ::lMChange := .F.

      If ::aColumns[ nAtCol ]:bFLClicked != Nil

         Eval( ::aColumns[ nAtCol ]:bFLClicked, uPar1, uPar2, ::nAt )

         If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus != ::hWnd
            ReleaseCapture()
            CursorArrow()
            Return 0
         EndIf

      EndIf

      ::lMChange := lMChange
      ::DrawFooters()

   EndIf

   If ::lMChange .and. nClickRow == 0

      If AScan( ::GetColSizes(), { | nColumn | nColPixPos += nColumn, nColInit ++, ;
                  nColPix >= nColPixPos - 2 .and. nColPix <= nColPixPos + 2 }, ::nColPos ) != 0

         ::lLineDrag := .T.
         ::VertLine( nColPixPos, nColInit, nColPixPos - nColPix )

      Else
         ::lColDrag := .T.
         ::nDragCol := ::nAtCol( nColPix )
      EndIf

      If ! ::lCaptured
         ::lCaptured := .T.
         ::Capture()
      EndIf

   EndIf

   If nClickRow > 0 .and. nClickRow != ::nRowPos .and. nClickRow < ( nLines + 1 )

      ::ResetSeek()
      ::DrawLine()

      nSkipped  := ::Skip( nClickRow - ::nRowPos )
      ::nRowPos += nSkipped

      If ::oVScroll != Nil
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
      EndIf

      lDrawRow      := .T.
      ::lHitTop     := .F.
      ::lHitBottom  := .F.
      ::lAppendMode := .F.

      If ::bChange != Nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      EndIf

   EndIf

   If nClickRow > 0 .or. ( ! ::lDrawHeaders .and. nClickRow >= 0 )

      bLClicked := If( ::aColumns[ nAtCol ]:bLClicked != Nil, ;
                       ::aColumns[ nAtCol ]:bLClicked, ::bLClicked )

      If ! ( ::lLockFreeze .and. ::nAtCol( nColPix, .T. ) <= ::nFreeze )
         lDrawCol := ::HiliteCell( ::nCell, nColPix )
      EndIf

      If bLClicked != Nil
         Eval( bLClicked, uPar1, uPar2, nKeyFlags, Self )
      EndIf

      If ! ::lNoHScroll .and. ::oHScroll != Nil .and. lDrawCol
         ::oHScroll:SetPos( ::nCell )
      EndIf

   EndIf

   If lDrawRow .or. lDrawCol
      ::DrawSelect()
   EndIf

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell

   EndIf

   ::lGrasp := ! lHeader .and. ! Empty( ::bDragBegin )

   If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus == ::hWnd
      ::lMouseDown := .T.
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:LButtonUp() Version 8.0 Feb/01/2008
* ============================================================================

METHOD LButtonUp( nRowPix, nColPix, nFlags ) CLASS TSBrowse

   Local nClickRow, nDestCol

   If ::lDrag

      If ::lColDrag
         ::lDrag := .F.
      Else
         Return Super:LButtonUp( nRowPix, nColPix, nFlags )
      EndIf

   EndIf

   If nKeyPressed != Nil
      ::DrawPressed( nKeyPressed, .F. )
   EndIf

   If ::lCaptured

      ::lCaptured := .F.
      ReleaseCapture()

      If ::lLineDrag
         ::lLineDrag := .F.

         If oToolTip != Nil
            ::DestroyToolTip()
         EndIf

         ::VertLine()
      Else
         ::lColDrag := .F.
         nClickRow := ::GetTxtRow( nRowPix )

         nDestCol := ::nAtCol( nColPix )

         // we gotta be on header row within listbox and not same colm
         If nClickRow == 0 .and. nColPix > ::nLeft .and. ;
            ::nDragCol != nDestCol

            If ::lMoveCols
               ::MoveColumn( ::nDragCol, nDestCol )
            Else
               ::Exchange( ::nDragCol, nDestCol )
            EndIf

         EndIf

      EndIf

   EndIf

   ::lGrasp := .F.
   Super:LButtonUp( nRowPix, nColPix, nFlags )

Return 0

* ============================================================================
* METHOD TSBrowse:LDblClick() Version 8.0 Feb/01/2008
* ============================================================================

METHOD LDblClick( nRowPix, nColPix, nKeyFlags ) CLASS TSBrowse

   Local uTemp, uVal, nBParam, ;
         nLines    := ::nRowCount(), ;
         nClickRow := ::GetTxtRow( nRowPix ), ;
         nCol      := ::nAtCol( nColPix ), ;
         uPar1     := nRowPix, ;
         uPar2     := nColPix, ;
         aMoveCell := { {|| ::GoRight() }, {|| ::GoDown() }, ;
                        {|| ::goLeft() }, {|| ::GoUp() }, ;
                        {|| ::GoNext() } }, ;
         bRecLock  := If( ! Empty( ::bRecLock ), ::bRecLock, ;
                         {|| ( ::cAlias )->( RLock() ) } ), ;
         bAddRec   := If( ! Empty( ::bAddRec ), ::bAddRec, ;
                        {|| ( ::cAlias )->( dbAppend() ), ! NetErr() } )

   If ::lDrag
      Return Super:LDblClick( nRowPix, nColPix, nKeyFlags )
   EndIf

   nBParam := ::aColumns[ nCol ]:nBParam
   ::oWnd:nLastKey := 0
   uPar1 := If( nBParam == 2, TSPoint():New( uPar1, uPar2 ), ;
            If( nBParam == 1, nClickRow, uPar1 ) )
   uPar2 := If( nBParam == 2, TSPoint():New( nClickRow, nCol ), ;
            If( nBParam == 1, nCol, uPar2 ) )


   If ( nClickRow == ::nRowPos .and. nClickRow > 0 ) .or. ;
      ( nClickRow == ::nRowPos .and. ! ::lDrawHeaders )

      If ::lCellBrw .and. ::IsEditable( nCol )

            If ValType( Eval( ::aColumns[ nCol ]:bData ) ) == "L" .and. ;
               ::aColumns[ nCol ]:lCheckBox  // virtual checkbox
               ::PostMsg( WM_CHAR, VK_SPACE, 0 )
            Else
               ::PostMsg( WM_KEYDOWN, VK_RETURN, 0 )
            EndIf

            Return 0

      ElseIf ::lCanSelect

         uVal := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

         If ( uTemp := AScan( ::aSelected, uVal ) ) > 0

            ADel( ::aSelected, uTemp )
            ASize( ::aSelected, ( Len( ::aSelected ) - 1 ) )
            ::DrawSelect()

            If ::bSelected != Nil
               Eval( ::bSelected, Self, uVal, .F. )
            EndIf

         Else

            AAdd( ::aSelected, uVal )
            ::DrawSelect()

            If ::bSelected != Nil
               Eval( ::bSelected, Self, uVal, .T. )
            EndIf

         EndIf

         If ::bLDblClick != Nil
            Eval( ::bLDblClick, uPar1, uPar2, nKeyFlags )
         EndIf

      ElseIf ::bLDblClick != nil
         Eval( ::bLDblClick, uPar1, uPar2, nKeyFlags )
      EndIf

   ElseIf nClickRow == 0 .and. ::lDrawHeaders .and. ! ::lNoChangeOrd
      ::SetOrder( ::nAtCol( nColPix, .T. ) )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:LoadFields() Version 8.0 Feb/01/2008
* ============================================================================

METHOD LoadFields( lEditable, aNames ) CLASS TSBrowse

   Local n, nE, cHeading, nAlign, nSize, aColSizes, cData, cType, nDec, hFont, bData, cBlock, ;
         aAlign := { "LEFT", "CENTER", "RIGHT", "VERT" }, ;
         aStru  := ( ::cAlias )->( DbStruct() ), ;
         nCols  := If( aNames == Nil, ( ::cAlias )->( FCount() ), Len( aNames ) )

   Default lEditable := .T.

   aColSizes := If( Len( ::aColumns )  ==  Len( ::aColSizes ), Nil, ::aColSizes )

   For n := 1 To nCols

      nE := If( aNames == Nil, n, FieldPos( aNames[ n ] ) )

      cHeading := If( ! ::aHeaders == Nil .and. Len( ::aHeaders ) >= nE, ::aHeaders[ nE ], ;
                      ::Proper( ( ::cAlias )->( Field( nE ) ) ) )

      nAlign := If( ::aJustify != Nil .and. Len( ::aJustify ) >= nE, ::aJustify[ nE ], ;
                    If( ( ::cAlias )->( ValType( FieldGet( nE ) ) ) == "N", 2, ;
                    If( ( ::cAlias )->( ValType( FieldGet( nE ) ) ) == "L", 1, 0 ) ) )

      nAlign := If( ValType( nAlign ) == "L", If( nAlign, 2, 0 ), ;
                If( ValType( nAlign ) == "C", AScan( aAlign, nAlign ) - 1, nAlign ) )

      nSize := If( ! aColSizes == Nil .and. Len( aColsizes ) >= nE, aColSizes[ nE ], Nil )

      If nSize == Nil
         cData := ( ::cAlias )->( FieldGet( nE ) )
         cType := aStru[ nE, 2 ]
         nSize := aStru[ nE, 3 ]
         nDec  := aStru[ nE, 4 ]
         hFont := If( ::oFont != Nil, ::oFont:hFont, 0 )

         If cType == "C"
            cData := PadR( Trim( cData ), nSize, "B" )
            nSize := GetTextWidth( 0, cData, hFont )
         ElseIf cType == "N"
            cData := StrZero( cData, nSize, nDec )
            nSize := GetTextWidth( 0, cData, hFont )
         ElseIf cType == "D"
            cData := cValToChar( If( ! Empty( cData ), cData, Date() ) )
            nSize := Int( GetTextWidth( 0, cData, hFont ) * 1.15 )
         ElseIf cType == "M"
            cData := cValToChar( cData )
            nSize := If( ::nMemoWV == Nil, 200, ::nMemoWV )
         Else
            cData := cValToChar( cData )
            nSize := GetTextWidth( 0, cData, hFont )
         EndIf

         nSize := Max( GetTextWidth( 0, Replicate( "B", Len( cHeading ) ), hFont ), nSize )

      EndIf

      cBlock := 'FieldWBlock("' + aStru[ nE, 1 ] + '",Select("' + ::cAlias + '"))'
      ::AddColumn( TSColumn():New( cHeading, FieldWBlock( aStru[ nE, 1 ], Select( ::cAlias ) ),, ;
                                   { ::nClrText, ::nClrPane }, { nAlign, DT_CENTER }, nSize,, lEditable,,,,,,, ;
                                   5,,,, Self, cBlock ) )

      ATail( ::aColumns ):cData := ::cAlias + "->" + FieldName( nE )

   Next

   If ::nLen == 0
      ::nLen := Eval( ::bLogicLen )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:nAtCol() Version 8.0 Feb/01/2008
* ============================================================================

METHOD nAtCol( nColPixel, lActual ) CLASS TSBrowse

   Local nColumn := ::nColPos - 1, ;
         aSizes  := ::GetColSizes(), ;
         nI      := 0, ;
         nPos    := 0

   Default lActual := .F.

   If ::nFreeze > 0

      If lActual
         nColumn := 0
      Else
         For nI := 1 To ::nFreeze
            nPos += aSizes[ nI ]
         Next
      EndIf

   EndIf

   While nPos < nColPixel .and. nColumn < Len( aSizes )
      nPos += aSizes[ nColumn + 1 ]
      nColumn++
   Enddo

Return nColumn

* ============================================================================
* METHOD TSBrowse:nAtIcon() Version 8.0 Feb/01/2008
* ============================================================================

METHOD nAtIcon( nRow, nCol ) CLASS TSBrowse

   Local nIconsByRow := Int( ::nWidth() / 50 )

   nRow -= 9
   nCol -= 1

   If ( nCol % 50 ) >= 9 .and. ( nCol % 50 ) <= 41
      return Int( ( nIconsByRow * Int( nRow / 50 ) ) + Int( nCol / 50 ) ) + 1
   Else
      return 0
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:nLogicPos() Version 8.0 Feb/01/2008
* ============================================================================

METHOD nLogicPos() CLASS TSBrowse

   Local cAlias, cOrderName, nLogicPos

   If ! ::lIsDbf

      If ::lIsTxt
         ::nAt := ::oTxtFile:RecNo()
      EndIf

      Return ::nAt

   EndIf

   If ::lDbfObj
      cAlias := ::oDbf:cAlias
   Else
      cAlias := ::cAlias
   EndIf

   cOrderName := If( ::bTagOrder != Nil, ( cAlias )->( Eval( ::bTagOrder ) ), Nil )
   nLogicPos  := ( cAlias )->( Eval( ::bKeyNo, cOrderName ) )

   If ::lFilterMode
      nLogicPos := nLogicPos - ::nFirstKey
   EndIf

   nLogicPos := If( nLogicPos <= 0, ::nLen + 1, nLogicPos )

Return nLogicPos

* ============================================================================
* METHOD TSBrowse:HandleEvent() Version 8.0 Feb/01/2008
* ============================================================================

METHOD HandleEvent( nMsg, nWParam, nLParam ) CLASS TSBrowse

   Local nDelta, nRow, nCol, aCoors

   Default ::lNoPaint := .F.

/*   fDebug( "nMsg="+AllTrim(cValTochar(nMsg)), "nWParam,nLoWord,nHiWord",;
           {nWParam,nLoWord(nLParam),nHiWord(nLParam)}, 3 ) */

   If nMsg == WM_SETFOCUS .and. ! ::lPainted
      Return 0
   #ifdef __HARBOUR__
   ElseIf nMsg == WM_KEYUP
      Return ::KeyUp( nWParam, nLParam )
   ElseIf nMsg == WM_VSCROLL
      Return ::VScroll( nLoword( nWParam ), nHiWord( nWParam ) )
   #EndIf
   ElseIf nMsg == WM_CHAR .and. ::lEditing
      Return 0
   ElseIf nMsg == WM_ERASEBKGND .and. ! ::lEditing
      ::lNoPaint := .F.
   ElseIf nMsg == WM_ERASEBKGND
      Return 0
   ElseIf nMsg == WM_DESTROY .and. ! Empty( ::aColumns ) .and. ::aColumns[ ::nCell ]:oEdit != Nil
      ::aColumns[ ::nCell ]:oEdit:PostMsg( WM_KEYDOWN, VK_ESCAPE, 0 )
   EndIf

Return Super:HandleEvent( nMsg, nWParam, nLParam )

* ============================================================================
* METHOD TSBrowse:HiliteCell() Version 8.0 Feb/01/2008
* ============================================================================

METHOD HiliteCell( nCol, nColPix ) CLASS TSBrowse

   Local nI, nAbsCell, nRelCell, nNowPos, nOldPos, nLeftPix, ;
         lDraw := .F.,;
         lMove := .T.

	Default nCol := 1

   If ! ::lCellBrw .and. nColPix == Nil          // if not browsing cell-style AND no nColPix, ignore call.
      Return lDraw                               // nColPix NOT nil means called from ::LButtonDown()
   EndIf

	If nCol < 1
		nCol := 1
   ElseIf nCol > Len( ::aColumns )
		nCol := Len( ::aColumns )
   EndIf

	If Len( ::aColumns ) > 0

      If nColPix != Nil                           // used internally by ::LButtonDown() only
         nAbsCell := ::nAtCol( nColPix, .F. )
         nRelCell := ::nAtCol( nColPix, .T. )

         If nAbsCell >= ::nFreeze .and. nRelCell <= ::nFreeze
		      nNowPos := nRelCell
		   Else
		      nNowPos := nAbsCell
         EndIf

		   nOldPos := ::nCell

         If ::nFreeze > 0 .and. nOldPos < nNowPos  // frozen col and going right
				nNowPos := nAbsCell
				lMove := ( nOldPos > ::nFreeze )
         EndIf

		   If nOldPos < nNowPos                    // going right
				nLeftPix := 0

            For nI := nOldPos To nNowPos - 1
               lDraw := .T.
			      ::nCell ++
               nLeftPix += ::aColSizes[ nI ]       // we need to know pixels left of final cell...
				Next

            ::nCell := If( ::nCell > Len(::aColumns), Len(::aColumns), ::nCell )

            If ::nWidth() < nLeftPix + ::aColSizes[ ::nCell ] .and. ;  // ...and set ::nColPos accordingly
                  ::nColPos < Len( ::aColumns ) .and. lMove            //::GetColSizes()
		         ::nColPos ++
               ::Refresh( .F. )
            EndIf

         ElseIf nNowPos < nOldPos                // going left

				For nI := nNowPos To nOldPos - 1
               lDraw := .T.
			      ::nCell --
				Next

				::nCell := If( ::nCell < 1, 1, ::nCell )

         EndIf

			nCol := ::nCell

		Else

			lDraw := ! ( ::nCell == nCol )

         ::nColPos := Max( ::nFreeze + 1, ::nColPos )

         If ::nFreeze > 0 .and. ::lLockFreeze
            ::nCell := Max( nCol, ::nFreeze + 1 )
         ElseIf ::nCell != nCol
            ::nCell := nCol
         EndIf

         If ! ::lNoHScroll .and. ::oHScroll != Nil .and. lDraw

            ::oHScroll:SetPos( nCol )

            If ::lPainted
               ::Refresh( .F. )
            EndIf

         EndIf

      EndIf

		If ::lCellBrw
			// unhilite all columns EXCEPT those with "double cursor" (permanent) efect
         AEval( ::aColumns, { |oColumn| oColumn:lNoLite := ! oColumn:lFixLite } )   // allways .T. if no double cursor
         ::aColumns[ nCol ]:lNoLite := .F.
      EndIf

   EndIf

Return lDraw

* ============================================================================
* METHOD TSBrowse:HScroll() Version 8.0 Feb/01/2008
* ============================================================================

METHOD HScroll( nWParam, nLParam ) CLASS TSBrowse

   Local nCol

   ::lNoPaint := .F.

   If GetFocus() != ::hWnd
      SetFocus( ::hWnd )
   EndIf

	Do Case
	Case nWParam == SB_LINEUP
		::GoLeft()

	Case nWParam == SB_LINEDOWN
		::GoRight()

	Case nWParam == SB_PAGEUP

      ::PanLeft()

	Case nWParam == SB_PAGEDOWN
        nCol := ::nColPos + 1

        While ::IsColVisible( nCol ) .and. nCol <= Len( ::aColumns )
           ++nCol
        EndDo

        If nCol < Len ( ::aColumns )
           ::nColPos := ::nCell := nCol
           ::Refresh( .F. )
           ::oHScroll:SetPos( nCol )
        Else

           nCol := Len( ::aColumns )
           While ! ::IsColVisible( nCol ) .and. ::nColPos < nCol
              ::nColPos++
           EndDo
           ::nCell := nCol
           ::oHScroll:GoBottom()
           ::Refresh( .F. )
        EndIf

        If ::lCellBrw
           ::HiLiteCell( ::nCell )
        EndIf

   Case nWParam == SB_TOP
		::PanHome()

	Case nWParam == SB_BOTTOM
      ::PanEnd()

	Case nWParam == SB_THUMBPOSITION
		::HThumbDrag( nLParam )

	Endcase

Return 0

* ============================================================================
* METHOD TSBrowse:HThumbDrag() Version 8.0 Feb/01/2008
* ============================================================================

METHOD HThumbDrag( nNewCol ) CLASS TSBrowse

   Local nI, nLeftPix, nColPos,;
         nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If ::oHScroll != Nil .and. ! Empty( nNewCol )

      If nNewCol >= Len( ::aColumns )
         If ::IsColVisible( Len( ::aColumns ) )
            ::nCell := Len( ::aColumns )
            ::HiliteCell( ::nCell )
            ::Refresh( .F. )
         Else
            ::PanEnd()
         EndIf
         ::oHScroll:GoBottom()
         Return Self
      EndIf

      If ::lIsTxt
			::oHScroll:SetPos( ::nAt := nNewCol )
		Else
         If ::lLockFreeze .and. nNewCol <= ::nFreeze  // watch out for frozen columns
				::oHScroll:SetPos( ::nCell := ::nFreeze + 1 )
			Else
            ::oHScroll:SetPos( ::nCell := Min( nNewCol, Len( ::aColumns ) ) )
         EndIf

         nLeftPix := 0                              // check for frozen columns,

         For nI := 1 To ::nFreeze                   // if any
            nLeftPix += ::aColSizes[ nI ]
			Next
			nColPos := ::nCell
			For nI := ::nCell To 1 Step - 1            // avoid extra scrolling
				If nLeftPix + ::aColSizes[nI] < nWidth  // to the right of the
					nLeftPix += ::aColSizes[nI]          // last cell (column)
					nColPos := nI
				Else
					Exit
            EndIf
			Next
			::nColPos := nColPos
			::HiliteCell( ::nCell )
      EndIf
      ::Refresh( .F. )

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:Inspect() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Inspect( cData ) CLASS TSBrowse

   Do case
      Case cData == "aColumns"
           Return { | aColumns | Tone(500,1), aColumns }
   Endcase

Return Nil

* ============================================================================
* METHOD TSBrowse:InsColumn() Version 8.0 Feb/01/2008
* ============================================================================

METHOD InsColumn( nPos, oColumn ) CLASS TSBrowse

   Local nI, ;
         nCell := ::nCell

	Default nPos := 1

	If oColumn == Nil                             // if no Column object supplied
		Return Nil                                 // return nil insted of reference to object
   EndIf

	If nPos < 1
		nPos := 1
   ElseIf nPos > Len( ::aColumns ) + 1
		nPos := Len( ::aColumns ) + 1
   EndIf

	ASize( ::aColumns, Len( ::aColumns ) + 1 )
	aIns( ::aColumns, nPos )
   ::aColumns[ nPos ] := oColumn

	ASize( ::aColSizes, Len( ::aColSizes ) + 1 )
	aIns( ::aColSizes, nPos )
   ::aColsizes[ nPos ] := oColumn:nWidth

   If( nCell != nPos, ::nCell := If( ::lPainted, nPos, nCell ), Nil )

   If ! Empty( oColumn:cOrder )                       // if column has a TAG, we
      ::SetOrder( nPos )                              // set it as controling order
   ElseIf ::nColOrder != 0 .and. nPos <= ::nColOrder  // if left of current order
      ::nColOrder ++                                  // adjust position
   EndIf

   If ::lPainted
      ::HiliteCell( ::nCell )

      If ::oHScroll != Nil
         ::oHScroll:SetRange( 1, Len( ::aColumns ) )
         ::oHScroll:SetPos( ::nCell )
      EndIf

      If ! Empty( ::aSuperHead )

         For nI := 1 To Len( ::aSuperHead )

            If nPos >= ::aSuperHead[ nI, 1 ] .and. ;
               nPos <= ::aSuperHead[ nI, 2 ]

               ::aSuperHead[ nI, 2 ] ++

            ElseIf nPos < ::aSuperHead[ nI, 1 ]
               ::aSuperHead[ nI, 1 ] ++
               ::aSuperHead[ nI, 2 ] ++
            EndIf

         Next

      EndIf

      ::Refresh( .F. )
      ::SetFocus()

   EndIf

Return oColumn                                   // returns reference to Column object

* ============================================================================
* METHOD TSBrowse:IsColVisible() Version 8.0 Feb/01/2008
* ============================================================================

METHOD IsColVisible( nCol ) CLASS TSBrowse

   Local nCols, nFirstCol, nLastCol, nWidth, nBrwWidth, xVar, ;
         aColSizes := ::GetColSizes()

   nCols     := Len( aColSizes )
   nFirstCol := ::nColPos
   nLastCol  := nFirstCol
   nWidth    := 0
   nBrwWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If nCol < ::nColPos .or. ::nColPos <= 0
      Return .F.
   EndIf

   xVar := 1

   While xVar <= ::nFreeze
      nWidth += aColSizes[ xVar++ ]
   EndDo

   While nWidth < nBrwWidth .and. nLastCol <= nCol .and. nLastCol <= nCols
      nWidth += aColSizes[ nLastCol ]
      nLastCol++
   Enddo

   If nCol <= --nLastCol
      Return ! nWidth > nBrwWidth
   EndIf

Return .F.

* ============================================================================
* METHOD TSBrowse:IsColVis2() Version 8.0 Feb/01/2008
* ============================================================================

METHOD IsColVis2( nCol ) CLASS TSBrowse

   Local nCols, nFirstCol, nLastCol, nBrwWidth, ;
         nWidth := 0, ;
         aColSizes := ::GetColSizes()

   nCols     := Len( aColSizes )
   nFirstCol := ::nColPos
   nLastCol  := nFirstCol

   // mt differs from iscolvisible here - allows for frozen column
   If ::nFreeze > 0
		AEval( aColSizes, {|nSize| nWidth += nSize }, 1, ::nFreeze )
   EndIf

   nBrwWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If nCol < ::nColPos
      Return .F.
   EndIf

   Do While nWidth < nBrwWidth .and. nLastCol <= nCols
      nWidth += aColSizes[ nLastCol ]
      nLastCol++
   Enddo

   If nCol <= --nLastCol
      // mt differs from new iscolvisible here
      Return .T.
   EndIf

Return .F.

* ============================================================================
* METHOD TSBrowse:Insert() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Insert( cItem, nAt ) CLASS TSBrowse

   Default nAt := ::nAt, ;
           cItem := AClone( ::aDefValue )

   If ! ::lIsArr
      Return Nil
   EndIf

   If ValType( cItem ) == "A" .and. cItem[ 1 ] == Nil
      ADel( cItem, 1 )
      ASize( cItem, Len( cItem ) - 1 )
   EndIf

   ASize( ::aArray, Len( ::aArray ) + 1 )
   AIns( ::aArray, nAt )
   ::aArray[ nAt ] := If( Valtype( cItem ) == "A", cItem, {cItem} )
   ::nLen := Eval( ::bLogicLen )
   ::Refresh( .T. )

Return Self

* ============================================================================
* METHOD TSBrowse:lEditCol() Version 8.0 Feb/01/2008
* ============================================================================

METHOD lEditCol( uVar, nCol, cPicture, bValid, nClrFore, nClrBack ) CLASS TSBrowse

// just for compatibility
Return ::Edit( uVar, nCol,,, cPicture, bValid, nClrFore, nClrBack )

* ============================================================================
* METHOD TSBrowse:lIgnoreKey() Version 8.0 Feb/01/2008
* Checks if any of the predefined navigation keys has been remapped so as to
* ignore its default behavior and forward it to TWindow class in case a new
* behavior has been defined in ::bKeyDown. Uses the new nested array IVar
* ::aKeyRemap which has the following structure (data type in parens):
*
* { { VK_ to ignore(n), alone(l), ctrl(l), shift(l), alt(l), ctrl+shift(l), bBlock }, ... }
*
* Example:  AAdd( ::aKeyRemap, { VK_END, .T., .F., .T., .F., .F., { || Tone(600) } } )
*           will ignore End key alone and with shift+end combinations
*
* It's the programmer's (ie you!) responsibility to make sure each subarray
* has 6 elements of the specified data type or kaboom!
* This method is called by ::KeyDown() which provides nKey and nFlags.
* If called directly, you must specify the parameter nKey (nFlags is always ignored)
* ============================================================================

METHOD lIgnoreKey( nKey, nFlags ) CLASS TSBrowse

   Local lIgnore := .F., ;
         nAsync := 2, ;                // key by itself
         nIgnore := AScan( ::aKeyRemap, {|aRemap| aRemap[ 1 ] == nKey } )

   If nIgnore > 0

      If GetKeyState( VK_CONTROL ) .and. GetKeyState( VK_SHIFT )
         nAsync := 6
      ElseIf GetKeyState( VK_CONTROL )
         nAsync := 3
      ElseIf GetKeyState( VK_SHIFT )
         nAsync := 4
      ElseIf GetKeyState( VK_MENU )                    // alt key
         nAsync := 5
      EndIf

      lIgnore := ::aKeyRemap[ nIgnore, nAsync ]

      If lIgnore .and. ValType( ::aKeyRemap[ nIgnore, 7 ] ) == "B"
         Eval( ::aKeyRemap[ nIgnore, 7 ] )
      EndIf

   EndIf

Return lIgnore

* ============================================================================
* METHOD TSBrowse:LoadRelated() Version 8.0 Feb/01/2008
* ============================================================================

METHOD LoadRelated( cAlias, lEditable, aNames, aHeaders ) CLASS TSBrowse

   Local n, nE, cHeading, nAlign, nSize, aColSizes, cData, cType, nDec, ;
         hFont, aStru, nArea, nFields, cBlock

   Default lEditable := .F.

   If Empty( cAlias )
      Return Self
   EndIf

   cAlias  := AllTrim( cAlias )
   nArea   := Select( cAlias )
   aStru   := ( cAlias )->( DbStruct() )
   nFields := If( aNames == Nil, ( cAlias )->( FCount() ), Len( aNames ) )

   For n := 1 To nFields

      nE := If( aNames == Nil, n, ( cAlias )->( FieldPos( aNames[ n ] ) ) )

      cHeading := If( aHeaders != Nil .and. Len( aHeaders ) >= n, ;
                      aHeaders[ n ], cAlias + "->" + ;
                      ::Proper( ( cAlias )->( Field( nE ) ) ) )

      cHeading := cAlias + "->" + ::Proper( ( cAlias )->( Field( nE ) ) )

      nAlign := If( ( cAlias )->( ValType( FieldGet( nE ) ) ) == "N", 2, ;
                If( ( cAlias )->( ValType( FieldGet( nE ) ) ) == "L", ;
                          1, 0 ) )

      cData := ( cAlias )->( FieldGet( nE ) )
      cType := ValType( cData )
      nSize := aStru[ nE, 3 ]
      nDec  := aStru[ nE, 4 ]
      hFont := If( ::oFont != Nil, ::oFont:hFont, 0 )

      If cType == "C"
         cData := PadR( Trim( cData ), nSize, "B" )
         nSize := GetTextWidth( 0, cData, hFont )
      ElseIf cType == "N"
         cData := StrZero( cData, nSize, nDec )
         nSize := GetTextWidth( 0, cData, hFont )
      ElseIf cType == "D"
         cData := cValToChar( If( ! Empty( cData ), cData, Date() ) )
         nSize := Int( GetTextWidth( 0, cData, hFont ) * 1.15 )
      Else
         cData := cValToChar( cData )
         nSize := GetTextWidth( 0, cData, hFont )
      EndIf

      nSize := Max( GetTextWidth( 0, Replicate( "B", Len( cHeading ) ), ;
                                  hFont ), nSize )
      cBlock := 'FieldWBlock( "' + ( cAlias )->( Field( nE ) ) + '", Select( "' + ;
                cAlias + '" ) )'
      ::AddColumn( TSColumn():New( cHeading, ;
                                   FieldWBlock( ( cAlias )->( Field( nE ) ), nArea ),, ;
                                   { ::nClrText, ::nClrPane }, { nAlign, DT_CENTER }, ;
                                   nSize,, lEditable,,,,,,, 5,,,, Self, cBlock ) )

      ATail( ::aColumns ):cAlias := cAlias
      ATail( ::aColumns ):cData  := cAlias + "->" + FieldName( nE )

   Next

Return Self

* ============================================================================
* METHOD TSBrowse:Look3D() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Look3D( lOnOff, nColumn, nLevel, lPhantom ) CLASS TSBrowse

   Default lOnOff   := .T., ;
           nColumn  :=  0 , ;
           lPhantom := .T., ;
           nLevel   :=  0

   ::l3DLook := lOnOff                              // used internally

   If nColumn > 0
      If nLevel = 1 .or. nLevel = 0
         ::aColumns[ nColumn ]:l3DLook := lOnOff
      EndIf

      If nLevel = 2 .or. nLevel = 0
         ::aColumns[ nColumn ]:l3DLookHead := lOnOff
      EndIf

      If nLevel = 3 .or. nLevel = 0
         ::aColumns[ nColumn ]:l3DLookFoot := lOnOff
      EndIf
   Else
      If nLevel > 0
         AEval( ::aColumns, { | oCol | If( nLevel = 1, oCol:l3DLook := lOnOff, ;
                                       If( nLevel = 2, oCol:l3DLookHead := lOnOff, ;
                                           oCol:l3DLookFoot := lOnOff ) ) } )
      Else
         AEval( ::aColumns, { | oCol | oCol:l3DLook := lOnOff, ;
                                       oCol:l3DLookHead := lOnOff, ;
                                       oCol:l3DLookFoot := lOnOff } )
      EndIf
   EndIf

   If lPhantom
      ::nPhantom := PHCOL_GRID
   Else
      ::nPhantom := PHCOL_NOGRID
   EndIf

   ::Refresh( .T. )

Return Self

* ============================================================================
* METHOD TSBrowse:LostFocus() Version 8.0 Feb/01/2008
* ============================================================================

METHOD LostFocus( hCtlFocus ) CLASS TSBrowse

   Local nRecNo, uTag

   Default ::aControls := {}

   If ::lEditing .and. Len( ::aControls ) > 0 .and. ;
      hCtlFocus == ::aControls[ 1 ]:hWnd

      Return 0

   EndIf

   If ::lEditing

      If ::aColumns[ ::nCell ]:oEdit != Nil
         ::aColumns[ ::nCell ]:oEdit:End()
      EndIf

      ::lEditing := ::lPostEdit := .F.

   EndIf

   ::lNoPaint := .F.

   If ::lDrag
      Return Super:LostFocus( hCtlFocus )
   EndIf

   ::lFocused = .F.

   If ! Empty( ::bLostFocus )
      Eval( ::bLostFocus, hCtlFocus )
   EndIf

   If ::nLen > 0 .and. ! EmptyAlias( ::cAlias ) .and. ! ::lIconView

      If ::lIsDbf .and. ( ::cAlias )->( RecNo() ) != ::nLastPos

         If ::bTagOrder != Nil .and. ::uLastTag != Nil
            uTag := ( ::cAlias )->( Eval( ::bTagOrder ) )
            ( ::cAlias )->( Eval( ::bTagOrder, ::uLastTag ) )
         EndIf

         nRecNo := ( ::cAlias )->( RecNo() )
         ( ::cAlias )->( DbGoTo( ::nLastPos ) )

      EndIf

      ::DrawSelect()

      If nRecNo != Nil

         If uTag != Nil
            ( ::cAlias )->( Eval( ::bTagOrder, uTag ) )
         EndIf

         ( ::cAlias )->( DbGoTo( nRecNo ) )

      EndIf

   EndIf

   If ::oCtx != Nil
      ::oCtx:Save()
   EndIf

   ::lHasFocus := .F.

Return 0

* ============================================================================
* METHOD TSBrowse:MButtonDown() Version 8.0 Feb/01/2008
* ============================================================================

METHOD MButtonDown( nRow, nCol, nKeyFlags ) CLASS TSBrowse

   If ::bMButtonDown != Nil
      Eval( ::bMButtonDown, nRow, nCol, nKeyFlags )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:MouseMove() Version 8.0 Feb/01/2008
* ============================================================================

METHOD MouseMove( nRowPix, nColPix, nKeyFlags ) CLASS TSBrowse

   Local nI, nIcon, lHeader, lMChange, ;
         cMsg       := ::cMsg, ;
         nColPixPos := 0, ;
         lFrozen    := .F., ;
         nColumn    := Max( 1, ::nAtCol( nColPix ) )

   If ::lDrag
      Return Super:MouseMove( nRowPix, nColPix, nKeyFlags )
   EndIf

   Default ::lMouseDown := .F., ;
           nToolTip := 0
           lToolTip := .F.

   If ::lIconView
      If ( nIcon := ::nAtIcon( nRowPix, nColPix ) ) != 0
         If ::nIconPos != 0 .and. ::nIconPos != nIcon
            ::DrawIcon( ::nIconPos )
         EndIf
         ::nIconPos := nIcon
         ::DrawIcon( nIcon, .T. )
         CursorHand()
         Return 0
      EndIf
   EndIf

   If ::nFreeze > 0
      For nI := 1 To ::nFreeze
         nColPixPos += ::GetColSizes()[ nI ]
      Next

      If nColPix < nColPixPos
         lFrozen := .T.
      EndIf
   EndIf

   If ( lHeader := ::GetTxtRow( nRowPix ) == 0 ) .and. ! Empty( ::aColumns[ nColumn ]:cToolTip )

      If nToolTip != nColumn
         ::DestroyToolTip()
         SysRefresh()
      EndIf

      nToolTip := nColumn
      ::ShowToolTip( nRowPix, nColPix, ::aColumns[ nColumn ]:cToolTip, .F. )
   Else
      ::DestroyToolTip()
   EndIf

   If ! ::lGrasp .and. ( lFrozen .or. ! lHeader .or. ! ::lMChange )
       // don't allow MouseMove to drag/resize columns
       // unless in header row and not in frozen zone
      CursorArrow()

      If ::lCaptured
         If ::lLineDrag
            ::VertLine()
            ::lLineDrag := .F.
         EndIf

         ReleaseCapture()
         ::lColDrag := ::lCaptured := ::lMouseDown := .F.
      EndIf

      lMChange := ::lMChange  // save it for restore
      ::lMChange := .F.

      If ! Empty( ::aColumns[ Max( 1, ::nAtCol( nColPix ) ) ]:cMsg )
         ::cMsg := ::aColumns[ Max( 1, ::nAtCol( nColPix ) ) ]:cMsg
      Else
         ::cMsg := cMsg
      EndIf

      ::cMsg := If( ValType( ::cMsg ) == "B", Eval( ::cMsg, Self, Max( 1, ::nAtCol( nColPix ) ) ), ::cMsg )
      Super:MouseMove( nRowPix, nColPix, nKeyFlags )
      ::lMChange := lMChange
      ::cMsg := cMsg
      Return 0

   EndIf

   If ::lMChange

      If lHeader
         If ::lGrasp             // avoid dragging between header & rows
            ::lGrasp := .F.
            CursorArrow()        // restore default cursor
         EndIf

         If ::lColDrag
            CursorSize()
         Else
            If ::lLineDrag
               ::VertLine( nColPix )
               CursorWE()
            Else
               If AScan( ::GetColSizes(), { | nColumn | nColPixPos += nColumn, ;
                           nColPix >= nColPixPos - 2 .and. nColPix <= nColPixPos + 2 }, ::nColPos ) != 0
                  CursorWE()
               Else
                  CursorHand()
               EndIf
            EndIf
         EndIf
      ElseIf ::lGrasp
         ::lCaptured := ::lColDrag := .F.     // to avoid collision with header/column dragging
         ::lMouseDown := .T.                  // has to be down until dragging finishes
         Super:MouseMove( nRowPix, nColPix, nKeyFlags )
      Else
         CursorArrow()
      EndIf
   Else
      CursorArrow()
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:MouseWheel() Version 8.0 Feb/01/2008
* ============================================================================

METHOD MouseWheel( nKeys, nDelta, nXPos, nYPos ) CLASS TSBrowse

   Local nWParam

   #ifdef __CLIPPER__
      If GetKeyState( VK_SHIFT ) .or. GetKeyState( VK_CONTROL )
         nDelta := 120
      EndIf
   #EndIf

   nDelta /= 120

   If ( nDelta ) > 0

      If ::nWheelLines != Nil
         nWParam := SB_LINEUP
         nDelta  := ::nWheelLines * nDelta
      Else
         nWParam := SB_PAGEUP
      EndIf

   Else

      If ::nWheelLines != Nil
         nWParam := SB_LINEDOWN
         nDelta  := ::nWheelLines * Abs( nDelta )
      Else
         nWParam := SB_PAGEDOWN
         nDelta := Abs( nDelta )
      EndIf

   EndIf

   While nDelta > 1
      ::VScroll( nWParam, 0 )
      nDelta--
   EndDo

Return ::VScroll( nWParam, 0 )

* ============================================================================
* METHOD TSBrowse:MoveColumn() Version 8.0 Feb/01/2008
* ============================================================================

METHOD MoveColumn( nColPos, nNewPos ) CLASS TSBrowse

   Local oCol, cOrder, ;
         nMaxCol   := Len( ::aColumns ), ;
         nOrder    := ::nColOrder, ;
         lCurOrder := ( ::nColOrder == nColPos )

   Local lSetOrder := ;
      ( nOrder != nColPos .and. nOrder != nNewPos .and. ::nColOrder == nNewPos )

   If ! Empty( nColPos ) .and. ! Empty( nNewPos ) .and. ;
         nColPos > ::nFreeze .and. nNewPos > ::nFreeze .and. ;
         nColPos <= nMaxCol .and. nNewPos <= nMaxCol

      oCol   := ::aColumns[ nColPos ]
		cOrder := oCol:cOrder
		oCol:cOrder := Nil                         // avoid ::InsColumn() from seting order...

      ::DelColumn( nColPos )
      ::InsColumn( nNewPos, oCol )
      ::aColumns[ nNewPos ]:cOrder := cOrder     // ...restore ::cOrder (if any)

		If lSetOrder
         ::SetOrder( nNewPos - 1 )
      ElseIf lCurOrder
         ::SetOrder( nNewPos )
      ElseIf nOrder != 0

			// check if current order is in between moving columns
         If nOrder >= nColPos .and. nOrder <= nNewPos      // left to right movement
				nOrder --
         ElseIf nOrder <= nColPos .and. nOrder >= nNewPos  // right to left movement
				nOrder ++
         EndIf

         ::SetOrder( nOrder )

      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:PageDown() Version 8.0 Feb/01/2008
* ============================================================================

METHOD PageDown( nLines ) CLASS TSBrowse

   Local nSkipped, nI, ;
         lPageMode := ::lPageMode, ;
         nTotLines := ::nRowCount()

   Default nLines := nTotLines

   ::lAppendMode := .F.
   ::ResetSeek()

   If ::nLen == 0
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                    Eval( ::bLogicLen ) )
   EndIf

   If ::nLen < 1
      Return Nil
   EndIf

   If ! ::lHitBottom

      ::nPrevRec := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

      If lPageMode .and. ::nRowPos < nLines
         nSkipped := ::Skip( nLines - ::nRowPos )
         lPageMode := .F.
      Else
         nSkipped = ::Skip( ( nLines * 2 ) - ::nRowPos )
      EndIf

      If nSkipped != 0
         ::lHitTop = .F.
      EndIf

      Do Case

         Case nSkipped == 0
            ::lHitBottom := .T.
         Case nSkipped < nLines .and. ! lPageMode

            nI := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

            If ::lIsDbf
               ( ::cAlias )->( DbGoTo( ::nPrevRec ) )
            Else
               ::nAt := ::nPrevRec
            EndIf

            ::DrawLine()

            If ::lIsDbf
               ( ::cAlias )->( DbGoTo( nI ) )
            Else
               ::nAt := nI
            EndIf

            If nLines - ::nRowPos < nSkipped

               nKeyPressed := Nil
               ::Skip( -( nLines ) )

               For nI = 1 To ( nLines - 1 )
                  ::Skip( 1 )
                  ::DrawLine( nI )
               Next

               ::Skip( 1 )

            EndIf

            ::nRowPos = Min( ::nRowPos + nSkipped, nTotLines )

         Case nSkipped < nLines .and. lPageMode
            ::Refresh( .T. )
         Otherwise

            For nI = nLines To 1 Step -1
               ::Skip( -1 )
            Next

            ::Skip( ::nRowPos )

      Endcase

      If nKeyPressed == Nil
         ::Refresh( ::nLen < nTotLines )
         If ::bChange != Nil
            Eval( ::bChange, Self, VK_NEXT )
         EndIf
      ElseIf nSkipped >= nLines
         ::DrawSelect()
      Else
         nKeyPressed := Nil
         ::DrawSelect()
      EndIf

      If ::oVScroll != Nil
         If ! ::lHitBottom
            ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
         Else
            ::oVScroll:GoBottom()
         EndIf
      EndIf

   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:PageUp() Version 8.0 Feb/01/2008
* ============================================================================

METHOD PageUp( nLines ) CLASS TSBrowse

   Local nSkipped, nRecNo

   Default nLines := ::nRowCount()

   ::lHitBottom := .F.
   ::lAppendMode := .F.
	::ResetSeek()

   If ::lPageMode .and. ::nRowPos > 1

      ::DrawLine()
      nSkipped := ::Skip( -( ::nRowPos - 1 ) )
      ::nRowPos := 1
      ::Refresh( .F. )

      If ::oVScroll != Nil
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
      EndIf

      If ::bChange != Nil
         Eval( ::bChange, Self, VK_PRIOR )
      EndIf

      Return Self

   EndIf

   ::nPrevRec := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )
   nSkipped := ::Skip( -nLines )

   If ::nLen == 0
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                    Eval( ::bLogicLen ) )
   EndIf

   If ::nLen < 1
      Return Nil
   EndIf

   If ! ::lHitTop

      If nSkipped == 0
         ::lHitTop := .T.
      Else

         If -nSkipped < nLines

            nRecNo := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

            If ::lIsDbf
               ( ::cAlias )->( DbGoto( ::nPrevRec ) )
            Else
               ::nAt := ::nPrevRec
            EndIf

            ::DrawLine()
            ::nRowPos := 1

            If ::lIsDbf
               ( ::cAlias )->( DbGoto( nRecNo ) )
            Else
               ::nAt := nRecNo
            EndIf

            If ::oVScroll != Nil
               ::oVScroll:SetPos( 1 )
            EndIf


         Else

            If ::oVScroll != nil
               ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
            EndIf

         EndIf

         If nKeyPressed == Nil

            ::Refresh( .F. )

            If ::bChange != Nil
               Eval( ::bChange, Self, VK_PRIOR )
            EndIf

         Else
            ::DrawSelect()

            If -nSkipped < nLines
               nKeyPressed := Nil
            EndIf

         EndIf

      EndIf

   Else

      If ::oVScroll != Nil
         ::oVScroll:GoTop()
      EndIf

   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:Paint() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Paint() CLASS TSBrowse

   Local nRecs, lAppendMode, nRecNo, uTag, oCol, ;
         nColPos := ::nColPos, ;
         nI      := 1, ;
         nLines  := Min( ( ::nLen + If( ::lAppendMode .and. ! ::lIsArr, 1, 0 ) ), ::nRowCount() ), ;
         nSkipped := 1

   Default ::lPostEdit   := .F., ;
           ::lFirstPaint := .T., ;
           ::lNoPaint    := .F., ;
           ::lInitGoTop  := .T., ;
           ::nFreeze     := 0


   If ! ::lRepaint
      Return 0
   EndIf

   If ::lEditing .and. ! ::lPostEdit .and. ::nLen > 0
      Return 0
   ElseIf ::lEditing .or. ::lNoPaint

      If ::lDrawHeaders
         ::DrawHeaders()
      EndIf

      ::DrawSelect()
      Return 0

   EndIf

   If ::lFirstPaint
      ::Default()
   EndIf

   ::nRowPos := If( ::lDrawHeaders, Max( 1, ::nRowPos ), ::nRowPos )

   If ::lDrag .and. ! ::lActive .and. Upper( ::oWnd:ClassName() ) == "VFWMODULE"
      BtnDisable( ::hWnd )
      Return 0
   EndIf

   If ::lIconView
      ::DrawIcons()
      Return 0
   EndIf

   If ! ::lPainted

      If ::lSelector
         oCol := OClone( ::aColumns[ 1 ] )
         oCol:bData := {||""}
         oCol:cHeading := ""
         oCol:nWidth := 25
         oCol:lNoHilite := .T.
         oCol:nClrBack := oCol:nClrHeadBack
         ::InsColumn( 1, oCol )
         ::nFreeze ++
         ::lLockFreeze := .T.
         ::HiliteCell( Max( ::nCell, ::nFreeze + 1 ) )
      EndIf

      SetHeights( Self )
      nLines  := Min( ( ::nLen + If( ::lAppendMode .and. ! ::lIsArr, 1, 0 ) ), ::nRowCount() )

      If ::nLen <= nLines .and. ::nAt > ::nRowPos
         ::nRowPos := ::nAt
      EndIf

      If ::lInitGoTop
         ::GoTop()
      EndIf

      If ::bInit != Nil
         Eval( ::bInit, Self )
      EndIf

   EndIf

   If ::lDrawHeaders .and. ::nHeightSuper > 0
      ::nColPos := ::nFreeze + 1
      ::DrawSuper()
      ::nColPos := nColPos
   EndIf

   If ::lDrawHeaders
      ::nRowPos := Max( 1, ::nRowPos )
      ::DrawHeaders()
   EndIf

   If ! ::lFocused .and. ::oCtx != Nil
      ::oCtx:Restore()  // window not in focus but needs repainting
   EndIf

   If ::lIsDbf .and. ::lPainted .and. ! ::lFocused .and. ( ::cAlias )->( RecNo() ) != ::nLastPos

      If ::bTagOrder != Nil .and. ::uLastTag != Nil
         uTag := ( ::cAlias )->( Eval( ::bTagOrder ) )
         ( ::cAlias )->( Eval( ::bTagOrder, ::uLastTag ) )
      EndIf

      nRecNo := ( ::cAlias )->( RecNo() )
      ( ::cAlias )->( DbGoTo( ::nLastPos ) )

   EndIf

   If ::lAppendMode .and. ::lFilterMode
      Eval( ::bGoBottom )
   EndIf

   ::Skip( 1 - ::nRowPos )

   If ::lIsArr
      lAppendMode   := ::lAppendMode
      ::lAppendMode := .F.
   EndIf

   ::nLastPainted := 0

   While nI <= nLines .and. nSkipped == 1

      If ::nRowPos == nI
         ::DrawSelect()
      Else
         ::DrawLine( nI )
      EndIf

      ::nLastPainted := nI
      nSkipped := ::Skip( 1 )

      If nSkipped == 1
         nI++
      EndIf

   Enddo

   If ::lIsArr
      ::lAppendMode := lAppendMode
   EndIf

   If ::lAppendMode
      nI := Max( 1, --nI )
   EndIf

   ::Skip( ::nRowPos - nI )

   If ::nLen < ::nRowPos
      ::nRowPos := ::nLen
   EndIf

   If ::lAppendMode .and. ::nLen == ::nRowPos .and. ::nRowPos < nLines
      ::DrawLine( ++ ::nRowPos )
   EndIf

   If ! ::lFocused .and. ::oCtx != Nil
      ::oCtx:Save()
   EndIf

   If ! ::lPainted

      If Upper( ::oWnd:ClassName() ) == "TDIALOG" .and. ! ::lNoVScroll
         ::oVScroll := TScrollBar():WinNew( 1, Min( ::nLen, MAX_POS ), Min( nLines, ::nLen ), .T., Self )
      EndIf

      If ::bChange != Nil
         Eval( ::bChange, Self, 0 )
      EndIf

      If ::lIsDbf .and. ! ::lNoResetPos

         If ::bTagOrder != Nil
            ::uLastTag := ( ::cAlias )->( Eval( ::btagOrder ) )
         EndIf

         ::nLastPos := ( ::cAlias )->( RecNo() )

      EndIf

      If ::lCanAppend .and. ::lHasFocus .and. ! ::lAppendMode .and. ::nLen == 0
         ::lHitBottom := .T.
         ::PostMsg( WM_KEYDOWN, VK_DOWN, 0 )
      Else
         ::lNoPaint := .T.
      EndIf

   EndIf

   ::lPainted := .T.

   If nRecNo != Nil

      If uTag != Nil
         ( ::cAlias )->( Eval( ::bTagOrder, uTag ) )
      EndIf

      ( ::cAlias )->( DbGoTo( nRecNo ) )

   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:PanEnd() Version 8.0 Feb/01/2008
* ============================================================================

METHOD PanEnd() CLASS TSBrowse

   Local nI, nTxtWid, ;
         nWidth   := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ), ;
         nWide    := 0, ;
         nCols    := Len( ::aColumns )

   ::nOldCell := ::nCell

   If ::lIsTxt
		nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::oFont != nil, ::oFont:hFont, 0 ) ) )
		::nAt := ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
      ::Refresh( .F. )

      If ::oHScroll != Nil
			::oHScroll:setPos( ::nAt )
      EndIf

      Return Self
   EndIf

   ::nColPos := nCols
	::nCell := nCols
	nWide := ::aColSizes[nCols]

   For nI := nCols - 1 To 1 Step - 1
		If nWide + ::aColSizes[nI] <= nWidth
			nWide += ::aColSizes[nI]
			::nColPos--
		Else
			Exit
      EndIf
	Next

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell

   EndIf

   ::Refresh( .F. )

   If ::oHScroll != Nil
      If ::oHScroll:nMax != nCols
         ::oHScroll:SetRange( 1, nCols )
      EndIf
      ::oHScroll:GoBottom()
   EndIf

	::HiliteCell( nCols )

Return Self

* ============================================================================
* METHOD TSBrowse:PanHome() Version 8.0 Feb/01/2008
* ============================================================================

METHOD PanHome() CLASS TSBrowse

   Local nColChk, nEle

   ::nOldCell := ::nCell

   If ::lIsTxt

		::nAt := 1
      ::Refresh( .F. )

      If ::oHScroll != Nil
			::oHScroll:setPos( ::nAt )
      EndIf

      Return Self
   EndIf

   For nEle := 1 To Len( ::aColumns )
      If ! ::aColumns[ nEle ]:lNoHilite
         nColChk := nEle
         Exit
      EndIf
   Next

   ::nColPos := 1
   ::nCell := nColChk

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell

   EndIf

   If ! ::lEditing
      ::Refresh( .F. )
   Else
      ::Paint()
   EndIf

   If ::oHScroll != Nil
      ::oHScroll:SetPos( ::nCell )
   EndIf

   ::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:PanLeft() Version 8.0 Feb/01/2008
* ============================================================================

METHOD PanLeft() CLASS TSBrowse

   Local nI,;
         nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ),;
         nWide := 0,;
         nCols := Len( ::aColumns ),;
         nPos := ::nColPos,;
         nFirst := If( ::lLockFreeze .and. ::nFreeze > 0, ::nFreeze + 1, 1 )

   ::nOldCell := ::nCell

   If ::lIsTxt

		If ::nAt > 11
			::nAt := ::nAt - 10
		Else
			::nAt := 1
      EndIf
      If ::oHScroll != Nil
			::oHScroll:SetPos( ::nAt )
      EndIf
      ::Refresh( .F. )
		Return Self
   EndIf

   If ::nFreeze >= nCols
      Return Self
   EndIf

   AEval( ::aColSizes, { | nSize | nWide += nSize } )

   If  nWide <= nWidth                           // browse fits all inside
		::nCell := nFirst                          // window or dialog
		::nColPos := 1
	Else
		nWide := ::aColSizes[nPos]
		For nI := nPos - 1 To nFirst Step - 1
			If nWide <= nWidth
            nWide += ::aColSizes[ nI ]
				::nCell := nI
			Else
				Exit
         EndIf
		Next
		::nColPos := ::nCell                       // current column becomes first in offset
   EndIf

   If ! ::lCellBrw .and. ! ::lLockFreeze .and. ;  // for frozen columns
         ::nFreeze > 0 .and. ::nCell - 1 == 1
		::nCell := ::nColPos := ::nFreeze
   EndIf

   If ::nCell != ::nOldCell
      ::Refresh( .F. )
   EndIf

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell

   EndIf

   If ::oHScroll != Nil
		::oHScroll:SetPos( ::nCell )
   EndIf

   If ::lCellBrw
      ::HiliteCell( ::nCell )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:PanRight() Version 8.0 Feb/01/2008
* ============================================================================

METHOD PanRight() CLASS TSBrowse

   Local nTxtWid, nI,;
         nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ),;
         nWide := 0,;
         nCols := Len( ::aColumns ),;
         nPos := ::nColPos

   ::nOldCell := ::nCell

   If ::lIsTxt

 		nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::oFont != nil, ::oFont:hFont, 0 ) ) )

 		If ::nAt < ::oTxtFile:nMaxLineLength - 21 - Int( nWidth / nTxtWid )
 			::nAt := ::nAt + 20
 		Else
 			::nAt := ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
      EndIf

      If ::oHScroll != Nil
 			::oHScroll:SetPos( ::nAt )
      EndIf

      ::Refresh( .F. )
		Return Self
   EndIf

   If ::nFreeze >= nCols
      Return Self
   EndIf

   AEval( ::aColSizes, {|nSize| nWide += nSize }, nPos )

   If ::nFreeze > 0
		AEval( ::aColSizes, {|nSize| nWide += nSize }, 1, ::nFreeze )
   EndIf

   If nWide <= nWidth     // we're in last columns (including the current one),
      ::nCell := nCols    // so just ::nCell changes, not ::nColPos
	Else
		nWide := 0
		AEval( ::aColSizes, {|nSize| nWide += nSize }, nPos + 1 )

      If ::nFreeze > 0
			AEval( ::aColSizes, {|nSize| nWide += nSize }, 1, ::nFreeze )
      EndIf

      If nWide <= nWidth .and. nPos < nCols      // the remaining columns are added
			::nCell := nPos + 1                     // the last in the browse
			nPos := nCols                           // so as to avoid For..Next
      EndIf

      nWide := ::aColSizes[nPos]

      For nI := nPos + 1 To nCols
         If ( nWide + ::aColSizes[nI] <= nWidth ) .or. ;
               ( nI - nPos < 2 .and. nWide + ::aColSizes[nI] > nWidth )  // two consecutive very wide columns
				nWide += ::aColSizes[nI]
				::nCell := nI
			Else
				Exit
         EndIf
		Next
		::nColPos := ::nCell                       // last column becomes first in offset
   EndIf

   If ! ::lCellBrw .and. ;                       // for frozen columns
	   If( ::nFreeze > 0, ::IsColVis2( nCols ), ::IsColVisible( nCols ) )

		::nCell := nCols

   EndIf

   If ::nCell != ::nOldCell
      ::Refresh( .F. )
   EndIf

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell

   EndIf

   If ::oHScroll != Nil
		::oHScroll:SetPos( ::nCell )
   EndIf

	::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:Proper() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Proper( cString ) CLASS TSBrowse

   Local nPos, cChr, cTxt, cAnt, ;
         nLen := Len( cString )

   cString := Lower( Trim( cString ) ) + " "

   nPos := 1
   cAnt := "."
   cTxt := ""

   While nPos <= Len( cString )
      cChr := SubStr( cString, nPos, 1 )
      cTxt += If( cAnt $ '".,-/ (', Upper( cChr ), If( Asc( cChr ) == 209, Chr( 241 ), cChr ) )
      cAnt := cChr
      nPos++
   EndDo

   cTxt := StrTran( cTxt, ::aMsg[ 51 ], Lower( ::aMsg[ 51 ] ) )
   cTxt := StrTran( cTxt, ::aMsg[ 52 ], Lower( ::aMsg[ 52 ] ) )
   cTxt := StrTran( cTxt, ::aMsg[ 53 ], Lower( ::aMsg[ 53 ] ) )
   cTxt := StrTran( cTxt, ::aMsg[ 54 ], Lower( ::aMsg[ 54 ] ) )
   cTxt := StrTran( cTxt, ::aMsg[ 55 ], Lower( ::aMsg[ 55 ] ) )

Return PadR( cTxt, nLen )

* ============================================================================
* METHOD TSBrowse:PostEdit() Version 8.0 Feb/01/2008
* ============================================================================

METHOD PostEdit( uTemp, nCol, bValid ) CLASS TSBrowse

   Local aMoveCell, bRecLock, bAddRec, cAlias, uRet, ;
         nLastKey := ::oWnd:nLastKey, ;
         lAppend  := ::lAppendMode

   cAlias := If( ::lIsDbf .and. ::aColumns[ nCol ]:cAlias != Nil, ::aColumns[ nCol ]:cAlias, ::cAlias )

   aMoveCell := { {|| ::GoRight() }, {|| ::GoDown() }, {|| ::GoLeft() },  {|| ::GoUp() }, {|| ::GoNext() } }

   bRecLock := If( ! Empty( ::bRecLock ), ::bRecLock, {|| ( cAlias )->( RLock() ) } )

   bAddRec := If( ! Empty( ::bAddRec ), ::bAddRec, {|| ( cAlias )->( dbAppend() ), ! NetErr() } )

   If bValid != Nil

      uRet := Eval( bValid, uTemp, Self )

      If ValType( uRet ) == "B"
         uRet := Eval( uRet, uTemp, Self )
      EndIf

      If ! uRet

         Tone( 500, 1 )
         ::lEditing  := ::lPostEdit := ::lNoPaint := .F.

         If ::lAppendMode
            ::lAppendMode := .F.
            ::lHitBottom  := .F.
            ::GoBottom()
            ::HiliteCell( nCol )
            lNoAppend := .T.
            ::lCanAppend := .F.
         Else
            ::DrawSelect()
         EndIf

         Return Nil

      EndIf

   EndIf

   If ::lIsDbf

      If Eval( If( ! ::lAppendMode, bRecLock, bAddRec ), uTemp )

         Eval( ::aColumns[ nCol ]:bData, uTemp, Self )

         If ::lAppendMode

            If ! Empty( ::aDefault )
               ASize( ::aDefault, Len( ::aColumns ) )
               AEval( ::aDefault, { | e, n | If( e != Nil .and. ;
               n != nCol, If( Valtype( e ) == "B", ;
               Eval( ::aColumns[ n ]:bData, Eval( e, Self ) ), ;
               Eval( ::aColumns[ n ]:bData, e ) ), Nil ) } )
               ::DrawLine()
            EndIf

            If ::lFilterMode .and. ::aColumns[ nCol ]:lIndexCol

               If &( ( cAlias )->( IndexKey() ) ) >= ::uValue1 .and. ;
                  &( ( cAlias )->( IndexKey() ) ) <= ::uValue2

                  ::nLen := ( cAlias )->( Eval( ::bLogicLen() ) )
                  ::nRowPos := ::nAt := Min( ::nRowCount, ::nLen )
               Else
                  ::lChanged := .F.
                  DbGoTo( ::nPrevRec )
                  ::Refresh( .F. )
               EndIf

            Else
               ::nLen++
            EndIf

            ::lAppendMode := .F.

            If ::nRowPos == 0 .and. ::lDrawHeaders
               ::nRowPos := ::nAt := 1
            EndIf

            If ::oVScroll != Nil
               ::oVScroll:SetRange( 1, Max( 1, ::nLen ) )
               ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
            EndIf

            ::DrawLine( ::nRowPos )

         EndIf

         If ::aColumns[ nCol ]:bPostEdit != Nil
            Eval( ::aColumns[ nCol ]:bPostEdit, uTemp, Self, lAppend )
         EndIf

         ::lEditing  := .F.
         ::lPostEdit := .F.
         ::lUpdated  := .T.
         ( cAlias )->( DbUnLock() )

         If lAppend

            If ::bChange != Nil
               Eval( ::bChange, Self, ::oWnd:nLastKey )
            EndIf

            lAppend := .F.
            AEval( ::aColumns, { |oC| lAppend := If( oC:lIndexCol, ;
                                      .T., lAppend ) } )
         EndIf

         If ( ::aColumns[ nCol ]:lIndexCol .and. ::lChanged ) .or. lAppend

            ::lNoPaint := .F.

            If ::lFilterMode

               If &( ( cAlias )->( IndexKey() ) ) >= ::uValue1 .and. ;
                  &( ( cAlias )->( IndexKey() ) ) <= ::uValue2

                  ::UpStable()

               Else
                  ::Reset()
               EndIf

            Else
               ::UpStable()
            EndIf

         EndIf

         ( cAlias )->( DbGoTo( ( cAlias )->( RecNo() ) ) )  // refresh relations just in case that
                                                            // a relation field changes
         ::SetFocus()

         If nLastKey == VK_UP
            ::GoUp()
         ElseIf nLastkey == VK_RIGHT
            ::GoRight()
         ElseIf nLastkey == VK_LEFT
            ::GoLeft()
         ElseIf nLastkey == VK_DOWN
            ::GoDown()
         ElseIf ::aColumns[ nCol ]:nEditMove >= 1 .and. ::aColumns[ nCol ]:nEditMove <= 5  // excel-like behavior post-edit movment
            Eval( aMoveCell[ ::aColumns[ nCol ]:nEditMove] )
            ::DrawSelect()
         ElseIf ::aColumns[ nCol ]:nEditMove == 0 .and. ! ::lAutoEdit
            ::DrawSelect()
         EndIf

         ::oWnd:nLastKey := Nil

         If ::lAutoEdit .and. ! lAppend
            SysRefresh()

            If ! ::aColumns[ ::nCell ]:lCheckBox
               ::PostMsg( WM_KEYDOWN, VK_RETURN, nMakeLong( 0, 0 ) )
            EndIf

            Return Nil
         EndIf

      Else
         If ! ::lAppendMode .and. Empty( ::bRecLock )
            MsgStop( ::aMsg[ 3 ], ::aMsg[ 4 ] )
         ElseIf ::lAppendMode .and. Empty( ::bAddRec )
            MsgStop( ::aMsg[ 5 ], ::aMsg[ 4 ] )
         EndIf
      EndIf

   Else

      If ::lAppendMode .and. ::lIsArr
         // when ::aDefValue[1] == Nil, it flags this element
         // as the equivalent of the "record no" for the array
         // this is why ::aDefValue will have one more element
         // than Len( ::aArray )
         ::lAppendMode := .F.
         AAdd( ::aArray, ;
               Array( Len( ::aDefValue ) - ;
                      If( ::aDefValue[ 1 ] == Nil, 1, 0 ) ) )
         ::nAt := ::nLen := Len( ::aArray )

         If ::oVScroll != Nil
            ::oVScroll:SetRange( 1, Max( 1, ::nLen ) )
            ::oVScroll:GoBottom()
         EndIf

         AEval( ATail( ::aArray ), { | uVal, n | ::aArray[ ::nAt, n ] := ;
                ::aDefValue[ n + If( ::aDefValue[ 1 ] == Nil, 1, 0 ) ] } )

      EndIf

      Eval( ::aColumns[ nCol ]:bData, uTemp )

      If ::aColumns[ nCol ]:bPostEdit != Nil
         Eval( ::aColumns[ nCol ]:bPostEdit, uTemp, Self, lAppend )
      EndIf

      ::lEditing  := .F.
      ::lPostEdit := .F.

      If lAppend .and. ! Empty( ::aDefault )
         ASize( ::aDefault, Len( ::aColumns ) )
         AEval( ::aDefault, { | e, n | If( e != Nil .and. ;
                n != nCol, If( Valtype( e ) == "B", ;
                Eval( ::aColumns[ n ]:bData, Eval( e, Self ) ), ;
                Eval( ::aColumns[ n ]:bData, e ) ), Nil ) } )
         ::DrawLine()
      EndIf

      If lAppend .and. ::nLen <= ::nRowCount()
         ::Refresh( .T. )
         ::nRowPos := Min( ::nRowCount, ::nLen )
      EndIf

      If lAppend .and. ::bChange != Nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      EndIf

      ::SetFocus()

      If nLastKey == VK_UP
         ::GoUp()
      ElseIf nLastkey == VK_RIGHT
         ::GoRight()
      ElseIf nLastkey == VK_LEFT
         ::GoLeft()
      ElseIf nLastkey == VK_DOWN
         ::GoDown()
      ElseIf ::aColumns[ nCol ]:nEditMove >= 1 .and. ;
         ::aColumns[ nCol ]:nEditMove <= 5  // excel-alike behaviour post-edit movment
         Eval( aMoveCell[ ::aColumns[ nCol ]:nEditMove ] )
      ElseIf ::aColumns[ nCol ]:nEditMove == 0
         ::DrawSelect()
      EndIf

      ::oWnd:nLastKey := Nil

      If ::lAutoEdit .and. ! lAppend
         SysRefresh()
         If ! ::aColumns[ ::nCell ]:lCheckBox
            ::PostMsg( WM_KEYDOWN, VK_RETURN, nMakeLong( 0, 0 ) )
         EndIf
      EndIf

   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:RButtonDown() Version 8.0 Feb/01/2008
* ============================================================================

METHOD RButtonDown( nRowPix, nColPix, nFlags ) CLASS TSBrowse

   Local nRow, nCol, nSkipped, oMenu, lNoEdit, bRClicked, nBParam, lHeader, lFooter, ;
         uPar1 := nRowPix, ;
         uPar2 := nColPix

   ::lNoPaint := .F.

   If ::lDrag
      Return Super:RButtondown( nRowPix, nColPix, nFlags )
   EndIf

   ::SetFocus()
   ::oWnd:nLastKey := 0

   If ::nLen < 1
      Return 0
   EndIf

   nRow    := ::GetTxtRow( nRowPix )
   nCol    := ::nAtCol( nColPix )
   lHeader := nRow == 0
   lFooter := nRow < 0
   nBParam := ::aColumns[ nCol ]:nBParam
   uPar1   := If( nBParam == 2, TSPoint():New( uPar1, uPar2 ), If( nBParam == 1, nRow, uPar1 ) )
   uPar2   := If( nBParam == 2, TSPoint():New( nRow, nCol ), If( nBParam == 1, nCol, uPar2 ) )
   lNoEdit := ! ::aColumns[ nCol ]:lEdit

   If nRow > 0

      If nCol <= ::nFreeze .and. ::lLockFreeze
         Return 0
      EndIf

      ::ResetSeek()
      ::DrawLine()

      nSkipped  := ::Skip( nRow - ::nRowPos )
      ::nRowPos += nSkipped
      ::nCell := nCol

      If ! ::lNoVScroll
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
      EndIf

      If ! ::lNoHScroll
         ::oHScroll:SetPos( ::nCell )
      EndIf

      If nSkipped != 0 .and. ::bChange != Nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      EndIf

      If ::lCellBrw

         If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
            Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
         EndIf

         If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
            Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
         EndIf

         ::nOldCell := ::nCell
         ::HiliteCell( ::nCell )

      EndIf

      ::DrawSelect()
      bRClicked := If( ::aColumns[ nCol ]:bRClicked != Nil, ;
                       ::aColumns[ nCol ]:bRClicked, ::bRClicked )

      If bRClicked != Nil
         Eval( bRClicked, uPar1, uPar2, ::nAt )
         Return 0
      Else
         Return 0
      EndIf

   ElseIf lHeader
      If ::aColumns[ nCol ]:bHRClicked != Nil
         Eval( ::aColumns[ nCol ]:bHRClicked, uPar1, uPar2, ::nAt )
      EndIf
   ElseIf lFooter
      If ::aColumns[ nCol ]:bFRClicked != Nil
         Eval( ::aColumns[ nCol ]:bFRClicked, uPar1, uPar2, ::nAt )
      EndIf
   EndIf

   If nCol <= ::nFreeze .or. ::lNoMoveCols
      Return 0
   EndIf

   MENU oMenu POPUP
      If ::lUnDo
         MENUITEM ::aMsg[ 6 ] + Space( 1 ) + ::aClipBoard[ 3 ] ;
         ACTION ( ::InsColumn( ::aClipBoard[ 2 ], ;
                               ::aClipBoard[ 1 ] ), ;
                               ::nCell := ::aClipBoard[ 2 ], ::Refresh( .T. ), ;
                               ::aClipBoard := Nil, ::lUnDo := .F. )
      Else
         MENUITEM ::aMsg[ 6 ] ACTION Nil DISABLED
      EndIf

      SEPARATOR
      MENUITEM ::aMsg[ 7 ]  ;
         ACTION ::aClipBoard := { OClone( ::aColumns[ nCol ] ), ;
                                  nCol, ::aMsg[ 12 ] }

      MENUITEM ::aMsg[ 8 ]  ;
         ACTION ( ::aClipBoard := { OClone( ::aColumns[ nCol ] ), ;
                                            nCol, ::aMsg[ 13 ] }, ;
                  ::DelColumn( nCol ), ::Refresh( .T. ), ::lUnDo := .T. )

      If ::aClipBoard != Nil .and. ::aClipBoard[ 3 ] != ::aMsg[ 12 ]
         MENUITEM ::aMsg[ 9 ] ;
            ACTION ( ::InsColumn( nCol, ::aClipBoard[ 1 ] ), ;
                     ::nCell := nCol, ::Refresh( .T. ), ;
                     ::aClipBoard := Nil, ::lUnDo := .F. )
      Else
         MENUITEM ::aMsg[ 9 ] ACTION Nil DISABLED
      EndIf

      SEPARATOR

      MENUITEM ::aMsg[ 10 ]  ;
      ACTION ( ::aClipBoard := { OClone( ::aColumns[ nCol ] ), ;
                                         nCol, ::aMsg[ 11 ] }, ;
               ::DelColumn( nCol ), ::Refresh( .T. ), ::lUnDo := .T. )

      If ! lNoEdit
         SEPARATOR
         MENUITEM ::aMsg[ 19 ]
            MENU
               MENUITEM ::aMsg[ 14 ] ACTION ::aColumns[ nCol ]:nEditMove := DT_MOVE_DOWN
               MENUITEM ::aMsg[ 15 ] ACTION ::aColumns[ nCol ]:nEditMove := DT_MOVE_RIGHT
               MENUITEM ::aMsg[ 16 ] ACTION ::aColumns[ nCol ]:nEditMove := DT_MOVE_UP
               MENUITEM ::aMsg[ 17 ] ACTION ::aColumns[ nCol ]:nEditMove := DT_MOVE_LEFT
               MENUITEM ::aMsg[ 18 ] ACTION ::aColumns[ nCol ]:nEditMove := DT_MOVE_NEXT
           ENDMENU
      EndIf
   ENDMENU

   ACTIVATE POPUP oMenu AT nRowPix + ::nHeightHead + 2, nColPix OF ::oWnd

Return 0

* ============================================================================
* METHOD TSBrowse:_RecCount() Version 8.0 Feb/01/2008
* ============================================================================

METHOD _RecCount() CLASS TSBrowse

   Local nLen := 0, ;
         nRecNo := ( ::cAlias )->( RecNo() )

   ::nFirstKey := 0

   Eval( ::bGoTop )

   If ! EoF() .and.  ( If( ! ::lDescend, ;
                       ( &( ( ::cAlias )->( IndexKey() ) ) <= ::uValue2 ), ;
                       ( &( ( ::cAlias )->( IndexKey() ) ) >= ::uValue2 ) ) )

      While ::bFilter != Nil .and. ! Eval( ::bFilter ) .and. ! EoF()
         DbSkip( 1 )
      EndDo

      ::nFirstKey := ( ::cAlias )->( Eval( ::bKeyNo ) ) - 1
      ( ::cAlias )->( DbGoBottom() )
      Eval( ::bGoBottom() )
      nLen := ( ::cAlias )->( Eval( ::bKeyNo ) ) - ::nFirstKey

   EndIf

   ( ::cAlias )->( DbGoTo( nRecNo ) )

Return nLen

* ============================================================================
* METHOD TSBrowse:RelPos() Version 8.0 Feb/01/2008
* Calculates the relative position of vertical scroll box in huge databases
* ============================================================================

METHOD RelPos( nLogicPos ) CLASS TSBrowse

   Local nRet

   If ::nLen > MAX_POS
      nRet := Int( nLogicPos * ( MAX_POS / ::nLen ) )
   Else
      nRet := nLogicPos
   EndIf

Return nRet

* ============================================================================
* METHOD TSBrowse:Report() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Report( cTitle, lPreview, oFont, cCaption, lModal, aCols, cHeader, cFooter, lGrid, oDevice ) CLASS TSBrowse

   Local oRpt, oColumn, nRecNo, nI, nAt, cType, nSize, ;
         nVPos := If( ::oVScroll != Nil, ::oVScroll:GetPos(), Nil ), ;
         nRPos := ::nRowPos, ;
         aAlig := { "LEFT", "CENTER", "RIGHT" }

   Default cTitle   := ::oWnd:GetText(), ;
           lPreview := .T., ;
           cCaption := ::oWnd:GetText(), ;
           oFont    := ::oFont, ;
           lGrid    := .F.

   Default lModal   := lPreview

   ::lNoPaint := .F.
   cHeader := If( cHeader != Nil, cHeader + Space( 1 ), "" )
   cFooter := If( cFooter != Nil, cFooter + Space( 1 ), "" )
   cCaption += If( lPreview, Space( 1 ) + ::aMsg[ 23 ], "" )

   If aCols == Nil

      aCols := {}

      For nI := 1 To Len( ::aColumns )
         AAdd( aCols, nI )
      Next

   EndIf

   If ::lIsDbf

      If ::lDbfObj
         nRecNo := ::oDbf:RecNo()
      Else
         nRecNo := ( ::cAlias )->( RecNo() )
      EndIf

   EndIf

   nAt := ::nAt
   Eval( ::bGoTop )

   oRpt := RptBegin( {{||cTitle}}, { {||cHeader + ::aMsg[ 20 ] + Space( 1 ) + DToC( Date() ) + " - " + ;
                     ::aMsg[ 22 ] + Space( 1 ) + Time() } }, ;
                     { {|| cFooter + ::aMsg[ 21 ] + Str( oRpt:nPage, 3 ) } }, ;
                     If( oFont == Nil, Nil, {oFont} ),,,,,, lPreview,, oDevice, cCaption,,, "CENTER" )

   oRpt:oDevice:lPrvModal := lModal
   oRpt:bPostEnd  := {|| If( ::lIsDbf, ( ::cAlias )->( DbGoTo( nRecNo ) ), Nil ), ::nAt := nAt, ::SetFocus() }
   oRpt:cCharPattern := "b"

   For nI := 1 To Len( aCols )

      If ! ::aColumns[ aCols[ nI ] ]:lBitMap
         cType := ValType( Eval( ::aColumns[ aCols[ nI ] ]:bData ) )
         nSize := Max( 1, Round( ::aColSizes[ aCols[ nI ] ] / ;
                                 GetTextWidth( 0, "b", If( oFont != Nil, oFont:hFont, 0 ) ), 0 ) )
         oRpt:AddColumn( TrColumn():New( GenHead( ::aColumns, aCols[ nI ] ),, ;
                         GenData( ::aColumns, aCols[ nI ] ), nSize, ;
                         { If( ! Empty( ::aColumns[ aCols[ nI ] ]:cPicture), ;
                           ::aColumns[ aCols[ nI ] ]:cPicture, "" ) },, ;
                         ( ::aColumns[ aCols[ nI ] ]:cFooting != Nil .and. ;
                         cType == "N"),, ;  // prints footings if the column has one (numeric only)
                         aAlig[ nLoWord( ::aColumns[ aCols[ nI ] ]:nAlign ) + 1 ],,,, oRpt ) )
      EndIf

	Next

	If lGrid
	   oRpt:CellView()
	EndIf

	RptEnd()
	oRpt:bSkip := { || oRpt:Cargo := ::Skip( 1 ) }
   oRpt:Cargo := 1

   oRpt:Activate( , { || If( ::lIsArr,;
                      oRpt:nCounter <= Max( ( Eval( ::bLogicLen ) ) - 1, 1 ),;
                      oRpt:Cargo == 1 ) } )

   ::lHitTop := .F.
   ::SetFocus()

Return Self

* ============================================================================
* METHOD TSBrowse:Reset() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Reset( cField, uVal1, uVal2 ) CLASS TSBrowse

   Local nMin, nMax, nPage

   Default cField := ::cField, ;
           uVal1  := ::uValue1

   Default uVal2  := uVal1

   If ::lIsDbf
      If cField != Nil
         ::SetFilter( cField, uVal1, uVal2 )
      Else
         ::nLen := ( ::cAlias )->( Eval( ::bLogicLen ) )
      EndIf
   Else
      ::nLen := Eval( ::bLogicLen )
   EndIf

   If ! ::lNoVScroll

      If ::nLen <= ::nRowCount .and. ::oVScroll != Nil
         ::oVScroll:nMax := -1
      Else
         nMin  := Min( 1, ::nLen )
         nMax  := Min( ::nLen, MAX_POS )
         nPage := Min( ::nRowCount(), ::nLen )
         ::oVScroll := TScrollBar():WinNew( nMin, nMax, nPage, .T., Self )
      EndIf

   EndIf

   ::lNoPaint := .F.
   ::lHitTop  := ::lHitBottom := .F.
   ::nColPos  := 1
   ::GoTop()
   ::Refresh()

Return Self

* ============================================================================
* METHOD TSBrowse:ResetBarPos() Version 8.0 Feb/01/2008
* ============================================================================

METHOD ResetBarPos( lInit ) CLASS TSBrowse

   Local cRDDName, cType, cOrderName, cAlias, nLogicPos, nMin, nMax, nPage

   Default lInit := .F., ;
           ::lIsArr := ::cAlias == "ARRAY", ;
           ::lIsTxt := "TEXT_" $ ::cAlias

	If lInit
		::cDriver   := "NONE"                      // anything different from a database
      ::lClipMore := .F.
   EndIf

   If ! Empty( ::cAlias ) .and. ! ::lIsArr .and. ! ::lIsTxt

      If ::lDbfObj
         cAlias := ( ::oDbf:cAlias )
		Else
         cAlias := ::cAlias
      EndIf

      If lInit .and. ! Empty( ( cAlias )->( IndexKey() ) )

         If ( cAlias )->( Used() )
				cRddName := ( cAlias )->( RddName() )
			Else
				cRddName := RddSetDefault()
         EndIf

         #ifdef __HARBOUR__
            cRddName := If( cRddName == "DBF", "DBFNTX", cRddName )
         #EndIf

         If cRDDName == "COMIX"
			   ::cDriver := "COMIX"
            ::bTagOrder := &( "{|uTag|OrdSetFocus(uTag)}" )
            cType := Type( "cmKeyNo()" )
            If ( ::lClipMore := ( cType == "C" .or. cType == "UI" ) )
               ::bKeyNo    := &( "{|cTag|cmKeyNo(cTag) }" )
               ::bLogicLen := If( ::lFilterMode, {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                                  &( "{|cTag| cmKeyCount( cTag ) }" ) )
               ::bGoToPos  := &( "{|n| cmKeyGoTo( n ) }" )
            Else
               ::bKeyNo    := &( "{|cTag|cmxKeyNo(cTag)}" )
               ::bLogicLen := If( ::lFilterMode,;
                                  {||(::cAlias)->(Self:RecCount(::uValue1))}, &( "{|cTag| cmxKeyCount( cTag ) }" ) )
               ::bGoToPos  := &( "{|n| cmxKeyGoTo( n ) }" )
            EndIf
         Elseif cRDDName $ "DBFCDX_DBFCDX"
			   ::cDriver   := "CDX"
            ::bKeyNo    := &( "{|uTag|OrdKeyNo(uTag)}" )
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, &( "{|cTag|OrdKeyCount(cTag)}" ) )
            ::bGoToPos  := &( "{|n|OrdKeyGoTo(n) }" )
            ::bTagOrder := &( "{|uTag|OrdSetFocus(uTag)}" )
         Elseif "XAX" $ cRDDName
            ::cDriver   := "ADS"
            ::bKeyNo    := &( "{||AX_KeyNo()}" )
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               &( "{|cTag| AX_KeyCount( cTag ) }" ) )
            ::bTagOrder := &( "{|uTag|OrdSetFocus(uTag)}" )
         Elseif "ADS" $ cRDDName
            ::cDriver   := "ADS"
            ::bKeyNo    := &( "{||ADSKeyNo()}" )
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, &( "{|cTag| ADSKeyCount( cTag,, 1 ) }" ) )
            ::bTagOrder := &( "{|uTag|OrdSetFocus(uTag)}" )
         Elseif cRDDName $ "DBFNSX_SIXCDX_SIXNSX_SIXMDX"
			   ::cDriver   := "NSX"
            ::bKeyNo    := &( "{||sx_KeyNo()}" )
            ::bLogicLen := If( ::lFilterMode, {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               &( "{|cTag| Sx_KeyCount(cTag)}" ) )
            ::bGoToPos  := &( "{|n| sx_KeyGoTo( n ) }" )
            cType := Type( "sx_SetTagO()" )

            If cType == "C" .or. cType == "UI"
               ::bTagOrder := &( "{|cTag| sx_SetTagOrder( cTag ) }" )
            Else
               ::bTagOrder := &( "{|cTag| OrdSetFocus(cTag) }" )
            EndIf

			Else                                    // DBFNTX considered default RDD
				::cDriver   := "NTX"
            ::bGoToPos  := Nil
            ::bLogicLen := If( ::lFilterMode, {||(::cAlias)->(Self:RecCount(::uValue1))}, {||(::cAlias)->(LastRec())} )

            If "5.3" $ Version()                 // In Clipper 5.3x OrdKeyNo() is supported by NTX
               ::bKeyNo := &( "{|uTag|OrdKeyNo(uTag)}" )
               ::bTagOrder := &( "{|uTag|OrdSetFocus(uTag)}" )
            Else
               ::bTagOrder := &( "{|nTag|If(nTag==Nil,IndexOrd(),DbSetOrder(nTag))}" )
               ::bKeyNo := {||(cAlias)->(NtxPos(IndexOrd(),RecNo()-If(Eof(),1,0)))}
            EndIf

            If ::lDbfObj
               ::bLogicLen := {|| ::oDbf:RecCount() }
            EndIf

         EndIf

      Elseif lInit .and. Empty( ( cAlias )->( IndexKey() ) )
        ::bKeyNo    := { || ( cAlias )->( Recno() ) }
        ::bLogicLen := { || ( cAlias )->( LastRec() ) }
        ::bGoToPos  := { |n| ( cAlias )->( DbGoTo( n ) ) }
      EndIf

		cOrderName := If( ::bTagOrder != Nil, ( cAlias )->( Eval( ::bTagOrder ) ), Nil )  // only used by Comix/ClipMore RDD
      nLogicPos  := ( cAlias )->( Eval( ::bKeyNo, cOrderName ) )

      If ::nLen == 0
         ::nLen := ( cAlias )->( Eval( ::bLogicLen ) )
      EndIf

      If lInit .and. ! ::lNoVScroll .and. ::lFilterMode
         nMin  := Min( 1, ::nLen )
         nMax  := Min( ::nLen, MAX_POS )
         nPage := Min( ::nRowCount(), ::nLen )
         ::oVScroll := TScrollBar():WinNew( nMin, nMax, nPage, .T., Self )
         ::oVScroll:SetPos( ::RelPos( nLogicPos ) )
      ElseIf ::oVScroll != Nil
         ::oVScroll:SetRange( 1, Max( 1, Min( ::nLen, MAX_POS ) ) )
			::oVScroll:SetPos( ::RelPos( nLogicPos ) )
         ::oVScroll:SetPage( Min( ::nRowCount(), ::nLen ), .T. )
      EndIf

      If nLogicPos > 0 .and. nLogicPos < ::nRowPos
         ::nRowPos := nLogicPos
      EndIf

   Else
      If lInit .and. ! ::lNoVScroll
         nMin  := Min( 1, ::nLen )
         nMax  := Min( ::nLen, MAX_POS )
         nPage := Min( ::nRowCount(), ::nLen )
         ::oVScroll := TScrollBar():WinNew( nMin, nMax, nPage, .T., Self )
         ::oVScroll:SetPos( ::RelPos( nLogicPos ) )
      ElseIf ::oVScroll != Nil
         ::oVScroll:SetRange( 1, Max( 1, Min( ::nLen, MAX_POS ) ) )
			::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
         ::oVScroll:SetPage( Min( ::nRowCount(), ::nLen ), .T. )
      EndIf
   EndIf

Return Self


* ============================================================================
* METHOD TSBrowse:ResetSeek() Version 8.0 Feb/01/2008
* ============================================================================

METHOD ResetSeek() CLASS TSBrowse

   If ::nColOrder > 0
      If ::cOrderType == "D"
         ::cSeek := "  /  /    "
      Else
         ::cSeek := ""
      EndIf
   EndIf

   If ::bSeekChange != Nil
      Eval( ::bSeekChange )
   EndIf

   nNewEle := 0

Return ::cSeek

* ============================================================================
* METHOD TSBrowse:ReSize() Version 8.0 Feb/01/2008
* ============================================================================

METHOD ReSize( nSizeType, nWidth, nHeight ) CLASS TSBrowse

   Local nMin, nMax, nPage, ;
         nTotPix := 0

   AEval( ::aColSizes, {|n| nTotPix += n } )

   If ::lEditing .and. ::aColumns[ ::nCell ]:oEdit != Nil
      SendMessage( ::aColumns[ ::nCell ]:oEdit:hWnd, WM_KEYDOWN, VK_ESCAPE, 0 )
   EndIf

   If ! Empty( ::nAdjColumn )
      ::nAdjColumn := Min( Len( ::aColumns ), ::nAdjColumn )
   EndIf

   If ! ::lDrag
      ::nRowPos := Min( ::nRowPos, Max( ::nRowCount(), 1 ) )
   EndIf

   If ! Empty( ::nAdjColumn ) .and. nTotPix != nWidth
      ::aColumns[ ::nAdjColumn ]:nWidth := ;
      ::aColSizes[ ::nAdjColumn ] += ( nWidth - nTotPix )
   EndIf

   If ! ::lNoVScroll

      nMin  := Min( 1, ::nLen )
      nMax  := Min( ::nLen, MAX_POS )
      nPage := Min( ::nRowCount(), ::nLen )

      If ::oVScroll == Nil
         ::oVScroll := TScrollBar():WinNew( nMin, nMax, nPage, .T., Self )
      EndIf

      ::oVScroll:SetRange( 1, nMax )
      ::oVScroll:SetPage( nPage, .T. )

   EndIf

   If ! ::lNoHScroll

      nMin  := Min( 1, Len( ::aColumns ) )
      nMax  := Len( ::aColumns )
      nPage := 1

      If ::oHScroll == Nil
         ::oHScroll := TScrollBar():WinNew( nMin, nMax, nPage, .F., Self )
      EndIf

      ::oHScroll:SetRange( 1, nMax )
      ::oHScroll:SetPage( nPage, .T. )

   EndIf

Return Super:ReSize( nSizeType, nWidth, nHeight )

* ============================================================================
* METHOD TSBrowse:Seek() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Seek( nKey ) CLASS TSBrowse

    Local nIdxLen, cPrefix, ;
          nLines    := ::nRowCount(), ;
          lFound    := .T., ;
          lEoF      := .F., ;
          lTrySeek  := .T., ;
          nRecNo    := 0, ;
          cSeek     := ::cSeek, ;
          xSeek     := cSeek

   If ( Seconds() - nLapsus ) > 3 .or. ( Seconds() - nLapsus ) < 0
      ::cSeek := cSeek := ""
   EndIf

   nLapsus := Seconds()

   cPrefix := If( ::cPrefix == Nil, "", If( ValType( ::cPrefix ) == "B", ;
                  Eval( ::cPrefix, Self ), ::cPrefix ) )

   If ::nColOrder > 0 .and. ::lIsDbf

      lTrySeek := .T.

      If ::cOrderType == "C"

         If ::lDbfObj
            nIdxLen := ( ::oDbf:cAlias )->( Len( Eval( &( "{||" + IndexKey() + "}" ) ) )  )
         Else
            nIdxLen := ( ::cAlias )->( Len( Eval( &( "{||" + IndexKey() + "}" ) ) ) )
         EndIf

      EndIf

      If nKey == VK_BACK
         If ::cOrderType == "D"
            cSeek := DateSeek( cSeek, nKey )
         Else
            cSeek := Left( cSeek, Len( cSeek ) - 1 )
         EndIf
      Else
         If ::cOrderType == "D"
            cSeek := DateSeek( cSeek, nKey )
         ElseIf ::cOrderType == "N"
            /* only  0..9, minus and dot*/
            If ( nKey >= 48 .and. nKey <= 57 ) .or. ( nKey >= 45 .or. ;
                 nKey <= 46 )
                cSeek += Chr( nKey )
            Else
               Tone( 500, 1 )
               lTrySeek := .F.
            EndIf
         ElseIf ::cOrderType == "C"
            If Len( cSeek ) < nIdxLen
               cSeek += If( ::lUpperSeek, Upper( Chr( nKey ) ), Chr( nKey ) )
            Else
               Tone( 500, 1 )
               lTrySeek := .F.
            EndIf
         EndIf
      EndIf

      If ::cOrderType == "C"
         xSeek := cPrefix + cSeek
      ElseIf ::cOrderType == "N"
         xSeek := Val( cSeek )
      ElseIf ::cOrderType == "D"
         xSeek := cPrefix + DToS( CToD( cSeek ) )
      Else
         xSeek := cPrefix + cSeek
      EndIf

      If ! ( ::cOrderType == "D" .and. ;
         Len( RTrim( cSeek ) ) < Len( DToC( Date() ) ) ) .and. lTrySeek

         If ::lDbfObj
            nRecNo := ::oDbf:RecNo()
            lFound := ::oDbf:Seek( xSeek, .T. )
            lEof   := ::oDbf:Eof()

            If lEof .or. ( ::cOrderType == "C" .and. ! lFound )
               ::oDBf:GoTo( nRecNo )
            EndIf
         Else
            nRecNo := ( ::cAlias )->( RecNo() )
            lFound := ( ::cAlias )->( DbSeek( xSeek, .T. ) )
            lEoF   := ( ::cAlias )->( Eof() )

            If lEoF .or. ( ::cOrderType == "C" .and. ! lFound )
               ( ::cAlias )->( DbGoTo( nRecNo ) )
            EndIf
         EndIf

         If ( ::cOrderType == "C" .and. ! lFound ) .or. lEof

            Tone( 500, 1 )

            If ::cOrderType == "D"
               ::cSeek := DateSeek( cSeek, VK_BACK )
            Else
               ::cSeek := Left( cSeek, Len( cSeek ) - 1 )
            EndIf

            Return Self

         ElseIf ! lFound

            If ::cOrderType == "N"
               ( ::cAlias )->( DbSeek( Val( cSeek ) * 10, .T. ) )
               xSeek := ( ::cAlias )->( Eval( &( "{||" + IndexKey() + "}" ) ) )
               xSeek := Val( Right( LTrim( Str( xSeek ) ), Len( cSeek ) + 1 ) )

               If xSeek > ( ( Val( cSeek ) * 10 ) + 9 )
                  Tone( 500, 1 )
                  ( ::cAlias )->( DbGoTo( nRecNo ) )
                  ::cSeek := Left( cSeek, Len( cSeek ) - 1 )
                  Return Self
               EndIf

            EndIf

            ::cSeek := cSeek
            ( ::cAlias )->( DbGoto( nRecNo ) )
            Return Self

         Else

            ::lHitBottom := ::lHitTop := .F.

            If ::lDbfObj

               If nRecNo != ::oDbf:RecNo()

                  ::Refresh( ::nLastPainted < ::nRowCount() )
						::ResetBarPos()

               EndIf

            Else

               If nRecNo != ( ::cAlias )->( RecNo() ) .and. ::nLen > nLines

                  nRecNo := ( ::cAlias )->( RecNo() )

                  ( ::cAlias )->( DbSkip( nLines - ::nRowPos ) )

                  If ( ::cAlias )->( EoF() )

                     Eval( ::bGoBottom )
                     ::nRowPos := nLines

                     While ::nRowPos > 1 .and. ;
                           ( ::cAlias )->( RecNo() ) != nRecNo

                        ::Skip( -1 )
                        ::nRowPos --

                     EndDo

                  Else
                     ( ::cAlias )->( DbGoTo( nRecNo ) )
                  EndIf

                  ::Refresh( .F. )
                  ::ResetBarPos()

               ElseIf nRecNo != ( ::cAlias )->( RecNo() )

                  nRecNo := ( ::cAlias )->( RecNo() )
                  Eval( ::bGoTop )
                  ::nAt := ::nRowPos := 1

                  While nRecNo != ( ::cAlias )->( RecNo() )
                     ::Skip( 1 )
                     ::nRowPos++
                  EndDo

                  ::Refresh( .F. )
                  ::ResetBarPos()

               EndIf

            EndIf

            If ::bChange != Nil
               Eval( ::bChange, Self, 0 )
            EndIf

         EndIf

      EndIf

      ::cSeek := cSeek

      If ::oCtx != Nil
         ::oCtx:Save()
      EndIf

      If ::bSeekChange != Nil
         Eval( ::bSeekChange )
      EndIf

   ElseIf ::nColOrder > 0 .and. ::lIsArr

      lTrySeek := .T.
      nIdxLen := Len( cValToChar( ::aArray[ ::nAt, ::nColOrder ] ) )

      If nKey == VK_BACK

         If ::cOrderType == "D"
            cSeek := DateSeek( cSeek, nKey )
         Else
            cSeek := Left( cSeek, Len( cSeek ) - 1 )
         EndIf

      Else

         If ::cOrderType == "D"
            cSeek := DateSeek( cSeek, nKey )
         ElseIf ::cOrderType == "N"
            /* only  0..9, minus and dot*/
            If ( nKey >= 48 .and. nKey <= 57 ) .or. ( nKey >= 45 .or. ;
                 nKey <= 46 )
                cSeek += Chr( nKey )
            Else
               Tone( 500, 1 )
               lTrySeek := .F.
            EndIf
         ElseIf ::cOrderType == "C"
            If Len( cSeek ) < nIdxLen
               cSeek += If( ::lUpperSeek, Upper( Chr( nKey ) ), Chr( nKey ) )
            Else
               Tone( 500, 1 )
               lTrySeek := .F.
            EndIf
         EndIf

      EndIf

      If ::cOrderType == "C"
         xSeek := cPrefix + cSeek
      ElseIf ::cOrderType == "N"
         xSeek := Val( cSeek )
      ElseIf ::cOrderType == "D"
         xSeek := cPrefix + DToS( CToD( cSeek ) )
      Else
         xSeek := cPrefix + cSeek
      EndIf

      If ! ( ::cOrderType == "D" .and. ;
             Len( RTrim( cSeek ) ) < Len( DToC( Date() ) ) ) .and. lTrySeek

         nRecNo := ::nAt
         lFound := lASeek( xSeek,, Self )

         If ! lFound
            ::nAt   := nRecNo
         EndIf

         If ::cOrderType == "C" .and. ! lFound

            Tone( 500, 1 )
            ::cSeek := Left( cSeek, Len( cSeek ) - 1 )
            Return Self

         ElseIf ! lFound

            If ::cOrderType == "N"
               lASeek( Val( cSeek ) * 10, .T. )
               xSeek := ::aArray[ ::nAt, ::nColOrder ]
               xSeek := Val( Right( LTrim( Str( xSeek ) ), Len( cSeek ) + 1 ) )
               If xSeek > ( ( Val( cSeek ) * 10 ) + 9 )
                  Tone( 500, 1 )
                  ::cSeek := Left( cSeek, Len( cSeek ) - 1 )
                  ::nAt := nRecNo
                  Return Self
               EndIf
            EndIf

            ::cSeek := cSeek
            ::nAt   := nRecNo
            Return Self

         Else

            If nRecNo != ::nAt .and. ::nLen > nLines

               nRecNo := ::nAt

               ::nAt += ( nLines - ::nRowPos )

               If ::nAt > ::nLen

                  Eval( ::bGoBottom )
                  ::nRowPos := nLines

                  While ::nRowPos > 1 .and. ::nAt != nRecNo

                     ::Skip( -1 )
                     ::nRowPos --

                  EndDo

               Else
                  ::nAt := nRecNo
               EndIf

               ::Refresh( .F. )
               ::ResetBarPos()

            ElseIf nRecNo != ::nAt

               nRecNo := ::nAt
               Eval( ::bGoTop )
               ::nAt := ::nRowPos := 1

               While nRecNo != ::nAt
                  ::Skip( 1 )
                  ::nRowPos++
               EndDo

               ::Refresh( .F. )
               ::ResetBarPos()

            EndIf

            If ::bChange != Nil
               Eval( ::bChange, Self, 0 )
            EndIf

         EndIf

      EndIf

      ::cSeek := cSeek

      If ::bSeekChange != Nil
         Eval( ::bSeekChange )
      EndIf

   EndIf

   If ! lTrySeek
      ::ResetSeek()
   EndIf

   If ::lIsArr .and. ::bSetGet != Nil
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, ::nAt )
      ElseIf ::nLen > 0
         Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
      Else
         Eval( ::bSetGet, "" )
      EndIf
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:Set3DText() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Set3DText( lOnOff, lRaised, nColumn, nLevel, nClrLight, ;
                  nClrShadow ) CLASS TSBrowse

   Local nEle

   Default lOnOff     := .T., ;
           lRaised    := .T., ;
           nClrLight  := GetSysColor( COLOR_BTNHIGHLIGHT ), ;
           nClrShadow := GetSysColor( COLOR_BTNSHADOW )

   If Empty( ::aColumns )
      Return Self
   EndIf

   If ! lOnOff
      If Empty( nColumn )
         If Empty( nLevel )
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextCell := Nil
               ::aColumns[ nEle ]:l3DTextHead := Nil
               ::aColumns[ nEle ]:l3DTextFoot := Nil
            Next
         ElseIf nLevel == 1
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextCell := Nil
            Next
         ElseIf nLevel == 2
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextHead := Nil
            Next
         Else
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextFoot := Nil
            Next
         EndIf

      ElseIf Empty( nLevel )
         ::aColumns[ nColumn ]:l3DTextCell := Nil
         ::aColumns[ nColumn ]:l3DTextHead := Nil
         ::aColumns[ nColumn ]:l3DTextFoot := Nil
      ElseIf nLevel == 1
         ::aColumns[ nColumn ]:l3DTextCell := Nil
      ElseIf nLevel == 2
         ::aColumns[ nColumn ]:l3DTextHead := Nil
      Else
         ::aColumns[ nColumn ]:l3DTextFoot := Nil
      EndIf

      Return Self

   EndIf

   If Empty( nColumn )
      If Empty( nLevel )
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextCell  := lRaised
            ::aColumns[ nEle ]:l3DTextHead  := lRaised
            ::aColumns[ nEle ]:l3DTextFoot  := lRaised
            ::aColumns[ nEle ]:nClr3DLCell  := nClrLight
            ::aColumns[ nEle ]:nClr3DLHead  := nClrLight
            ::aColumns[ nEle ]:nClr3DLFoot  := nClrLight
            ::aColumns[ nEle ]:nClr3DSCell  := nClrShadow
            ::aColumns[ nEle ]:nClr3DSHead  := nClrShadow
            ::aColumns[ nEle ]:nClr3DSFoot  := nClrShadow
         Next
      ElseIf nLevel == 1
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextCell  := lRaised
            ::aColumns[ nEle ]:nClr3DLCell  := nClrLight
            ::aColumns[ nEle ]:nClr3DSCell  := nClrShadow
         Next
      ElseIf nLevel == 2
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextHead  := lRaised
            ::aColumns[ nEle ]:nClr3DLHead  := nClrLight
            ::aColumns[ nEle ]:nClr3DSHead  := nClrShadow
         Next

      Else
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextFoot  := lRaised
            ::aColumns[ nEle ]:nClr3DLFoot  := nClrLight
            ::aColumns[ nEle ]:nClr3DSFoot  := nClrShadow
         Next
      EndIf
   Else
      If Empty( nLevel )
         ::aColumns[ nColumn ]:l3DTextCell  := lRaised
         ::aColumns[ nColumn ]:l3DTextHead  := lRaised
         ::aColumns[ nColumn ]:l3DTextFoot  := lRaised
         ::aColumns[ nColumn ]:nClr3DLCell  := nClrLight
         ::aColumns[ nColumn ]:nClr3DLHead  := nClrLight
         ::aColumns[ nColumn ]:nClr3DLFoot  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSCell  := nClrShadow
         ::aColumns[ nColumn ]:nClr3DSHead  := nClrShadow
         ::aColumns[ nColumn ]:nClr3DSFoot  := nClrShadow
      ElseIf nLevel == 1
         ::aColumns[ nColumn ]:l3DTextCell  := lRaised
         ::aColumns[ nColumn ]:nClr3DLCell  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSCell  := nClrShadow
      ElseIf nLevel == 2
         ::aColumns[ nColumn ]:l3DTextHead  := lRaised
         ::aColumns[ nColumn ]:nClr3DLHead  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSHead  := nClrShadow
      Else
         ::aColumns[ nColumn ]:l3DTextFoot  := lRaised
         ::aColumns[ nColumn ]:nClr3DLFoot  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSFoot  := nClrShadow
      EndIf
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetADO() Version 8.0 Feb/01/2008
* ============================================================================

/* WORKING ZONE
METHOD SetAdo( oRs ) CLASS TSBrowse

   Local nFields, nFor, oCol

   DEFAULT ::bGoTop    := { || oRs:MoveFirst() }, ;
           ::bGoBottom := { || oRs:MoveLast()  }, ;
           ::bSkip     := { | n | AdoSkip( oRs, If( n == nil, 1, n ) ) }, ;
           ::bKeyNo    := { | n | If( n == nil, oRs:AbsolutePosition, oRs:AbsolutePosition := n ) }, ;
           ::bKeyCount := { || oRs:RecordCount()}

   ::oRS = oRs

   If Len( ::aCols ) == 0
      nFields := oRs:Fields:Count-1

      For nFor := 0 To nFields
         oCol := ::AddCol()
         oCol:cHeader  := oRs:Fields(nFor):Name
         oCol:bStrData := AdoGenFldBlk( oRs, nFor )
      Next
   EndIf

Return Nil */

* ============================================================================
* METHOD TSBrowse:SetAlign() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetAlign( nColumn, nLevel, nAlign ) CLASS TSBrowse

   Default nColumn := 0, ;
            nLevel := 0, ;
            nAlign := DT_LEFT

   If nColumn > 0
      If nLevel > 0
         Do Case
            Case nLevel = 1
               ::aColumns[ nColumn ]:nAlign  := nAlign
            Case nLevel = 2
               ::aColumns[ nColumn ]:nHAlign := nAlign
            Otherwise
               ::aColumns[ nColumn ]:nFAlign := nAlign
         EndCase
      Else
         ::aColumns[ nColumn ]:nAlign := ::aColumns[ nColumn ]:nHAlign := ;
         ::aColumns[ nColumn ]:nFAlign := nAlign
      EndIf
   Else
      If nLevel > 0
         AEval( ::aColumns, { | oCol | If( nLevel = 1, oCol:nAlign := nAlign, ;
                                       If( nLevel = 2, oCol:nHAlign := nAlign, ;
                                           oCol:nFAlign := nAlign ) ) } )
      Else
         AEval( ::aColumns, { | oCol | oCol:nAlign := nAlign, ;
                                       oCol:nHAlign := nAlign, ;
                                       oCol:nFAlign := nAlign } )
      EndIf
   EndIf

   If ::lPainted
      ::Refresh( .T. )
   EndIf


Return Self

* ============================================================================
* METHOD TSBrowse:SetAppendMode() Version 8.0 Feb/01/2008
* Enables append mode in TSBrowse for DBF's and arrays.
* At least one column in TSBrowse must have oCol:lEdit set to TRUE in order
* to work and like direct cell editing.
* ============================================================================

METHOD SetAppendMode( lMode ) CLASS TSBrowse

   Local lPrevMode := ::lCanAppend

   Default lMode    := ! ::lCanAppend, ;
           ::lIsTxt := "TEXT_" $ ::cAlias

   If ! ::lIsTxt
      ::lCanAppend := lMode
   EndIf

Return lPrevMode

* ============================================================================
* METHOD TSBrowse:SetArray() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetArray( aArray, lListBox ) CLASS TSBrowse

   Local nColumns, nI, cType, nMin, nMax, nPage

   DEFAULT aArray   := {}, ;
           lListBox := .F.

   If Len( aArray ) > 0 .and. ValType( aArray[ 1 ] ) != "A"

      ::aArray := {}

      For nI := 1 To Len( aArray )
         AAdd( ::aArray, { aArray[ nI ] } )
      Next

   Else
      ::aArray := aArray
   EndIf

   //            default values for array elements used during append mode
   //            The user MUST AIns() as element no. 1 to ::aDefValue
   //            a nil value when using the actual elemnt no (::nAt)
   //            when browsing arrays like this:
   //            AIns( ASize( ::aDefValue, Len( ::aDefValue ) + 1 ), 1 )
   //            AFTER calling ::SetArray()

   nColumns    := If( ! Empty( ::aArray ), Len( ::aArray[ 1 ] ), 0 )
   ::aDefValue := Array( nColumns )

   For nI := 1 To nColumns
      cType := ValType( ::aArray[ 1, nI ] )
      If cType $ "CM"
         ::aDefValue[ nI ] := Space( Len( ::aArray[ 1, nI ] ) )
      ElseIf cType == "N"
         ::aDefValue[ nI ] := 0
      ElseIf cType == "D"
         ::aDefValue[ nI ] := CToD( "" )
      ElseIf cType == "L"
         ::aDefValue[ nI ] := .F.
      Else                                // arrays, objects and codeblocks not allowed
         ::aDefValue[ nI ] := "???"       // not user editable data type
      EndIf
   Next

   ::nAt       := 1
   ::bKeyNo    := { || ::nAt }
   ::cAlias    := "ARRAY"  // don't change name, used in method Default()
   ::lIsArr    := .T.
   ::nLen      := Eval( ::bLogicLen := { || Len( ::aArray ) + ;
                                            If( ::lAppendMode, 1, 0 ) } )
   ::bGoTop    := { || ::nAt := 1 }
   ::bGoBottom := { || ::nAt := Eval( ::bLogicLen ) }
   ::bSkip     := { | nSkip, nOld | nOld := ::nAt, ::nAt += nSkip,;
                   ::nAt := Min( Max( ::nAt, 1 ), Eval( ::bLogicLen ) ),;
                   ::nAt - nOld }

   ::lHitTop    := .F.
   ::lHitBottom := .F.
   ::nRowPos := 1
   ::nColPos := 1
	::nCell   := 1
	::HiliteCell( 1 )

   If lListBox .and. Empty( ::aColumns )
      nMax := ( ::nRight - ::nLeft + 1 ) * If( Empty( ::hWnd ), 2, 1 )
      ::lDrawHeaders := .F.
      ::nLineStyle   := LINES_NONE
      ::lNoHScroll   := .T.
      ::AddColumn( TSColumn():New( , ArrayWBlock( Self, 1 ),,,, ;
                                     nMax,,,,,,,,,,,,, Self, "ArrayWBlock(::oBrw,1)" ) )
   EndIf

   ::lNoPaint := .F.
   ::Reset()

Return Self

* ============================================================================
* METHOD TSBrowse:SetBtnGet() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetBtnGet( nColumn, cResName, bAction, nBmpWidth ) CLASS TSBrowse

   Default nBmpWidth := 16

   If nColumn == Nil .or. nColumn > Len( ::aColumns ) .or. nColumn <= 0
      Return Self
   EndIf

   ::aColumns[ nColumn ]:cResName  := cResName
   ::aColumns[ nColumn ]:bAction   := bAction
   ::aColumns[ nColumn ]:nBmpWidth := nBmpWidth

Return Self

* ============================================================================
* METHOD TSBrowse:SetColMsg() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetColMsg( cMsg, cEditMsg, nCol ) CLASS TSBrowse

   If Empty( ::aColumns )  .or. ;
      ( cMsg == Nil .and. cEditMsg == Nil )

      Return Self

   EndIf

   If nCol == Nil
      AEval( ::aColumns, { |e| If( cMsg != Nil, e:cMsg := cMsg, Nil ), ;
                               If( cEditMsg != Nil, e:cMsgEdit := cEditMsg, ;
                                   Nil ) } )
   Else
      If cMsg != Nil
         ::aColumns[ nCol ]:cMsg := cMsg
      EndIf

      If cEditMsg != Nil
         ::aColumns[ nCol ]:cMsgEdit := cEditMsg
      EndIf
  EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetColor() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetColor( xColor1, xColor2, nColumn ) CLASS TSBrowse

   Local nEle, nI, nColor

   Default xColor1 := { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }, ;
           nColumn := 0, ;
           ::lTransparent := .F.

   If ( Empty( ::aColumns ) .and. nColumn > 0 )
      Return nil
   End

   If Valtype( xColor1 ) == "N" .and. Valtype( xColor2 ) == "N" .and. nColumn == 0
      Return Super:SetColor( xColor1, xColor2 )  // FW SetColor Method only nClrText and nClrPane
   EndIf

   If Len( ::aColumns ) == 0 .and. ! ::lTransparent .and. ::oBrush == Nil
      nColor := If( ValType( xColor2[ 2 ] ) == "B", Eval( xColor2[ 2 ], 1, 1, Self ), xColor2[ 2 ] )
      ::oBrush := TBrush():New( , nColor )
   EndIf

   If nColumn == 0 .and. ValType ( xColor2[ 1 ] ) == "N" .and. ValType( xColor1 ) == "A" .and. xColor1[ 1 ] == 1 .and. ;
      Len( xColor1 ) > 1 .and. ValType( xColor2 ) == "A" .and. ValType( xColor2[ 2 ] ) == "N" .and. xColor1[ 2 ] == 2

      nColor := If( ValType( xColor2[ 2 ] ) == "B", Eval( xColor2[ 2 ], 1, 1, Self ), xColor2[ 2 ] )
      Super:SetColor( xColor2[ 1 ], nColor )
   EndIf

   If Valtype( xColor1 ) == "N"
      xColor1 := { xColor1 }
      xColor2 := { xcolor2 }
   EndIf

   For nEle := 1 To Len( xColor1 )
      Do Case

         Case xColor1[ nEle ] == 1

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrText := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 2

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrPane := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 3

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrHeadFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrHeadFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrHeadFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 4

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrHeadBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrHeadBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrHeadBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 5

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFocuFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrFocuFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrFocuFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 6

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFocuBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrFocuBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrFocuBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 7

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrEditFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrEditFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrEditFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 8

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrEditBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrEditBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrEditBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 9

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFootFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrFootFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrFootFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 10

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFootBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrFootBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrFootBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 11

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrSeleFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrSeleFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrSeleFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 12

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrSeleBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrSeleBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrSeleBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 13

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrOrdeFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrOrdeFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrOrdeFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 14

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrOrdeBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrOrdeBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrOrdeBack := xColor2[ nEle ]
            EndIf

         Otherwise
            ::nClrLine := xColor2[ nEle ]
      EndCase

   Next

   If ::lPainted
      ::Refresh( .T. )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:SetCols() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetColumns( aData, aHeaders, aColSizes ) CLASS TSBrowse

   Local aFields , nElements, n

   nElements   := Len( aData )

   ::aHeaders  := If( aHeaders  != Nil, aHeaders, ::aHeaders )
   ::aColSizes := If( aColSizes != Nil, aColSizes, {} )
   ::bLine     := {|| _aData( aData ) }
   ::aJustify  := AFill( Array( nElements ), .F. )

   If Len( ::GetColSizes() ) < nElements
      ::aColSizes := AFill( Array( nElements ), 0 )
      aFields := Eval( ::bLine )

      For n := 1 to nElements
          ::aColSizes[ n ] := If( ValType( aFields[ n ] ) != "C",;
                                   15,; // Bitmap handle
                                   GetTextWidth( 0, Replicate( "B", ;
                                   Max( Len( ::aHeaders[ n ] ), ;
                                        Len( aFields[ n ] ) ) + 1 ),;
                                   If( ! Empty( ::oFont ), ::oFont:hFont, 0 ) ) )
      Next
   EndIf

   If ::oHScroll != nil
      ::oHScroll:nMax := ::GetColSizes()
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetColSize() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetColSize( nCol, nWidth ) CLASS TSBrowse

   Local nI, nSize

   If ValType( nCol ) == "A"
      For nI := 1 To Len( nCol )
          nSize := If( ValType( nWidth ) == "A", nWidth[ nI ], nWidth )
          ::aColumns[ nCol[ nI ] ]:nWidth := nSize
          ::aColSizes[ nCol[ nI ] ] := ::aColumns[ nCol[ nI ] ]:nWidth
      Next
   Else
      ::aColumns[ nCol ]:nWidth := nWidth
      ::aColSizes[ nCol ] := ::aColumns[ nCol ]:nWidth
   EndIf

   If ::lPainted
      ::Refresh( .T. )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetData() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetData( nColumn, bData, aList ) CLASS TSBrowse

   Local aArr

   If Valtype( nColumn ) != "N" .or. nColumn <= 0
      Return Nil
   EndIf

   If aList != Nil

      If ValType( aList[ 1 ] ) == "A"
         ::aColumns[ nColumn ]:aItems := aList[ 1 ]
         ::aColumns[ nColumn ]:aData := aList[ 2 ]
         ::aColumns[ nColumn ]:cDataType := ValType( aList[ 2, 1 ] )
      Else
         ::aColumns[ nColumn ]:aItems := aList
      EndIf

      ::aColumns[ nColumn ]:lComboBox := .T.

   EndIf

   If bData != Nil

      If Valtype( bData ) == "B"
         ::aColumns[ nColumn ]:bData := bData
      Else
         ::aColumns[ nColumn ]:bData := {||(bData)}
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetDeleteMode() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetDeleteMode( lOnOff, lConfirm, bDelete, bPostDel ) CLASS TSBrowse

   Default lOnOff   := .T., ;
           lConfirm := .T.

   ::lCanDelete := lOnOff
   ::lConfirm   := lConfirm
   ::bDelete    := bDelete
   ::bPostDel   := bPostDel

Return Self

* ============================================================================
* METHOD TSBrowse:SetFilter() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetFilter( cField, uVal1, uVal2 ) CLASS TSBrowse

   Local cIndexType, cAlias, ;
         lWasFiltered := ::lFilterMode

   Default uVal2 := uVal1

   If ValType( uVal2 ) == "A"
      ::bFilter := uVal2[ 2 ]
      uVal2     := uVal2[ 1 ]
   EndIf

   ::cField      := cField
   ::uValue1     := uVal1
   ::uValue2     := uVal2
   ::lFilterMode := ! Empty( cField )

   If ::lDbfObj
      cAlias := ( ::oDbf:cAlias )
   Else
      cAlias := ::cAlias
   EndIf

   If ::lFilterMode
      ::lDescend := ::uValue2 < ::uValue1

      cIndexType := ( cAlias )->( ValType( &( IndexKey() ) ) )

      If ( ::cAlias )->( ValType( &cField ) ) != cIndexType .or. ValType( uVal1 ) != cIndexType .or. ;
         ValType( uVal2 ) != cIndexType

         MsgInfo( ::aMsg[ 27 ], ::aMsg[ 28 ] )
         ::lFilterMode := .F.
      EndIf

   EndIf

   // Posibility of using FILTERs based on INDEXES!!!

   ::bGoTop := If( ::lFilterMode, {|| BrwGoTop( Self ) }, {|| ( cAlias )->( DbGoTop() ) } )

   ::bGoBottom := If( ::lFilterMode, {|| BrwGoBottom( uVal2, Self ) }, {|| ( cAlias )->( DbGoBottom() ) } )

   ::bSkip := If( ::lFilterMode, BuildSkip( ::cAlias, cField, uVal1, uVal2, Self ), {| n | ::DbSkipper( n ) } )

   ::ResetBarPos( .T. )

   ::lHitTop    := .F.
   ::lHitBottom := .F.

   If ::lFilterMode .or. lWasFiltered
      ::GoTop()
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:SetFont() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetFont( oFont ) CLASS TSBrowse

   If ::lIsV22
      Return Super:SetFont( oFont )
   EndIf

   If ::oFont != Nil
      If ::oFont:nCount != Nil .and. ::oFont:nCount > 1
         ::oFont:nCount--
      Else
         ::oFont:End()
      EndIf
   EndIf

   If oFont != Nil
      ::oFont = oFont
      Default oFont:nCount := 0   // Xbase++ requirement
      oFont:nCount++
      SendMessage( ::hWnd, WM_SETFONT, oFont:hFont )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:SetHeaders() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetHeaders( nHeight, aCols, aTitles, aAlign , al3DLook, aFonts, ;
                   aActions ) CLASS TSBrowse

   Local nI

   If nHeight != Nil
      ::nHeightHead := nHeight
   EndIf

   If aCols == Nil

      aCols := {}

      Do Case

         Case aTitles != Nil
            For nI := 1 TO Len( aTitles )
                AAdd( aCols, nI )
            Next

         Case aAlign != Nil
            For nI := 1 TO Len( aAlign )
                AAdd( aCols, nI )
            Next

         Case al3DLook != Nil
            For nI := 1 TO Len( al3DLook )
                AAdd( aCols, nI )
            Next

         Case aFonts != Nil
            For nI := 1 TO Len( aFonts )
                AAdd( aCols, nI )
            Next

         Case aActions != Nil
            For nI := 1 TO Len( aActions )
                AAdd( aCols, nI )
            Next

         Otherwise
            Return Nil
      EndCase

   EndIf

   For nI := 1 TO Len( aCols )

      If aTitles != Nil
         ::aColumns[ aCols[ nI ] ]:cHeading := aTitles[ nI ]
      EndIf

      If aAlign != Nil
         ::aColumns[ aCols[ nI ] ]:nHAlign := aAlign[ nI ]
      EndIf

      If al3DLook != Nil
         ::aColumns[ aCols[ nI ] ]:l3DLookHead := al3DLook[ nI ]
      EndIf

      If aFonts != Nil
         ::aColumns[ aCols[ nI ] ]:cHeading := aFonts[ nI ]
      EndIf

      If aActions != Nil
         ::aColumns[ aCols[ nI ] ]:bAction := aActions[ nI ]
      EndIf

   Next

   ::DrawHeaders()

Return Self

* ============================================================================
* METHOD TSBrowse:SetIndexCols() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetIndexCols( nCol1, nCol2, nCol3, nCol4, nCol5 ) CLASS TSBrowse

   Local aCol

   Default nCol2 := 0, nCol3 := 0, nCol4 := 0, nCol5 := 0

   If Valtype( nCol1 ) == "A"
      AEval( nCol1, { | nCol | ::aColumns[ nCol ]:lIndexCol := .T. } )
   Else
      aCol := { nCol1, nCol2, nCol3, nCol4, nCol5 }
      AEval( aCol, { | nCol | If( nCol > 0, ;
                                 ::aColumns[ nCol ]:lIndexCol := .T., Nil ) } )
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:SetoDbf() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetoDbf( oDbf ) CLASS TSBrowse

   ::oDbf := oDbf

   If Upper( oDbf:ClassName() )== "TMULTIDBF"
     // setup for the parent as the controlling oDbf
     ::oCtx := oDbf:oCtx
     ::oDbf:oParent:bBof := {||Nil}
     ::oDbf:oParent:bEof := {||Nil}
     ::oDbf:oParent:bNetError := {||Nil}
   Else
     ::oDbf:bBof := {||Nil}
     ::oDbf:bEof := {||Nil}
     ::oDbf:bNetError := {||Nil}
   EndIf

   ::nRowPos    := 1  // reinitialize for multiple calls to this method
   ::nColPos    := 1
   ::nCell      := 1
   ::lHitTop    := .F.
   ::lHitBottom := .F.
   ::cAlias     := oDbf:cAlias
   ::lDbfObj    := .T.
   ::HiliteCell( 1 )

   ::bLogicLen := {|| ::oDbf:RecCount() }
   ::bGoTop    := {|| ::oDbf:GoTop() }
   ::bGoBottom := {|| ::oDbf:GoBottom() }
   ::bSkip     := {| nSkip | ::oDbf:Skipper( nSkip ) }

Return Self

* ============================================================================
* METHOD TSBrowse:SetOrder() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetOrder( nColumn, cPrefix, lDescend ) CLASS TSBrowse

   Local nDotPos, cAlias, ;
         lReturn := .F., ;
         oColumn := If( ::lIsDbf, ::aColumns[ nColumn ], Nil )

   Default ::lIsArr := ::cAlias == "ARRAY"

   If nColumn == Nil .or. nColumn > Len( ::aColumns )
      Return .F.
   EndIf

   ::lNoPaint := .F.

   If ::lIsDbf .and. ! Empty( oColumn:cOrder ) .and. nColumn != ::nColOrder

      cAlias := If( ::lDbfObj, ::oDbf:cAlias, ::cAlias )

      If ::cDriver == Nil
         ::ResetBarPos( .T. )     // dialogs initialize differently from windows!?
      EndIf

      If ( nDotPos := At( ".", oColumn:cOrder ) ) > 0 // in case TAG has an extension (ie .NTX)
			oColumn:cOrder := SubStr( oColumn:cOrder, 1, nDotPos - 1 )
      EndIf

      If ::lDbfObj

         If ::cDriver == "NSX"
            ( cAlias )->( Eval( ::bTagOrder, oColumn:cOrder ) )
			Else
			   ::oDbf:SetOrder( oColumn:cOrder )
         EndIf

         ::uLastTag := ( cAlias )->( Eval( ::bTagOrder ) )

		Else

         If ::cDriver == "NTX" .and. ! ( "5.3" $ Version() )
            ::uLastTag := If( ValType( oColumn:cOrder ) == "C", Val( oColumn:cOrder ), oColumn:cOrder )
            ( cAlias )->( Eval( ::bTagOrder, Max( 1, ::uLastTag ) ) )
            ::uLastTag := oColumn:cOrder
         Else
            ::uLastTag := oColumn:cOrder
            ( cAlias )->( Eval( ::bTagOrder, oColumn:cOrder ) )
         EndIf

      EndIf

      If Empty( ( cAlias )->( IndexKey() ) )
		   ::cOrderType := ""
		Else
         ::cOrderType := ( cAlias )->( ValType( &( IndexKey() ) ) )
      EndIf

      If ::oCtx != Nil
		   ::oCtx:ReNew()
      EndIf

      If ! ::lDbfObj .and. ::lPainted
         ::UpStable()    // ::UpStable() won't work with DBFOBJECT
      ElseIf ::lPainted
         ::Refresh()
      EndIf

      ::ResetBarPos()
      ::nColOrder := nColumn
      ::ResetSeek()

      If ::bSetOrder != Nil
         Eval( ::bSetOrder, Self, ( cAlias )->( Eval( ::bTagOrder ) ), nColumn )
      EndIf

      lReturn := .T.

      If cPrefix != Nil
         ::cPrefix := cPrefix
      EndIf

      ::aColumns[ nColumn ]:lSeek := .T.

   ElseIf ::lIsArr .and. nColumn != ::nColOrder

      If ::cDriver == Nil
         ::ResetBarPos( .T. )
      EndIf

      If nColumn <= Len( ::aArray[ 1 ] )
         ::cOrderType := ValType( ::aArray[ ::nAt, nColumn ] )
         ::nColOrder  := nColumn

         If ::bSetOrder != Nil
            Eval( ::bSetOrder, Self, nColumn )
         Else
            ::SortArray()
         EndIf

         ::Refresh()
         ::ResetBarPos()
         ::aColumns[ nColumn ]:lSeek := .T.
      EndIf

      ::ResetSeek()
      lReturn := .T.

      If cPrefix != Nil
         ::cPrefix := cPrefix
      EndIf

      If ::bSetGet != Nil
         If ValType( Eval( ::bSetGet ) ) == "N"
            Eval( ::bSetGet, ::nAt )
         ElseIf ::nLen > 0
            Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
         Else
            Eval( ::bSetGet, "" )
         EndIf
      EndIf

   EndIf

   ::lHitTop := ::lHitBottom := .F.

Return lReturn

* ============================================================================
* METHOD TSBrowse:SetSelectMode() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetSelectMode( lOnOff, bSelected, uBmpSel, nColSel, nAlign ) CLASS TSBrowse

   Default lOnOff  := .T., ;
           nColSel := 1, ;
           nAlign  := DT_RIGHT

   ::lCanSelect := lOnOff
   ::bSelected  := bSelected
   ::aSelected  := {}

   If ::lCanSelect .and. ;
      ( uBmpSel == Nil .or. Empty( nColSel ) .or. nColSel > Len( ::aColumns ) )
      Return Self
   EndIf

   If ::lCanSelect .and. uBmpSel != Nil

      If ValType( uBmpSel ) != "C"
         ::uBmpSel  := uBmpSel
      Else
         If At( ".BMP", Upper( uBmpSel )  ) > 0
            ::uBmpSel  := TBitMap():Define( , uBmpSel, Self )
         Else
            ::uBmpSel  := TBitMap():Define( uBmpSel,, Self )
         EndIf

         ::lDestroy := .T.
      EndIf

      ::nColSel  := nColSel
      ::nAligBmp := nAlign

   ElseIf ::uBmpSel != Nil

      If ::lDestroy
         ::uBmpSel:End()
      EndIf

      ::lDestroy := .F.
      ::uBmpSel  := Nil
      ::nCoSel   := 0
      ::nAligBmp := 0

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetSpinner() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetSpinner( nColumn, lOnOff, bUp, bDown, bMin, bMax ) CLASS TSBrowse

   Default lOnOff := .T., ;
           bUp := { | oGet | oGet++ }, ;
           bDown := { | oGet | oGet++ }

   If nColumn == Nil .or. nColumn > Len( ::aColumns ) .or. nColumn <= 0
      Return Self
   EndIf

   ::aColumns[ nColumn ]:lSpinner := lOnOff
   ::aColumns[ nColumn ]:bUp      := bUp
   ::aColumns[ nColumn ]:bDown    := bDown
   ::aColumns[ nColumn ]:bMin     := bMin
   ::aColumns[ nColumn ]:bMax     := bMin

Return Self

* ============================================================================
* METHOD TSBrowse:SetTree() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetTree( oTree ) CLASS TSBrowse

   Local oItem := oTree:oFirst

   ::lMChange   := .F.
   ::bKeyNo     := { || ::nAt }
   ::bLine      := { || oItem:GetLabel() }
   ::aLine      := oItem:GetLabel()
   ::aColSizes  := { || oItem:ColSizes() }
   ::bGoTop     := { || oItem := oTree:oFirst }
   ::bGoBottom  := { || oItem := oTree:GetLast() }
   ::bSkip      := { | n | oItem := oItem:Skip( @n ), ::nAt += n, ::oTree := oItem, n }
   ::bLogicLen  := { || ::nLen := oTree:nCount() }
   ::bLDblClick := { || If( oItem:oTree != nil,;
                          ( oItem:Toggle(), ::Refresh() ),) }
   ::oTree      := oItem
   ::bKeyChar   := { | nKey | If( nKey == VK_RETURN .and. oItem:oTree != nil,;
                          ( oItem:Toggle(), ::Refresh() ),) }

   If ::oHScroll != nil
      ::oHScroll := nil
      ::lNoHScroll := .T.
   EndIf

   oTree:Draw()
   ::cAlias := "TREE_"

Return Self

* ============================================================================
* METHOD TSBrowse:SetTxtFile() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SetTxtFile( uTxtFile, cTitle, lOemToAnsi ) CLASS TSBrowse

   Default lOemToAnsi := .F.

   If ValType( uTxtFile ) == "C"

      If ! File( uTxtFile )
         MsgStop( ::aMsg[ 29 ] + Space( 1 ) + uTxtFile + Space( 1 ) + ;
                  ::aMsg[ 30 ], ::aMsg[ 28 ] )
         Return Nil
      EndIf

      ::oTxtFile := TTxtFile():New(uTxtFile, 0)
      ::cAlias := "TEXT_" + AllTrim( uTxtFile )

   Else   // is a TTxtFile object
      ::oTxtFile := uTxtFile
      ::cAlias := "TEXT_" + AllTrim( uTxtFile:cName )
   EndIf

   ::lIsTxt := .T.
   ::oTxtFile:nTLines ++         // for the last CRLF at eof()
   ::nOffset := 1                    // we'll use this as an offset marker

   Default cTitle := SubStr( ::cAlias, At( "_", ::cAlias ) + 1 )

   ::AddColumn( TSColumn():New( cTitle, ;
       If( lOemToAnsi, {|| OemToAnsi( SubStr( ::oTxtFile:ReadLine(), ::nOffset ) ) }, ;
           {|| SubStr( ::oTxtFile:ReadLine(), ::nOffset ) } ),, ;
           {::nClrText,::nClrPane},, 1024 ) )

   ::nLineStyle := LINES_NONE // don't want gridlines with text files
   ::bKeyNo    := {|| ::nAt }
   ::nLen      := Eval( ::bLogicLen := {|| ::oTxtFile:LastRec() } )
   ::bGoTop    := {|| ::oTxtFile:GoTop() }
   ::bGoBottom := {|| ::oTxtFile:GoBottom() }
   ::bSkip     := {|nSkip, nOld| nOld := ::oTxtFile:RecNo(),;
                   ::oTxtFile:Skip( nSkip ), ::nAt := ::oTxtFile:RecNo(), ;
                   ::oTxtFile:RecNo() - nOld }

   ::nRowPos := ::nAt := 1                                // reinitialize for multiple calls to this method
	::nColPos := 1
	::nCell   := 1
   ::HiliteCell( 1 )

Return Self

* ============================================================================
* METHOD TSBrowse:ShowSizes() Version 8.0 Feb/01/2008
* ============================================================================

METHOD ShowSizes() CLASS TSBrowse

   Local cText  := "", ;
         nTotal := 0, ;
         aTemp  := ::GetColSizes()

   AEval( aTemp, { | e, n | nTotal += e, cText += ( If( ValType( ::aColumns[ n ]:cHeading ) == "C", ;
                   ::aColumns[ n ]:cHeading, ::aMsg[ 24 ] + Space( 1 ) + Ltrim( Str( n ) ) ) + ": " + ;
                   Str( e, 3 ) + " Pixels" + CRLF ) } )

   cText += CRLF + "Total " + Str( nTotal, 4 ) + " Pixels" + CRLF + ::aMsg[ 25 ] + Space( 1) + ;
            Str( ::nWidth(), 4 ) + " Pixels" + CRLF

   MsgInfo( cText, ::aMsg[ 26 ] )

Return Self

* ============================================================================
* METHOD TSBrowse:Skip() Version 8.0 Feb/01/2008
* ============================================================================

METHOD Skip( n ) CLASS TSBrowse

   Local nSkipped

   If ::bSkip != Nil
      nSkipped := Eval( ::bSkip, n )
   Else
      nSkipped := ::DbSkipper( n )
   EndIf

   If ::lIsDbf
      ::nLastPos := ( ::cAlias )->( RecNo() )
   EndIf

   ::nLastnAt := ::nAt

   If ::lIsArr .and. ::bSetGet != Nil
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, ::nAt )
      ElseIf ::nLen > 0
         Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
      Else
         Eval( ::bSetGet, "" )
      EndIf
   EndIf

Return nSkipped

* ============================================================================
* METHOD TSBrowse:SortArray() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SortArray( nCol, lDescend ) CLASS TSBrowse

   Local aArray := ::aArray

   Default nCol     := ::nColOrder, ;
           lDescend := .F.

   CursorWait()

   If lDescend
      ::SetArray( ASort( aArray,,, { |x,y| x[nCol] > y[nCol] } ) )
   Else
      ::SetArray( ASort( aArray,,, { |x,y| x[nCol] < y[nCol] } ) )
   EndIf

   Eval( ::bGoTop )
   CursorArrow()

Return Self

* ============================================================================
* METHOD TSBrowse:SwitchCols() Version 8.0 Feb/01/2008
* This method is dedicated to John Stolte by the 'arry
* ============================================================================

METHOD SwitchCols( nCol1, nCol2 ) CLASS TSBrowse

   Local oHolder, nHolder, nMaxCol := Len(::aColumns)

   If nCol1 > ::nFreeze .and. nCol2 > ::nFreeze .and. ;
      nCol1 <= nMaxCol .and. nCol2 <= nMaxCol

      oHolder := ::aColumns[ nCol1 ]
      nHolder := ::aColSizes[ nCol1 ]

      ::aColumns[ nCol1 ]  := ::aColumns[ nCol2 ]
      ::aColSizes[ nCol1 ] := ::aColSizes[ nCol2 ]

      ::aColumns[ nCol2 ]  := oHolder
      ::aColSizes[ nCol2 ] := nHolder

      If ::nColOrder == nCol1
         ::nColOrder := nCol2
      EndIf

   EndIf

   If ::lPainted
      ::Refresh( .F. )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SyncChild() Version 8.0 Feb/01/2008
* ============================================================================

METHOD SyncChild( aoChildBrw, abAction ) CLASS TSBrowse

   If aoChildBrw != Nil
		If ValType( aoChildBrw ) == "O"
			aoChildBrw := { aoChildBrw }
      EndIf

      Default abAction := Array( Len( aoChildBrw ) )

      If ValType( abAction ) == "B"
			abAction := { abAction }
      EndIf

      ::bChange := {|| ;
                       AEval( aoChildBrw, {|oChild,nI| If( ! Empty( oChild:cAlias ),;
                       ( oChild:lHitTop := .F., oChild:goTop(),;
                       If( abAction[nI] != Nil, Eval( abAction[nI], Self, oChild ), Nil ),;
                       oChild:reset() ), Nil ) } ) }
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:UpStable() Version 8.0 Feb/01/2008
* ============================================================================

METHOD UpStable() CLASS TSBrowse

   Local nRow     := ::nRowPos, ;
         nRecNo   := ( ::cAlias )->( RecNo() ), ;
         nRows    := ::nRowCount(), ;
         n        := 1, ;
         lSkip    := .T., ;
         bChange  := ::bChange, ;
         nLastPos := ::nLastPos

   If ::nLen > nRows

      ( ::cAlias )->( DbSkip( nRows - nRow ) )

      If EoF()
         Eval( ::bGoBottom )
         ::nRowPos := nRows

         While ::nRowPos > 1 .and. ( ::cAlias )->( RecNo() ) != nRecNo
            ::Skip( -1 )
            ::nRowPos --
         EndDo

         ::Refresh( .F. )
         ::ResetBarPos()
         Return Self
      Else
         ( ::cAlias )->( DbGoto( nRecNo ) )
      EndIf

   EndIf

   ::bChange    := Nil
   ::lHitTop    := .F.
   ::lHitBottom := .F.
   ::GoTop()

   While ! ( ::cAlias )->( EoF() )

      If n > nRows
         ::nRowPos := nRow
         lSkip     := .F.
         Exit
      EndIf

      If nRecNo == ( ::cAlias )->( RecNo() )
         ::nRowPos := n
         Exit
      Else
         ::Skip( 1 )
      EndIf

      n++

   Enddo

   If lSkip
      ::Skip( -::nRowPos )
   EndIf

   ( ::cAlias )->( DbGoTo( nRecNo ) )                // restores Record position
   ::nLastPos := nLastPos
   ::nAt      := ::nLastnAt := ::nLogicPos()
   ::lHitTop := .F.

   If ::oVScroll != Nil .and. ! Empty( ::bKeyNo )     // restore scrollbar thumb
      ::oVScroll:SetPos( ::RelPos( ( ::cAlias )->( Eval( ::bKeyNo ) ) ) )
   EndIf

   ::bChange := bChange

   If ::lPainted
      ::Refresh( If( ::nLen < nRows, .T., .F. ) )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:VertLine() Version 8.0 Feb/01/2008
* Thanks to Gianni Santamarina
* ============================================================================

METHOD VertLine( nColPixPos, nColInit, nGapp ) CLASS TSBrowse

   Local hDC      := GetDC( ::hWnd )
   Local oRect    := ::GetRect(), ;
         nRigHe   := 1, ;
         hRighe   := GetTextHeight( ::hWnd, hDC ), ;
         bDestroy := If( ::lIsV22, { || ::DestroyToolTip() }, {||Nil} )

   If nColInit != Nil
      nsCol   := nColInit
      nsWidth := nColPixPos
      nsOldPixPos := 0
      nGap := If( ! Empty( nGapp ), nGapp, 0 )
      ::ncMouseMove()
      hWndParent := 0
      hPrvWnd    := 0
      lToolTip   := .F.
      InvertRect( hDC, { 0, nsWidth - ::aColSizes[ nsCol ] - 2, oRect:nBottom, nsWidth - ::aColSizes[ nsCol ] + 2 } )
   EndIf

   If nColPixPos == Nil .and. nColInit == Nil   // We have finish draging
      ::aColSizes[ nsCol ] -= ( nsWidth - nsOldPixPos )
      ::aColumns[ nsCol ]:nWidth -= ( nsWidth - nsOldPixPos )
      ::ncMouseMove()
      ::Refresh( .F. )
   EndIf

   oRect := ::GetRect()

   If nsOldPixPos != 0 .and. nColPixPos != Nil .and. nColPixPos != nsOldPixPos
      InvertRect( hDC, { 0, nsOldPixPos - 2, oRect:nBottom, nsOldPixPos + 2 } )
      nsOldPixPos := 0
   EndIf

   If nColPixPos != Nil .and. nColPixPos != nsOldPixPos

      nColPixPos := Max( nColPixPos, 10 )

      If nColInit == Nil
         Eval( bDestroy )
      EndIf
      ::ShowToolTip( -( nRighe * hRighe ), nsWidth, ::aMsg[ 31 ] + ;
                     PadL(::aColSizes[ nsCol ] - ( nsWidth - nColPixPos - nGap ), 5 ) )
      InvertRect( hDC, { 0, nColPixPos - 2 + nGap, oRect:nBottom, nColPixPos + 2 + nGap } )
      nsOldPixPos := nColPixPos + nGap
   EndIf

   ReleaseDC( ::hWnd, hDC )

Return Nil

* ============================================================================
* METHOD TSBrowse:VScroll() Version 8.0 Feb/01/2008
* ============================================================================

METHOD VScroll( nWParam, nLParam ) CLASS TSBrowse

   Local nLen, nPos, nSkipped, nActualPos, nBottomPos, ;
         nLines := Min( ::nLen, ::nRowCount() )

   ::lNoPaint := .F.

   If GetFocus() != ::hWnd
      SetFocus( ::hWnd )
   EndIf

   Do Case
      Case nWParam == SB_LINEUP
         ::GoUp()

      Case nWParam == SB_LINEDOWN
         If ! ::lHitBottom
            ::GoDown()
         EndIf

      Case nWParam == SB_PAGEUP
         ::PageUp()

      Case nWParam == SB_PAGEDOWN
         ::PageDown()

      Case nWParam == SB_TOP
         ::GoTop()

      Case nWParam == SB_BOTTOM
         ::GoBottom()

      Case nWParam == SB_THUMBPOSITION

         nBottomPos := nLParam + ::oVScroll:nPgStep - 1

         If ::nLen == 0
            ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), Eval( ::bLogicLen ) )
         EndIf

         If ::nLen < 1
            Return 0
         EndIf

         If nLParam == 1
            ::GoTop()
            Return 0
         ElseIf nBottomPos >= ::oVScroll:GetRange()[ 2 ]
            ::GoBottom()
            Return 0
         Else
            CursorWait()
            If ::bGoToPos != Nil
               ( ::cAlias )->( Eval( ::bGoToPos, ::GetRealPos( nLParam ) ) )
            Else
               nSkipped := ::Skip( ( ::GetRealPos( nLParam ) - ::GetRealPos( ::oVScroll:GetPos() ) ) )
            EndIf
            CursorArrow()
            ::lHitTop := .F.
            ::lHitBottom := .F.
         EndIf

         If ::lIsDbf
            ::nLastPos := ( ::cAlias )->( RecNo() )
         EndIf

         ::nAt := ::nLogicPos()
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )

         If ( nBottomPos - ::oVScroll:nMin ) < nLines
              ::nRowPos := 1
         EndIf

         If ( ::oVScroll:nMax - nLParam ) < Min( nLines, ::nLen )
            ::nRowPos := Min( nLines, ::nLen ) - ( ::oVScroll:nMax - nLParam )
         EndIf

         ::Refresh( .F. )

         If ::bChange != nil
            Eval( ::bChange, Self, 0 )
         EndIf

      Otherwise
         Return Nil
   Endcase

Return 0

* ============================================================================
*                    TSBrowse   Functions
* ============================================================================


* ============================================================================
* FUNCTION TSBrowse _aData() Version 8.0 Feb/01/2008
* Called from METHOD SetCols()
* ============================================================================

Static Function _aData( aFields )

  Local aFld, nFor, nLen

  nLen := Len( aFields )
  aFld := Array( nLen )

  For nFor := 1 To nLen
     aFld[ nFor ] := Eval( aFields[ nFor ] )
  Next

Return aFld

* ============================================================================
* FUNCTION TSBrowse AClone() Version 8.0 Feb/01/2008
* Only for Harbour since by now it isn't working correctly
* ============================================================================

#ifdef __HARBOUR__
Static Function AClone( aSource )

   Local aTarget := {}

   AEval( aSource, { |e| AAdd( aTarget, e ) } )

Return aTarget
#EndIf

* ============================================================================
* FUNCTION TSBrowse lASeek() Version 8.0 Feb/01/2008
* Incremental searching in arrays
* ============================================================================

Static Function lASeek( uSeek, lSoft, oBrw )

   Local nEle, uData, ;
         lFound := .F., ;
         aArray := oBrw:aArray, ;
         nCol   := oBrw:nColOrder, ;
         nRecNo := oBrw:nAt

   Default lSoft := .F.

   For nEle := Max( 1, nNewEle ) To Len( aArray )

      uData := aArray[ nEle, nCol ]
      uData := If( oBrw:lUpperSeek, Upper( uData ), uData )

      If ! lSoft
         If uData = uSeek
            lFound := .T.
            Exit
         EndIf
      Else
         If uData >= uSeek
            lFound := .T.
            Exit
         EndIf
      EndIf

   Next

   If lFound .and. nEle <= oBrw:nLen
      oBrw:nAt := nEle
      nNewEle  := nEle
   Else
      oBrw:nAt := nRecNo
   EndIf

Return lFound

* ============================================================================
* FUNCTION TSBrowse BrwGoBottom() Version 8.0 Feb/01/2008
* Used by METHOD SetFilter() to set the bottom limit in an "Index Based"
* filtered database
* ============================================================================

Static Function BrwGoBottom( uExpr, oBrw )

   If ValType( uExpr ) == "C"
      ( oBrw:cAlias )->( DbSeek( SubStr( uExpr, 1, Len( uExpr ) - 1 ) + ;
              Chr( Asc( SubStr( uExpr, Len( uExpr ) ) ) + ;
              If( ! oBrw:lDescend, 1, - 1 ) ), .T. ) )
   Else
      ( oBrw:cAlias )->( DbSeek( uExpr + ;
                                 If( ! oBrw:lDescend, 1, - 1 ), .T. ) )
   EndIf

   If ( oBrw:cAlias )->( EoF() )
      ( oBrw:cAlias )->( DbGoBottom() )
   Else
      ( oBrw:cAlias )->( DbSkip( -1 ) )
   EndIf

   While oBrw:bFilter != Nil .and. ! Eval( oBrw:bFilter ) .and. ! BoF()
      ( oBrw:cAlias )->( DbSkip( -1 ) )
   EndDo

Return Nil

* ============================================================================
* FUNCTION TSBrowse BrwGoTop() Version 8.0 Feb/01/2008
* Used by METHOD SetFilter() to set the top limit in an "Index Based"
* filtered database
* ============================================================================

Static Function BrwGoTop( oBrw )

   ( oBrw:cAlias )->( DbSeek( oBrw:uValue1, .T. ) )

   While oBrw:bFilter != Nil .and. ! Eval( oBrw:bFilter ) .and. ! EoF()
      ( oBrw:cAlias )->( DbSkip( 1 ) )
   EndDo

Return Nil

* ============================================================================
* FUNCTION TSBrowse BuildSkip() Version 8.0 Feb/01/2008
* Used by METHOD SetFilter(). Returns a block to be used on skipping records
* in an "Index Based" filtered database
* ============================================================================

Static Function BuildSkip( cAlias, cField, uValue1, uValue2, oTb )

   Local bSkipBlock, lDescend := oTb:lDescend, ;
         cType := ValType( uValue1 )

   Do Case
      Case cType == "C"
           If ! lDescend
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + ">= '" + uValue1 + "' .and." + ;
              cField + "<= '" + uValue2 + "' }" ), oTb ) ) }
           Else
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + "<= '" + uValue1 + "' .and." + ;
              cField + ">= '" + uValue2 + "' }" ), oTb ) ) }
           EndIf
      Case cType == "D"
           If ! lDescend
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + ">= CToD( '" + DToC( uValue1 ) + "') .and." + ;
              cField + "<= CToD( '" + DToC( uValue2 ) + "') }" ), oTb ) ) }
           Else
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + "<= CToD( '" + DToC( uValue1 ) + "') .and." + ;
              cField + ">= CToD( '" + DToC( uValue2 ) + "') }" ), oTb ) ) }
           EndIf

      Case cType == "N"
           If ! lDescend
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + ">= " + cValToChar( uValue1 ) + " .and." + ;
              cField + "<= " + cValToChar( uValue2 ) + " }" ), oTb ) ) }
           Else
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + "<= " + cValToChar( uValue1 ) + " .and." + ;
              cField + ">= " + cValToChar( uValue2 ) + " }" ), oTb ) ) }
           EndIf

      Case cType == "L"
           If ! lDescend
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + ">= " + cValToChar( uValue1 ) + " .and." + ;
              cField + "<= " + cValToChar( uValue2 ) + " }" ), oTb ) ) }
           Else
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + "<= " + cValToChar( uValue1 ) + " .and." + ;
              cField + ">= " + cValToChar( uValue2 ) + " }" ), oTb ) ) }
           EndIf
   Endcase

Return bSkipBlock

* ============================================================================
* FUNCTION TSBrowse BrwGoto() Version 8.0 Feb/01/2008
* Executes the action defined into the block created with FUNCTION BuildSkip()
* ============================================================================

Static Function BrwGoTo( n, bWhile, oTb )

   Local nSkipped := 0, ;
         nDirection := If( n > 0, 1, -1 )

   While nSkipped != n .and. Eval( bWhile ) .and. ! EoF() .and. ! BoF()
      DbSkip( nDirection )
      nSkipped += nDirection

      If oTb:bFilter != Nil
         While ! Eval( oTb:bFilter ) .and. ! EoF() .and. ! BoF()
            DbSkip( nDirection )
         EndDo
      EndIf

   EndDo

   Do Case
      Case EoF()
	      DbSkip( -1 )

         While oTb:bFilter != Nil .and. ! Eval( oTb:bFilter ) .and. ! BoF()
            DbSkip( -1 )
         EndDo

         If ! oTb:lAppendMode
	         nSkipped += -nDirection
			Else
				If oTb:nPrevRec == Nil
					oTb:nPrevRec := RecNo()
            EndIf
				DbGoTo( 0 )                          // phantom record
         EndIf

      Case BoF()
         DbGoTo( RecNo() )

         While oTb:bFilter != Nil .and. ! Eval( oTb:bFilter ) .and. ! EoF()
            DbSkip( 1 )
         EndDo

         nSkipped++

      Case ! Eval( bWhile )
			If nDirection == 1 .and. oTb:lAppendMode
				If oTb:nPrevRec == Nil
		         DbSkip( -1 )
					oTb:nPrevRec := RecNo()
            EndIf
				DbGoTo( 0 )                          // phantom record
			Else
	         DbSkip( -nDirection )
            While oTb:bFilter != Nil .and. ! Eval( oTb:bFilter ) .and. ;
               ! BoF() .and. ! EoF()
               DbSkip( -nDirection )
            EndDo

	         nSkipped += -nDirection
         EndIf
   Endcase

Return nSkipped

* ============================================================================
* FUNCTION TSBrowse:DateSeek() Version 8.0 Feb/01/2008
* ============================================================================

Static Function DateSeek( cSeek, nKey )

    Local cChar  := Chr( nKey ), ;
          nSpace := At( " ", cSeek ), ;
          cTemp  := ""

    /* only  0..9 */
    If nKey >= 48 .and. nKey <= 57
       If nSpace <> 0
          cTemp := Left( cSeek, nSpace - 1 )
          cTemp += cChar
          cTemp += SubStr( cSeek, nSpace + 1, Len( cSeek ) )
          cSeek := cTemp
       Else
          cSeek := cSeek
          Tone(500, 1)
       EndIf
    ElseIf nKey == VK_BACK
        If nSpace == 4 .or. nSpace == 7
           cTemp := Left( cSeek, nSpace - 3 )
           cTemp += " "
           cTemp += SubStr( cSeek, nSpace - 1, Len( cSeek ) )
        ElseIf nSpace == 0
           cTemp := Left( cSeek, Len( cSeek ) - 1 )
        ElseIf nSpace == 1
           cTemp := cSeek
        Else
            cTemp := Left( cSeek, nSpace - 2 )
            cTemp += " "
            cTemp += SubStr( cSeek, nSpace, Len( cSeek ) )
        EndIf
        cSeek := PadR( cTemp, 10 )
    Else
       Tone( 500, 1 )
    EndIf

Return cSeek

* ============================================================================
* FUNCTION TSBrowse EmptyAlias() Version 8.0 Feb/01/2008
* Returns .T. if cAlias is not a constant "ARRAY" (browsing an array),
* or a constant "TEXT_" (browsing a text file), or an active database alias.
* ============================================================================

Static Function EmptyAlias( cAlias )

   Local nArea, bErrorBlock, ;
         lEmpty := .T.

   If ! Empty( cAlias )

      If cAlias == "ARRAY" .or. "TEXT_" $ cAlias
         lEmpty:= .F.
      Else
         bErrorBlock:= ErrorBlock( {|| Break( Nil ) } )
         BEGIN SEQUENCE
            If (cAlias)->( Used() )
               lEmpty:= .F.
            EndIf
         END SEQUENCE
         ErrorBlock( bErrorBlock )
      EndIf

    EndIf

Return lEmpty

* ============================================================================
* FUNCTION TSBrowse FieldSetGetBlock() Version 8.0 Feb/01/2008
* Called from METHOD LoadFields() to assign data to columns
* ============================================================================

Static Function FieldSetGetBlock( cAlias, n )

Return { | u | If( PCount() == 0,;
                 ( cAlias )->( FieldGet( n ) ),;
                 ( cAlias )->( FieldPut( n, u ) ) ) }

* ============================================================================
* FUNCTION TSBrowse GenData() Version 8.0 Feb/01/2008
* ============================================================================

Static Function GenData( aArray, nPos )

   Local b1, b2, cPart1, cPart2, aData, nAt, ;
         cData := aArray[ nPos ]:cData, ;
         cType := ValType( Eval( aArray[ nPos ]:bData ) )

   cData := If( cData != Nil, ;
                AllTrim( Upper( StrTran( aArray[ nPos ]:cData, " " ) ) ), "" )

   If cType == "U"

      aData := { {||""} }

   ElseIf cType == "C" .and. ( nAt := At( "+CHR(13)+CHR(10)", cData ) ) > 0 .and. At( "{", cData ) == 0

      cPart1 := SubStr( cData, 1, nAt - 1 )
      cPart2 := SubStr( cData, nAt + 17 )

      b1 := &( '{||' + cPart1 + '}' )
      b2 := &( '{||' + cPart2 + '}' )
      aData := { b1, b2 }

   Else
      aData := { aArray[ nPos ]:bData }
   EndIf

Return aData

* ============================================================================
* FUNCTION TSBrowse GenFoot() Version 8.0 Feb/01/2008
* ============================================================================

Static Function GenFoot( aArray, nPos )

Return {|| aArray[nPos]:cFooting }

* ============================================================================
* FUNCTION TSBrowse GenHead() Version 8.0 Feb/01/2008
* ============================================================================

Static Function GenHead( aArray, nPos )

   Local cPart1, cPart2, aHead, b1, b2, ;
         cHead := aArray[ nPos ]:cHeading, ;
         nAt := At( CRLF, aArray[ nPos ]:cHeading )

   If ValType( cHead ) == "B"
      cHead := Eval( cHead )
   EndIf

   cPart1 := If( nAt > 0, SubStr( cHead, 1, nAt - 1 ), "" )
   cPart2 := If( nAt > 0, SubStr( cHead, nAt + 2 ), "" )

   If ! Empty( cPart2 )
      b1 := &('{||"' + cPart1 + '"}' )
      b2 := &('{||"' + cPart2 + '"}' )
      aHead := { b1, b2 }
   Else
      b1 := &( '{||"' + AllTrim( cHead ) + '"}' )
      aHead := { b1 }
   EndIf

Return aHead

* ============================================================================
* FUNCTION TSBrowse IsChar() Version 8.0 Feb/01/2008
* Used by METHOD KeyChar() to filter keys according to the field type
* Clipper's function IsAlpha() doesn't fit the purpose in some cases
* ============================================================================

Static Function IsChar( nKey )

Return ( nKey >= 32 .and. nKey <= 255 )

* ============================================================================
* FUNCTION TSBrowse IsNumeric() Version 8.0 Feb/01/2008
* Function used by METHOD KeyChar() to filter keys according to the field type
* Clipper's function IsDigit() doesn't fit the purpose in some cases
* ============================================================================

Static Function IsNumeric( nKey )

Return ( Chr( nKey ) $ ".+-0123456789" )

* ============================================================================
* FUNCTION TSBrowse MakeBlock() Version 8.0 Feb/01/2008
* Called from METHOD Default() to assign data to columns
* ============================================================================

Static Function MakeBlock( Self, nI )

Return {|| Eval(::bLine)[ nI ] }

* ============================================================================
* FUNCTION TSBrowse SetHeights() Version 8.0 Feb/01/2008
* ============================================================================

Static Function SetHeights( oBrw )

   Local nEle, nHeight, nHHeight, oColumn, nAt, cHeading, cRest, nOcurs, hFont, aRect, nLines, ;
         aSuper       := oBrw:aSuperHead, ;
         lDrawFooters := If( oBrw:lDrawFooters != Nil, oBrw:lDrawFooters, .F. )

   Default oBrw:nLineStyle := LINES_ALL

   If oBrw:lDrawHeaders

      nHHeight := oBrw:nHeightHead

      For nEle := 1 TO Len( oBrw:aColumns )

         oColumn := oBrw:aColumns[ nEle ]
         cHeading := If( Valtype( oColumn:cHeading ) == "B", Eval( oColumn:cHeading ), oColumn:cHeading )
         hFont := If( oColumn:oFontHead != Nil, oColumn:oFontHead, oBrw:oFont )
         hFont := If( ValType( hFont ) == "B", Eval( hFont, 0, nEle, oBrw ), hFont )
         hFont := If( hFont == Nil, 0, hFont:hFont )

         If Valtype( cHeading ) == "C" .and. ;
            ( nAt := At( Chr( 13 ), cHeading ) ) > 0

            nOcurs := 1
            cRest := Substr( cHeading, nAt + 2 )

            While ( nAt := At( Chr( 13 ), cRest ) ) > 0
               nOcurs++
               cRest := Substr( cRest, nAt + 2 )
            EndDo

            nHeight := SBGetHeight( oBrw:hWnd, hFont, 0 )
            nHeight *= ( nOcurs + 1 )

            If ( nHeight + 1 ) > nHHeight
               nHHeight := nHeight + 1
            EndIf

         ElseIf Valtype( cHeading ) == "C" .and. nLoWord( oBrw:aColumns[ nEle ]:nHAlign ) == DT_VERT

            nHeight := GetTextWidth( oBrw:hDC, cHeading, hFont )

            If nHeight > nHHeight
               nHHeight := nHeight
            EndIf

         EndIf

      Next

      oBrw:nHeightHead := nHHeight
   Else
      oBrw:nHeightHead := 0
   EndIf

   If oBrw:lFooting .and. lDrawFooters

      nHHeight := oBrw:nHeightFoot

      For nEle := 1 TO Len( oBrw:aColumns )

         oColumn := oBrw:aColumns[ nEle ]
         cHeading := If( Valtype( oColumn:cFooting ) == "B", Eval( oColumn:cFooting ), oColumn:cFooting )
         hFont := If( oColumn:oFontFoot != Nil, oColumn:oFontFoot:hFont, If( oBrw:oFont != Nil, oBrw:oFont:hFont, 0 ) )

         hFont := If( oColumn:oFontFoot != Nil, oColumn:oFontFoot, oBrw:oFont )
         hFont := If( ValType( hFont ) == "B", Eval( hFont, 0, nEle, oBrw ), hFont )
         hFont := If( hFont == Nil, 0, hFont:hFont )

         If Valtype( cHeading ) == "C" .and. ;
            ( nAt := At( Chr( 13 ), cHeading ) ) > 0

            nOcurs := 1
            cRest := Substr( cHeading, nAt + 2 )

            While ( nAt := At( Chr( 13 ), cRest ) ) > 0
               nOcurs++
               cRest := Substr( cRest, nAt + 2 )
            EndDo

            nHeight := SBGetHeight( oBrw:hWnd, hFont, 0 )
            nHeight *= ( nOcurs + 1 )

            If ( nHeight + 1 ) > nHHeight
               nHHeight := nHeight + 1
            EndIf

         EndIf

      Next

      oBrw:nHeightFoot := nHHeight
   Else
      oBrw:nHeightFoot := 0
   EndIf

   // Now for cells

   nHHeight := oBrw:nHeightCell

   For nEle := 1 TO Len( oBrw:aColumns )

      oColumn := oBrw:aColumns[ nEle ]
      cHeading := Eval( oColumn:bData )
      hFont := If( oColumn:oFont != Nil, oColumn:oFont, oBrw:oFont )
      hFont := If( ValType( hFont ) == "B", Eval( hFont, 1, nEle, oBrw ), hFont )
      hFont := If( hFont == Nil, 0, hFont:hFont )

      If ( Valtype( cHeading ) == "C"  .and. At( Chr( 13 ), cHeading ) > 0 ) .or. ;
         ValType( cHeading ) == "M" .or. ( oColumn:cDataType != Nil .and. oColumn:cDataType == "M" )

         Default oBrw:nMemoHV := 2
         nHeight := SBGetHeight( oBrw:hWnd, hFont, 0 )
         nHeight *= oBrw:nMemoHV
         nHeight += If( oBrw:nLineStyle != 0 .and. oBrw:nLineStyle != 2, 1, 0 )
      Else
         nHeight := SBGetHeight( oBrw:hWnd, hFont, 0 )
         nHeight += If( oBrw:nLineStyle != 0 .and. oBrw:nLineStyle != 2, 1, 0 )
      EndIf

      nHHeight := Max( nHeight, nHHeight )

   Next

   oBrw:nHeightCell := nHHeight

Return Nil

* ============================================================================
* FUNCTION TSBrowse FileRename() Version 8.0 Feb/01/2008
* ============================================================================

Static Function FileRename( oBrw, cOldName, cNewName, lErase )

   Local nRet, ;
         lNew := lIsFile( cNewName )

   Default lErase := .T.

   If ! lIsFile( cOldName )
      MsgStop( oBrw:aMsg[ 29 ] + CRLF + AllTrim( cOldName ) + oBrw:aMsg[ 30 ], oBrw:aMsg[ 28 ] )
      Return -1
   EndIf

   If lErase .and. lNew

      If FErase( Lfn2Sfn( cNewName ) ) < 0
         MsgStop( oBrw:aMsg[ 11 ] + Space( 1 ) + AllTrim( cNewName ), ;
                  oBrw:aMsg[ 28 ] + Space( 1 ) + LTrim( Str( FError() ) ) )
         Return -1
      EndIf

   ElseIf ! lErase .and. lNew
      Return -1
   EndIf

   nRet := MoveFile( cOldName, cNewName )

   If lIsFile( cOldName ) .and. lIsFile( cNewName )
      FErase( Lfn2Sfn( cOldName ) )
   EndIf

Return nRet

//--------------------------------------------------------------------------------------------------------------------//

DLL32 Static Function MoveFile( cOldName AS STRING, cNewName AS STRING ) ;
      AS LONG  PASCAL FROM "MoveFileA" LIB "kernel32.dll"

* ============================================================================
* METHOD TSBrowse:ShowToolTip() Version 8.0 Feb/01/2008
* ============================================================================

METHOD ShowToolTip( nRow, nCol, cToolTip, lSize ) CLASS TSBrowse

   Local oFont, aPos, hOldFont, aToolTip, nLenToolTip, oTemp, hWnd, nTxtHeight, ;
         nTxtWidth := 0

   Default nCol := 7, ;
           nRow := ::nTop + ::nHeightHead, ;
           cToolTip := ::cToolTip, ;
           lSize := .T.

   If ! lSize
      Return Super:ShowToolTip( nRow, nCol, cToolTip )
   EndIf

   If oToolTip == Nil

      If ValType( cToolTip ) == "B"
         cToolTip = Eval( cToolTip )
      EndIf

      DEFINE WINDOW oToolTip FROM 0, 0 TO 1, 5 ;
         STYLE nOr( WS_POPUP, WS_BORDER ) ;
         COLOR 0, RGB( 255, 255, 225 ) OF Self

         DEFINE FONT oFont NAME GetSysFont() SIZE 0, -8

         aPos := { nRow, nCol }
         aPos := ClientToScreen( ::hWnd, aPos )

         nTxtHeight := Max( 14, GetTextHeight( oToolTip:hWnd ) -2 )

         aToolTip := Array( nLenToolTip := MLCount( cToolTip, 254 ) )
         AEval( aToolTip, {|c, n| aToolTip[ n ] := Trim( MemoLine( cToolTip, 252, n ) ), ;
                nTxtWidth := Max( nTxtWidth, GetTextWidth( 0, aToolTip[ n ], oFont:hFont ) + 7 ) } )

         If aPos[ 2 ] + nTxtWidth + 3 > GetSysMetrics( 0 )
            aPos[ 2 ] = GetSysMetrics( 0 ) - nTxtWidth - 3
         EndIf

         oToolTip:Move( aPos[ 1 ], aPos[ 2 ], nTxtWidth, nTxtHeight * nLenToolTip + 3 )
         oToolTip:Show()

         If oToolTip != nil
            SetBkMode( oToolTip:GetDC(), 2 )
            SetTextColor( oToolTip:hDC, CLR_BLACK )
            hOldFont = SelectObject( oToolTip:hDC, oFont:hFont )
            AEval( aToolTip, {| c, n | TextOut( oToolTip:hDC, n * nTxtHeight - (nTxtHeight-1), 2, aToolTip[ n ] ) } )
            SelectObject( oToolTip:hDC, hOldFont )
            oToolTip:ReleaseDC()
         EndIf

         oFont:End()

      If oToolTip != Nil
         hToolTip = oToolTip:hWnd
      EndIf
   EndIf

   lToolTip = .T.

Return 0

* ============================================================================
* METHOD TSBrowse:DestroyToolTip() Version 8.0 Feb/01/2008
* ============================================================================

METHOD DestroyToolTip() CLASS TSBrowse

   lToolTip := .F.

   If oToolTip != nil
      oToolTip:End()
      oToolTip := nil
   Else
      Return Super:DestroyToolTip()
   EndIf

   hPrvWnd := 0
   hWndParent := 0

Return 0

* ============================================================================
* METHOD TSBrowse:CheckToolTip() Version 8.0 Feb/01/2008
* ============================================================================

METHOD CheckToolTip() CLASS TSBrowse

   Local hWndAct

   Default hPrvWnd := 0, ;
           lToolTip := .F.

   If ::cToolTip == nil .and. ::hWnd != hWndParent
      If ::hWnd != hToolTip
         lToolTip = .f.
      EndIf
   EndIf

   If ::cToolTip == nil
      If hPrvWnd != ::hWnd
         hPrvWnd  = ::hWnd
      EndIf
      If oToolTip != nil
         oToolTip:End()
         oToolTip = NIL
      EndIf
      If oTmr != NIL
         oTmr:End()
         oTmr = NIL
      EndIf
   Else
      If hPrvWnd != ::hWnd
         hWndParent = GetParent( ::hWnd )
         hPrvWnd    = ::hWnd
         If oToolTip != Nil
            oToolTip:End()
            oToolTip = NIL
         EndIf
         If oTmr != NIL
            oTmr:End()
            oTmr = NIL
         EndIf

         #ifdef __CLIPPER__
            If lToolTip
               ::ShowToolTip()
            Else
               hWndAct = GetActiveWindow()
               DEFINE TIMER oTmr INTERVAL ::nToolTip ;
                      ACTION ( If( GetActiveWindow() == hWndAct, ::ShowToolTip(), Nil ), oTmr:End(), oTmr := Nil )
               oTmr:hWndOwner = GetActiveWindow() // WndApp()
               ACTIVATE TIMER oTmr
            EndIf
         #else
            ::ShowToolTip()
         #endif

      EndIf
   EndIf

Return Nil
